/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************/

#ifndef _OID_H_
#define _OID_H_

// Ralink defined OIDs

#define OID_GET_SET_TOGGLE                              0x8000

#define OID_802_11_NETWORK_TYPES_SUPPORTED              0x0103
#define OID_802_11_NETWORK_TYPE_IN_USE                  0x0104
#define OID_802_11_RSSI_TRIGGER                         		0x0107
#define OID_802_11_NUMBER_OF_ANTENNAS                   0x010B
#define OID_802_11_RX_ANTENNA_SELECTED                  0x010C
#define OID_802_11_TX_ANTENNA_SELECTED                  0x010D
#define OID_802_11_SUPPORTED_RATES                      0x010E
#define OID_802_11_ADD_WEP                              	0x0112
#define OID_802_11_REMOVE_WEP                           0x0113
#define OID_802_11_DISASSOCIATE                         0x0114
#define OID_802_11_PRIVACY_FILTER                       0x0118
#define OID_802_11_ASSOCIATION_INFORMATION              0x011E
#define OID_802_11_TEST                                 		0x011F
#define RT_OID_802_11_COUNTRY_REGION                0x0507 // NEWNEW
#define OID_802_11_BSSID_LIST_SCAN                      0x0508
#define OID_802_11_SSID                                 		0x0509
#define OID_802_11_BSSID                                		0x050A
#define RT_OID_802_11_RADIO                         		0x050B // NEWNEW
#define RT_OID_802_11_PHY_MODE                      	 0x050C // NEWNEW
#define RT_OID_802_11_STA_CONFIG                    	 0x050D // NEWNEW
#define OID_802_11_DESIRED_RATES                        0x050E
#define RT_OID_802_11_PREAMBLE                      	 0x050F // NEWNEW
#define OID_802_11_WEP_STATUS                             0x0510
#define OID_802_11_AUTHENTICATION_MODE                  0x0511
#define OID_802_11_INFRASTRUCTURE_MODE                  0x0512
#define RT_OID_802_11_RESET_COUNTERS                0x0513
#define OID_802_11_RTS_THRESHOLD                        0x0514
#define OID_802_11_FRAGMENTATION_THRESHOLD              0x0515
#define OID_802_11_POWER_MODE                           0x0516
#define OID_802_11_TX_POWER_LEVEL                       0x0517
#define RT_OID_802_11_ADD_WPA                       	 0x0518
#define OID_802_11_REMOVE_KEY                           0x0519
#define OID_802_11_ADD_KEY                              0x0520
#define OID_802_11_CONFIGURATION                        0x0521
#define OID_802_11_TX_PACKET_BURST			0x522  // NEWNEW
#define	RT_OID_802_11_QUERY_NOISE_LEVEL       0x523
#define	RT_OID_802_11_EXTRA_INFO	          0x524

#define RT_OID_DEVICE_NAME                              0x0607
#define RT_OID_VERSION_INFO                             0x0608
#define OID_802_11_BSSID_LIST                           0x0609
#define OID_802_3_CURRENT_ADDRESS                       0x060A
#define OID_GEN_MEDIA_CONNECT_STATUS                    0x060B
#define RT_OID_802_11_QUERY_LINK_STATUS                       0x060C
#define OID_802_11_RSSI                                 0x060D
#define OID_802_11_STATISTICS                           0x060E
#define OID_GEN_RCV_OK                                  0x060F
#define OID_GEN_RCV_NO_BUFFER                           0x0610
#define OID_802_11_ENCRYPTION_STATUS                    OID_802_11_WEP_STATUS
#define OID_802_11_RELOAD_DEFAULTS                      0x011B

//-------------------------------------------------------------------------------------

#define RT_OID_802_11_SET_PREAMBLE			(OID_GET_SET_TOGGLE | RT_OID_802_11_PREAMBLE)
#define RT_OID_802_11_SET_PHY_MODE			(OID_GET_SET_TOGGLE | RT_OID_802_11_PHY_MODE)
#define RT_OID_802_11_SET_STA_CONFIG			(OID_GET_SET_TOGGLE | RT_OID_802_11_STA_CONFIG)

//-------------------------------------------------------------------------------------

#define RT_OID_802_11_BSSID                   (OID_GET_SET_TOGGLE | OID_802_11_BSSID)

#define RT_OID_802_11_SSID                    (OID_GET_SET_TOGGLE | OID_802_11_SSID)

#define RT_OID_802_11_INFRASTRUCTURE_MODE     (OID_GET_SET_TOGGLE | OID_802_11_INFRASTRUCTURE_MODE)

#define RT_OID_802_11_ADD_WEP                 (OID_GET_SET_TOGGLE | OID_802_11_ADD_WEP)

#define RT_OID_802_11_ADD_KEY                 (OID_GET_SET_TOGGLE | OID_802_11_ADD_KEY)

#define RT_OID_802_11_REMOVE_WEP              (OID_GET_SET_TOGGLE | OID_802_11_REMOVE_WEP)

#define RT_OID_802_11_DISASSOCIATE            (OID_GET_SET_TOGGLE | OID_802_11_DISASSOCIATE)

#define RT_OID_802_11_AUTHENTICATION_MODE     (OID_GET_SET_TOGGLE | OID_802_11_AUTHENTICATION_MODE)

#define RT_OID_802_11_PRIVACY_FILTER          (OID_GET_SET_TOGGLE | OID_802_11_PRIVACY_FILTER)

#define RT_OID_802_11_BSSID_LIST_SCAN         (OID_GET_SET_TOGGLE | OID_802_11_BSSID_LIST_SCAN)

#define RT_OID_802_11_WEP_STATUS              (OID_GET_SET_TOGGLE | OID_802_11_WEP_STATUS)

#define RT_OID_802_11_RELOAD_DEFAULTS         (OID_GET_SET_TOGGLE | OID_802_11_RELOAD_DEFAULTS)

#define RT_OID_802_11_NETWORK_TYPE_IN_USE     (OID_GET_SET_TOGGLE | OID_802_11_NETWORK_TYPE_IN_USE)

#define RT_OID_802_11_TX_POWER_LEVEL          (OID_GET_SET_TOGGLE | OID_802_11_TX_POWER_LEVEL)

#define RT_OID_802_11_RSSI_TRIGGER            (OID_GET_SET_TOGGLE | OID_802_11_RSSI_TRIGGER)

#define RT_OID_802_11_FRAGMENTATION_THRESHOLD (OID_GET_SET_TOGGLE | OID_802_11_FRAGMENTATION_THRESHOLD)

#define RT_OID_802_11_RTS_THRESHOLD           (OID_GET_SET_TOGGLE | OID_802_11_RTS_THRESHOLD)

#define RT_OID_802_11_RX_ANTENNA_SELECTED     (OID_GET_SET_TOGGLE | OID_802_11_RX_ANTENNA_SELECTED)

#define RT_OID_802_11_TX_ANTENNA_SELECTED     (OID_GET_SET_TOGGLE | OID_802_11_TX_ANTENNA_SELECTED)

#define RT_OID_802_11_SUPPORTED_RATES         (OID_GET_SET_TOGGLE | OID_802_11_SUPPORTED_RATES)

#define RT_OID_802_11_DESIRED_RATES           (OID_GET_SET_TOGGLE | OID_802_11_DESIRED_RATES)

#define RT_OID_802_11_POWER_MODE              (OID_GET_SET_TOGGLE | OID_802_11_POWER_MODE)

#define RT_OID_802_11_STATISTICS              (OID_GET_SET_TOGGLE | OID_802_11_STATISTICS)

//wpa counter measure test

#define RT_OID_802_11_QUERY_GEN_MIC_ERROR     0x0D710115

#define RT_OID_802_11_SET_GEN_MIC_ERROR       (OID_GET_SET_TOGGLE | RT_OID_802_11_QUERY_GEN_MIC_ERROR)

#define RT_OID_802_11_QUERY_TX_POWER_LEVEL_1  0x0D710118

#define RT_OID_802_11_SET_TX_POWER_LEVEL_1    (OID_GET_SET_TOGGLE | RT_OID_802_11_QUERY_TX_POWER_LEVEL_1)

#define RT_OID_802_11_QUERY_EEPROM_VERSION    0x0D710119

#define	RT_OID_802_11_QUERY_LAST_RX_RATE      0x0D71011B

#define	RT_OID_802_11_LEAP_AUTH_INFO          (OID_GET_SET_TOGGLE | 0x0D71011C)

#define	RT_OID_802_11_CCX20_INFO	          (OID_GET_SET_TOGGLE | 0x0D71011E)

#define	RT_OID_802_11_QUERY_AIRONETIP_INFO	  0x0D71011F

#define	RT_OID_802_11_SET_RF_REGISTER	      (OID_GET_SET_TOGGLE | 0x0D710120)

#define	RT_OID_802_11_SET_BBP_TUNING	      (OID_GET_SET_TOGGLE | 0x0D710121)



//Add Paul Chen for Accton

#define RT_OID_TX_POWER_LEVEL                 0xFF020010

#define RT_OID_SET_TX_POWER_LEVEL             (OID_GET_SET_TOGGLE | RT_OID_TX_POWER_LEVEL)






// Definition of extra information code
#define	GENERAL_LINK_UP			0x0			// Link is Up
#define	GENERAL_LINK_DOWN		0x1			// Link is Down
#define	HW_RADIO_OFF			0x2			// Hardware radio off
#define	SW_RADIO_OFF			0x3			// Software radio off
#define	AUTH_FAIL			0x4			// Open authentication fail
#define	AUTH_FAIL_KEYS			0x5			// Shared authentication fail
#define	ASSOC_FAIL			0x6			// Association failed
#define	EAP_MIC_FAILURE			0x7			// Deauthencation because MIC failure
#define	EAP_4WAY_TIMEOUT		0x8			// Deauthencation on 4-way handshake timeout
#define	EAP_GROUP_KEY_TIMEOUT		0x9			// Deauthencation on group key handshake timeout
#define	EAP_SUCCESS			0xa			// EAP succeed
#define	EXTRA_INFO_MAX			0xa			// EXTRA INFO MAX

#endif
