
void RaPropSheet::ProfilePage_AddPage(QTabWidget* TabWidgetRaConfig)
{
    DebugPrint("<func>RaPropSheet::ProfilePage_AddPage()==>\n");

//===============================================================================
//Profile Page
//===============================================================================
    ProfilePage_tab = new QWidget( TabWidgetRaConfig, "ProfilePage_tab" );

    ProfilePage_ButtonGroup = new QButtonGroup( ProfilePage_tab, "ProfilePage_ButtonGroup" );
    ProfilePage_ButtonGroup->setGeometry( QRect( 10, 10, 550, 410 ) ); 
    ProfilePage_ButtonGroup->setTitle("Profile List");

    ProfilePage_ListView = new QListView( ProfilePage_ButtonGroup, "ProfilePage_ListView" );
    ProfilePage_ListView->addColumn("Profile");
    ProfilePage_ListView->addColumn("SSID");
    ProfilePage_ListView->addColumn("Channel");
    ProfilePage_ListView->addColumn("Authentication");
    ProfilePage_ListView->addColumn("Encryption");
    ProfilePage_ListView->addColumn("Network Type");
    ProfilePage_ListView->setSelectionMode( QListView::Single );
    ProfilePage_ListView->setAllColumnsShowFocus( TRUE ); 
    ProfilePage_ListView->setGeometry( QRect( 8, 20, 530, 350 ) ); 

    ProfilePage_PushButton_Add = new QPushButton( ProfilePage_ButtonGroup, "ProfilePage_PushButton_Add" );
    ProfilePage_PushButton_Add->setGeometry( QRect( 8, 375, 120, 30 ) ); 
    ProfilePage_PushButton_Add->setText("&ADD");

    ProfilePage_PushButton_Delete = new QPushButton( ProfilePage_ButtonGroup, "ProfilePage_PushButton_Delete" );
    ProfilePage_PushButton_Delete->setGeometry( QRect( 145, 375, 120, 30 ) ); 
    ProfilePage_PushButton_Delete->setText("&DELETE");
    ProfilePage_PushButton_Delete->setEnabled(FALSE);

    ProfilePage_PushButton_Edit = new QPushButton( ProfilePage_ButtonGroup, "ProfilePage_PushButton_Edit" );
    ProfilePage_PushButton_Edit->setGeometry( QRect( 282, 375, 120, 30 ) ); 
    ProfilePage_PushButton_Edit->setText("&EDIT");
    ProfilePage_PushButton_Edit->setEnabled(FALSE);

    ProfilePage_PushButton_Activate = new QPushButton( ProfilePage_ButtonGroup, "ProfilePage_PushButton_Activate" );
    ProfilePage_PushButton_Activate->setGeometry( QRect( 419, 375, 120, 30 ) ); 
    ProfilePage_PushButton_Activate->setText("A&CTIVATE");
    ProfilePage_PushButton_Activate->setEnabled(FALSE);

    TabWidgetRaConfig->insertTab( ProfilePage_tab,"Profile");
    
    connect( ProfilePage_PushButton_Add, SIGNAL( clicked() ), this, SLOT( ProfilePage_OnAddProfile() ) );
    connect( ProfilePage_PushButton_Delete, SIGNAL( clicked() ), this, SLOT( ProfilePage_OnDeleteProfile() ) );
    connect( ProfilePage_PushButton_Edit, SIGNAL( clicked() ), this, SLOT( ProfilePage_OnEditProfile() ) );
    connect( ProfilePage_PushButton_Activate, SIGNAL( clicked() ), this, SLOT( ProfilePage_OnActiveProfile() ) );
    connect( ProfilePage_ListView, SIGNAL( doubleClicked(QListViewItem*) ), this, SLOT( ProfilePage_OnEditProfile() ) );

    
    DebugPrint("<func>RaPropSheet::ProfilePage_AddPage()<==\n");    
}

bool RaPropSheet::ProfilePage_OnInitDialog()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnInitDialog()==>\n");    

        
    DebugPrint("<func>RaPropSheet::ProfilePage_OnInitDialog()<==\n");     
}

void RaPropSheet::ProfilePage_OnSetActive()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnSetActive()==>\n"); 
    
    killTimer(timerId_UpdateProfileStatus);
    // Stop SiteSurvey Autoreconnect
    m_bSetBssid = FALSE;
    m_bSetSsid = FALSE;
    timerId_UpdateProfileStatus = -1;
    timerId_UpdateProfileStatus = startTimer(2000);
    
    DebugPrint("<func>RaPropSheet::ProfilePage_OnSetActive()<==\n");     
}

void RaPropSheet::ProfilePage_OnKillActive()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnKillActive()==>\n"); 
    
    DebugPrint("<func>RaPropSheet::ProfilePage_OnKillActive()<==\n");     
}

void RaPropSheet::ProfilePage_OnTimer(int nIDEvent)
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnTimer()==>\n"); 

    if(nIDEvent == timerId_Alive)
    {
        NDIS_802_11_MAC_ADDRESS        CurrentAddress;    
        if(OidQueryInformation(OID_802_3_CURRENT_ADDRESS, m_nSocketId, m_strDeviceName, &CurrentAddress, sizeof(CurrentAddress)) == -1 && errno == ENODEV) //No such device from errno.h
        {
            killTimers();
            close();
        }    
    }
    
    if(nIDEvent == timerId_UpdateProfileStatus)
    {
        ProfilePage_UpdateProfileStatus();    
    }
    
    DebugPrint("<func>RaPropSheet::ProfilePage_OnTimer()<==\n");     
}

void RaPropSheet::ProfilePage_ReadProfileFromFile()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_ReadProfileFromFile()==>\n"); 

    QListViewItem               *Item;
    PRT_PROFILE_SETTING         nowProfileSetting=NULL;
    PRT_PROFILE_SETTING         lastProfileSetting=NULL;
    RT_PROFILE_SETTING          tmpProfileSetting;
    NDIS_802_11_SSID            SsidQuery;
    NDIS_MEDIA_STATE            ConnectStatus;
    FILE                        *cfgProfileId;
    char                        strSSID[NDIS_802_11_LENGTH_SSID + 1];
    char                        cfgProfile[512];
    char                        tempstr[255];

    memset(m_strActiveProfileID, 0x00,  32+1);
    getkeystring("Default", "ProfileID", m_strActiveProfileID, 32, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

    sprintf(cfgProfile, "%s/%s", RT2500_SYSTEM_PATH, RT2500_UI_PROFILE);
    lastProfileSetting = NULL;
    if ((cfgProfileId = fopen(cfgProfile, "rb")) != NULL)
    {
        while (fread((void *)&tmpProfileSetting, sizeof(RT_PROFILE_SETTING), (unsigned) 1, cfgProfileId) != 0)
        {
            if (tmpProfileSetting.ProfileDataType != RT2500_UI_TYPE)
                break;   //not for RT2500 Utility

            if (( nowProfileSetting = (PRT_PROFILE_SETTING) malloc(sizeof(RT_PROFILE_SETTING))) == NULL)
                break;

            memcpy(nowProfileSetting, (void *)&tmpProfileSetting, sizeof(RT_PROFILE_SETTING));
            nowProfileSetting->Next=lastProfileSetting;
            lastProfileSetting = nowProfileSetting;

            Item = new QListViewItem(ProfilePage_ListView);
            if (strcmp(m_strActiveProfileID, (const char *)nowProfileSetting->Profile) == 0)
            {
                if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, m_nSocketId, m_strDeviceName, &ConnectStatus, sizeof(ConnectStatus)) >= 0)
                {
                    if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
                    {
                        memset(&SsidQuery, 0x00, sizeof(SsidQuery));
                        OidQueryInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SsidQuery, sizeof(SsidQuery));

                        memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);
                        memcpy(strSSID, SsidQuery.Ssid, SsidQuery.SsidLength);

                        if (strcmp(strSSID, (const char *)nowProfileSetting->SSID) == 0)
                            Item->setPixmap(0, uic_load_pixmap_RaPropSheet("check16.xpm"));
                        else
                            Item->setPixmap(0, uic_load_pixmap_RaPropSheet("noactive16.xpm"));
                    }
                    else
                        Item->setPixmap(0, uic_load_pixmap_RaPropSheet("noactive16.xpm"));
                }
                else
                    Item->setPixmap(0, uic_load_pixmap_RaPropSheet("noactive16.xpm"));
            }
            else
            {
                Item->setPixmap(0, uic_load_pixmap_RaPropSheet("uncheck16.xpm"));
            }

            Item->setText(0, (const char *)nowProfileSetting->Profile);
            Item->setText(1, (const char *)nowProfileSetting->SSID);

            if(nowProfileSetting->Channel != 0)
            {
                sprintf(tempstr, "%d", nowProfileSetting->Channel);
                Item->setText(2, tempstr);
            }
            else
                Item->setText(2, "Auto");

            if (nowProfileSetting->Authentication == Ndis802_11AuthModeOpen)
                Item->setText(3, "OPEN");
            else if (nowProfileSetting->Authentication == Ndis802_11AuthModeShared)
                Item->setText(3, "SHARED");
            else if (nowProfileSetting->Authentication == Ndis802_11AuthModeWPAPSK)
                Item->setText(3, "WPA-PSK");
            else if (nowProfileSetting->Authentication == Ndis802_11AuthModeWPA2PSK)
                Item->setText(3, "WPA2-PSK");
            else if (nowProfileSetting->Authentication == Ndis802_11AuthModeWPANone)
                Item->setText(3, "WPA-NONE");
            else if (nowProfileSetting->Authentication == Ndis802_11AuthModeWPA)
                Item->setText(3, "WPA");
            else if (nowProfileSetting->Authentication == Ndis802_11AuthModeWPA2)
                Item->setText(3, "WPA2");
            else 
                Item->setText(3, "unknown");

            if (nowProfileSetting->Encryption == Ndis802_11WEPEnabled)
                Item->setText(4,"WEP");
            else if (nowProfileSetting->Encryption == Ndis802_11WEPDisabled)
                Item->setText(4,"NONE");
            else if (nowProfileSetting->Encryption == Ndis802_11Encryption2Enabled)
                Item->setText(4,"TKIP");
            else if (nowProfileSetting->Encryption == Ndis802_11Encryption3Enabled)
                Item->setText(4,"AES");
            else
                Item->setText(4,"unknown");

            Item->setText(5, strAryNetworkType[nowProfileSetting->NetworkType]);
        }
        fclose(cfgProfileId);
        m_pProfileSetting = lastProfileSetting;
    }

    if (G_bUserAdmin)
    {
        if (ProfilePage_ListView->childCount() > 0)
        {
            ProfilePage_PushButton_Delete->setEnabled(TRUE);
            ProfilePage_PushButton_Edit->setEnabled(TRUE);
            ProfilePage_PushButton_Activate->setEnabled(TRUE);
        }
    }
    
    DebugPrint("<func>RaPropSheet::ProfilePage_ReadProfileFromFile()<==\n"); 
    
}

void RaPropSheet::ProfilePage_UpdateProfileStatus()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_UpdateProfileStatus()==>\n"); 

    QListViewItem                       *ListItem = NULL;
    NDIS_MEDIA_STATE                    ConnectStatus = NdisMediaStateDisconnected;
    NDIS_802_11_SSID                    SsidQuery;
    NDIS_802_11_WEP_STATUS              ProEncryp = Ndis802_11WEPDisabled, Encryp = Ndis802_11WEPDisabled;
    NDIS_802_11_AUTHENTICATION_MODE     ProAuthenType = Ndis802_11AuthModeOpen, AuthenType = Ndis802_11AuthModeOpen;
    NDIS_802_11_NETWORK_INFRASTRUCTURE  ProNetType = Ndis802_11Infrastructure, NetType = Ndis802_11Infrastructure;
    QString                             qstr;
    char                                strSSID[NDIS_802_11_LENGTH_SSID + 1];
    int                                 nItem;
    int                                 i;

    if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, m_nSocketId, m_strDeviceName, &ConnectStatus, sizeof(ConnectStatus)) < 0)
        ConnectStatus = NdisMediaStateDisconnected;

    memset(&SsidQuery, 0x00, sizeof(SsidQuery));
    memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);

    if (ConnectStatus == NdisMediaStateConnected)
    {
        if (OidQueryInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SsidQuery, sizeof(SsidQuery)) >=0 )
        {
            memcpy(strSSID, SsidQuery.Ssid, SsidQuery.SsidLength);
        }
    }

    OidQueryInformation(OID_802_11_WEP_STATUS, m_nSocketId, m_strDeviceName, &Encryp, sizeof(Encryp));
    OidQueryInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &AuthenType, sizeof(AuthenType));
    OidQueryInformation(OID_802_11_INFRASTRUCTURE_MODE, m_nSocketId, m_strDeviceName, &NetType, sizeof(NetType));

    nItem = ProfilePage_ListView->childCount();
    ListItem = ProfilePage_ListView->firstChild();
    for (i = 0; i < nItem; i++)
    {
        qstr = ListItem->text(0);
        if (qstr.compare(m_strActiveProfileID) == 0)
        {
            qstr = ListItem->text(5);
            if (qstr.compare("Infrastructure") == 0)
                ProNetType = Ndis802_11Infrastructure;
            else
                ProNetType = Ndis802_11IBSS;

            qstr = ListItem->text(3);
            if (qstr.compare("OPEN") == 0)
                ProAuthenType = Ndis802_11AuthModeOpen;
            else if (qstr.compare("SHARED") == 0)
                ProAuthenType = Ndis802_11AuthModeShared;
            else if (qstr.compare("WPA-PSK") == 0)
                ProAuthenType = Ndis802_11AuthModeWPAPSK;
            else if (qstr.compare("WPA2-PSK") == 0)
                ProAuthenType = Ndis802_11AuthModeWPA2PSK;
            else if (qstr.compare("WPA-NONE") == 0)
                ProAuthenType = Ndis802_11AuthModeWPANone;
            else if (qstr.compare("WPA") == 0)
                ProAuthenType = Ndis802_11AuthModeWPA;
            else if (qstr.compare("WPA2") == 0)
                ProAuthenType = Ndis802_11AuthModeWPA2;

            qstr = ListItem->text(4);
            if (qstr.compare("WEP") == 0)
                ProEncryp = Ndis802_11WEPEnabled;
            else if (qstr.compare("NONE") == 0)
                ProEncryp = Ndis802_11WEPDisabled;
            else if (qstr.compare("TKIP") == 0)
                ProEncryp = Ndis802_11Encryption2Enabled;
            else if (qstr.compare("AES") == 0)
                ProEncryp = Ndis802_11Encryption3Enabled;

            qstr = ListItem->text(1);
            if ( ((qstr.isEmpty()) || (qstr.compare(strSSID) == 0)) && (ConnectStatus == NdisMediaStateConnected) &&
                (ProNetType == NetType) && (ProAuthenType == AuthenType) && (ProEncryp == Encryp))
                ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("check16.xpm"));
            else
                ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("noactive16.xpm"));
        }
        else
            ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("uncheck16.xpm"));

        ListItem = ListItem->itemBelow();
    }

    if (m_bUpdateSiteSurvPage)
    {
        m_bUpdateSiteSurvPage = FALSE;
        SiteSurvPage_ProbeConnectStatus();
    }

    if (m_bUpdateLinkSatusPage)
    {
        m_bUpdateLinkSatusPage = FALSE;
//        LinkStatusPage_UpdateStatus();
    }

    DebugPrint("<func>RaPropSheet::ProfilePage_UpdateProfileStatus()<==\n"); 
        
}

void RaPropSheet::ProfilePage_WriteProfileToFile()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_WriteProfileToFile()==>\n"); 
    
    FILE                        *WriteProfileId;
    PRT_PROFILE_SETTING         ptr=NULL;
    char                        cfgProfile[512];
    char                        cmdString[256];

    if (getuid() == 0)
    {
        sprintf(cfgProfile, "%s/%s", RT2500_SYSTEM_PATH, RT2500_UI_PROFILE);
        sprintf(cmdString, " if [ ! -d %s ] ; then mkdir -p %s ; fi ", RT2500_SYSTEM_PATH, RT2500_SYSTEM_PATH);
        system(cmdString);

        if (m_pProfileSetting != NULL)
        {
            if ((WriteProfileId = fopen(cfgProfile, "wb")) != NULL)
            {
                ptr = m_pProfileSetting;
                while (ptr != NULL)
                {
                    ptr->ProfileDataType = RT2500_UI_TYPE;
                    fwrite(ptr, sizeof(RT_PROFILE_SETTING), 1, WriteProfileId);
                    ptr = ptr->Next;
                }
                fclose(WriteProfileId);
            }
        }
        else
        {
            sprintf(cmdString, "rm -f %s", cfgProfile);
            system(cmdString);
        }
    }
    
    DebugPrint("<func>RaPropSheet::ProfilePage_WriteProfileToFile()<==\n"); 
    
}

RT_802_11_STA_CONFIG                    configStation;
RT_802_11_STA_CONFIG                    configOldStation;
	
void RaPropSheet::ProfilePage_WriteConfigToRegistryAndSetOid()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_WriteConfigToRegistryAndSetOid()==>\n"); 

    QListViewItem                           *Item;
    QString                                 qstr;
    PRT_PROFILE_SETTING                     ptr=NULL;
    RT_802_11_PHY_MODE                      enumWirelessMode;
	
    NDIS_802_11_NETWORK_INFRASTRUCTURE      enumNetworkType;
    RT_802_11_PREAMBLE                      enumPreamType;
    NDIS_802_11_RTS_THRESHOLD               lRtsThre;
    NDIS_802_11_FRAGMENTATION_THRESHOLD     lFragThre;
    NDIS_802_11_AUTHENTICATION_MODE         enumAuthenType;
    NDIS_802_11_WEP_STATUS                  enumEncryp;
    NDIS_802_11_CONFIGURATION               Configuration;
    NDIS_802_11_POWER_MODE                  enumPSMode;
    NDIS_802_11_SSID                        SSID;
    NDIS_802_11_REMOVE_KEY                  removeKey;
    PNDIS_802_11_KEY                        pKey = NULL;
    NDIS_802_11_RATES                       aryRates;
    ULONG                                   nKeyLen;
    ULONG                                   lBufLen;
    ULONG                                   lFreq = 0;
    UCHAR                                   keyMaterial[40];
    char                                    strSSID[NDIS_802_11_LENGTH_SSID + 1];
    char                                    strtmp[255];
    int                                     i;
    bool                                    bSetSSID = FALSE;
    bool                                    bIsFound = FALSE;

    Item = ProfilePage_ListView->currentItem();
    qstr = Item->text(0);
    ptr = m_pProfileSetting;
    while (ptr)
    {
        if (qstr.compare((const char *)ptr->Profile) == 0)
        {
            bIsFound = TRUE;
            break;
        }
            ptr = ptr->Next;
    }

    if (bIsFound)
    {
        writekeystring("Default", "ProfileID", (char *)ptr->Profile, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
        strcpy(m_strActiveProfileID, (const char *)ptr->Profile);

        //Write to Registry
        //SSID
        writekeystring("Default", "SSID", (char *)ptr->SSID, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        if(!G_bSupportAMode && G_enumWirelessMode >= PHY_11A)
            G_enumWirelessMode = PHY_11BG_MIXED;

#if 0	// Set Phy_Mode using AdvancePage.
        // SetOidInformation
        OidQueryInformation(RT_OID_802_11_PHY_MODE, m_nSocketId, m_strDeviceName, &enumWirelessMode, sizeof(enumWirelessMode));
        if(enumWirelessMode != G_enumWirelessMode)
            OidSetInformation(RT_OID_802_11_PHY_MODE, m_nSocketId, m_strDeviceName, &G_enumWirelessMode, sizeof(G_enumWirelessMode));
#endif

        //Get AdhocOfdm mode
        if (getkeystring("Default", "AdhocOfdm",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
                m_bAdhocOfdm = atoi(strtmp);
        }
        else
            m_bAdhocOfdm = 0;

        //Get CountryRegion
        if (getkeystring("Default", "CountryRegion",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
                G_nCountryRegion = atoi(strtmp);
        }
        else
            G_nCountryRegion = 0;
	
        // Get TXBurst value
        if (getkeystring("Default", "TXBurst",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
            if (atoi(strtmp) != 0)
                m_bTXBurst = TRUE;
            else
                m_bTXBurst = FALSE;
        }
        else
            m_bTXBurst = FALSE;

        //Get TurboRate value
        if (getkeystring("Default", "TurboRate",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
            if (atoi(strtmp) != 0)
                m_bTurboRate = TRUE;
            else
                m_bTurboRate = FALSE;
        }
        else
            m_bTurboRate = FALSE;

        // Get ShortSlot value
        if (getkeystring("Default", "ShortSlot",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
            if (atoi(strtmp) != 0)
                m_bShortSlot = TRUE;
            else
                m_bShortSlot = FALSE;
        }
        else
            m_bShortSlot = FALSE;

        // Get BGProtection value
        if (getkeystring("Default", "BGProtection",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
            m_nBGProtection = atoi(strtmp);

            if ((m_nBGProtection < 0) || (m_nBGProtection >= 3))
                m_nBGProtection = 0;
        }
        m_nBGProtection = 0;

        // Get TXRate value
        if (getkeystring("Default", "TxRate",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
        {
            m_nTXRate = atoi(strtmp);
        }

        OidQueryInformation(RT_OID_802_11_STA_CONFIG, m_nSocketId, m_strDeviceName, &configOldStation, sizeof(RT_802_11_STA_CONFIG));
        configStation.EnableTurboRate = m_bTurboRate;
        configStation.EnableTxBurst = m_bTXBurst;
        configStation.UseBGProtection = m_nBGProtection;
        configStation.UseShortSlotTime = m_bShortSlot;
        configStation.AdhocMode = m_bAdhocOfdm;
        if(memcmp(&configOldStation, &configStation, sizeof(RT_802_11_STA_CONFIG)) != 0)        
            OidSetInformation(RT_OID_802_11_STA_CONFIG, m_nSocketId, m_strDeviceName, &configStation, sizeof(RT_802_11_STA_CONFIG));

        // Get CountryRegion value
       if (getkeystring("Default", "CountryRegion",  strtmp, 255, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA) == TRUE)
       {
            G_nCountryRegion = atoi(strtmp);
       }

#if 0	// Set CountryRegion using AdvancePage	   
       DebugPrint("Set RT_OID_802_11_COUNTRY_REGION\n");     
       UCHAR chCountryRegion = (UCHAR)G_nCountryRegion;
       OidSetInformation(RT_OID_802_11_COUNTRY_REGION, m_nSocketId, m_strDeviceName, &chCountryRegion, sizeof(chCountryRegion));    
#endif     

        memset(aryRates, 0x00, sizeof(NDIS_802_11_RATES));
        if (m_WirelessMode == PHY_11A)
        {
            switch (m_nTXRate)
            {
            case 0:
                aryRates[0] = 0x6c; // 54Mbps
                aryRates[1] = 0x60; // 48Mbps
                aryRates[2] = 0x48; // 36Mbps
                aryRates[3] = 0x30; // 24Mbps
                aryRates[4] = 0x24; // 18M
                aryRates[5] = 0x18; // 12M
                aryRates[6] = 0x12; // 9M
                aryRates[7] = 0x0c; // 6M
                break;
            case 1:
                aryRates[0] = 0x0c; // 6M
                break;
            case 2:
                aryRates[0] = 0x12; // 9M
                break;
            case 3:
                aryRates[0] = 0x18; // 12M
                break;
            case 4:
                aryRates[0] = 0x24; // 18M
                break;
            case 5:
                aryRates[0] = 0x30; // 24M
                break;
            case 6:
                aryRates[0] = 0x48; // 36M
                break;
            case 7:
                aryRates[0] = 0x60; // 48M
                break;
            case 8:
                aryRates[0] = 0x6c; // 54M
                break;
            }
        }
        else if ((m_WirelessMode == PHY_11BG_MIXED) || (m_WirelessMode == PHY_11B) ||
                 (m_WirelessMode == PHY_11ABG_MIXED))
        {
            switch(m_nTXRate)
            {
            case 0:
                switch(m_WirelessMode)
                {
                case PHY_11BG_MIXED: // B/G Mixed
                case PHY_11ABG_MIXED: // A/B/G Mixed
                    aryRates[0] = 0x6c; // 54Mbps
                    aryRates[1] = 0x60; // 48Mbps
                    aryRates[2] = 0x48; // 36Mbps
                    aryRates[3] = 0x30; // 24Mbps
                    aryRates[4] = 0x16; // 11Mbps
                    aryRates[5] = 0x0b; // 5.5Mbps
                    aryRates[6] = 0x04; // 2Mbps
                    aryRates[7] = 0x02; // 1Mbps
                    break;
                case PHY_11B: // B Only
                    aryRates[0] = 0x16; // 11Mbps
                    aryRates[1] = 0x0b; // 5.5Mbps
                    aryRates[2] = 0x04; // 2Mbps
                    aryRates[3] = 0x02; // 1Mbps
                    break;
                case PHY_11A:
                    break;   //Not be call, for avoid warning.
                }
                break;
            case 1:
                aryRates[0] = 0x02; // 1M
                break;
            case 2:
                aryRates[0] = 0x04; // 2M
                break;
            case 3:
                aryRates[0] = 0x0b; // 5.5M
                break;
            case 4:
                aryRates[0] = 0x16; // 11M
                break;
            case 5:
                aryRates[0] = 0x0c; // 6M
                break;
            case 6:
                aryRates[0] = 0x12; // 9M
                break;
            case 7:
                aryRates[0] = 0x18; // 12M
                break;
            case 8:
                aryRates[0] = 0x24; // 18M
                break;
            case 9:
                aryRates[0] = 0x30; // 24M
                break;
            case 10:
                aryRates[0] = 0x48; // 36M
                break;
            case 11:
                aryRates[0] = 0x60; // 48M
                break;
            case 12:
                aryRates[0] = 0x6c; // 54M
                break;
            }
        }
        OidSetInformation(OID_802_11_DESIRED_RATES, m_nSocketId, m_strDeviceName, &aryRates, sizeof(NDIS_802_11_RATES));

        OidQueryInformation(OID_802_11_INFRASTRUCTURE_MODE, m_nSocketId, m_strDeviceName, &enumNetworkType, sizeof(enumNetworkType));
        if (ptr->NetworkType != enumNetworkType)
        {
            bSetSSID = TRUE;
            OidSetInformation(OID_802_11_INFRASTRUCTURE_MODE, m_nSocketId, m_strDeviceName, &ptr->NetworkType, sizeof(ptr->NetworkType));
        }
        //Write to Registry
        if (ptr->NetworkType == Ndis802_11IBSS)
            writekeystring("Default", "NetworkType", "Adhoc", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
        else
            writekeystring("Default", "NetworkType", "Infra", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        OidQueryInformation(RT_OID_802_11_PREAMBLE, m_nSocketId, m_strDeviceName, &enumPreamType, sizeof(enumPreamType));
        if (ptr->PreamType != enumPreamType)
            OidSetInformation(RT_OID_802_11_PREAMBLE, m_nSocketId, m_strDeviceName, &ptr->PreamType, sizeof(ptr->PreamType));

        //Write to Registry
        switch (ptr->PreamType)
        {
        case Rt802_11PreambleLong:
            writekeystring("Default", "PreambleType", "Long", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Rt802_11PreambleShort:
            writekeystring("Default", "PreambleType", "Short", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Rt802_11PreambleAuto:
        default:
            writekeystring("Default", "PreambleType", "Auto", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        }

        OidQueryInformation(OID_802_11_RTS_THRESHOLD, m_nSocketId, m_strDeviceName, &lRtsThre, sizeof(lRtsThre));
        if (ptr->RTS != lRtsThre)
            OidSetInformation(OID_802_11_RTS_THRESHOLD, m_nSocketId, m_strDeviceName, &ptr->RTS, sizeof(ptr->RTS));

        //Write to Registry
        sprintf(strtmp, "%ld", ptr->RTS);
        writekeystring("Default", "RTSThreshold", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        OidQueryInformation(OID_802_11_FRAGMENTATION_THRESHOLD, m_nSocketId, m_strDeviceName, &lFragThre, sizeof(lFragThre));
        if (ptr->Fragment != lFragThre)
            OidSetInformation(OID_802_11_FRAGMENTATION_THRESHOLD, m_nSocketId, m_strDeviceName, &ptr->Fragment, sizeof(ptr->Fragment));

        //Write to Registry
        sprintf(strtmp, "%ld", ptr->Fragment);
        writekeystring("Default", "FragThreshold", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

        OidQueryInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &enumAuthenType, sizeof(enumAuthenType));
        if (ptr->Authentication != enumAuthenType)
        {
            bSetSSID = TRUE;
            OidSetInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &ptr->Authentication, sizeof(ptr->Authentication));
        }

        //Write to Registry
        switch (ptr->Authentication)
        {
        case Ndis802_11AuthModeShared:
            writekeystring("Default", "AuthMode", "SHARED", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11AuthModeWPA:
            writekeystring("Default", "AuthMode", "WPA", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11AuthModeWPA2:
            writekeystring("Default", "AuthMode", "WPA2", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11AuthModeWPAPSK:
            writekeystring("Default", "AuthMode", "WPA-PSK", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11AuthModeWPA2PSK:
            writekeystring("Default", "AuthMode", "WPA2-PSK", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11AuthModeWPANone:
            writekeystring("Default", "AuthMode", "WPA-NONE", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11AuthModeOpen:
        default:
            writekeystring("Default", "AuthMode", "OPEN", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        }

        OidQueryInformation(OID_802_11_WEP_STATUS, m_nSocketId, m_strDeviceName, &enumEncryp, sizeof(enumEncryp));
        if ( ptr->Encryption != enumEncryp)
        {
            bSetSSID = TRUE;
            OidSetInformation(OID_802_11_WEP_STATUS, m_nSocketId, m_strDeviceName, &ptr->Encryption, sizeof(ptr->Encryption));
        }

        switch (ptr->Encryption)
        {
        case Ndis802_11WEPEnabled:
            writekeystring("Default", "EncrypType", "WEP", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11Encryption2Enabled:
            writekeystring("Default", "EncrypType", "TKIP", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11Encryption3Enabled:
            writekeystring("Default", "EncrypType", "AES", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        case Ndis802_11WEPDisabled:
        default:
            writekeystring("Default", "EncrypType", "NONE", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            break;
        }

        if (ptr->Encryption == Ndis802_11WEPEnabled)
        {
            sprintf(strtmp, "%d", ptr->KeyDefaultId + 1);
            writekeystring("Default", "DefaultKeyID", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            //Key1
            if (ptr->Key1Type == 0) //hex
                writekeystring("Default", "Key1Type", "0", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            else
                writekeystring("Default", "Key1Type", "1", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            writekeystring("Default", "Key1Str", ptr->Key1, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            //Key2
            if (ptr->Key2Type == 0) //hex
                writekeystring("Default", "Key2Type", "0", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            else
                writekeystring("Default", "Key2Type", "1", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            writekeystring("Default", "Key2Str", ptr->Key2, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            //Key3
            if (ptr->Key3Type == 0) //hex
                writekeystring("Default", "Key3Type", "0", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            else
                writekeystring("Default", "Key3Type", "1", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            writekeystring("Default", "Key3Str", ptr->Key2, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            //Key4
            if (ptr->Key4Type == 0) //hex
                writekeystring("Default", "Key4Type", "0", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            else
                writekeystring("Default", "Key4Type", "1", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            writekeystring("Default", "Key4Str", ptr->Key4, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

            //----------------------------------------------------------//
            //Key 1
            //----------------------------------------------------------//
            nKeyLen = strlen(ptr->Key1);
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 0;
                for(int i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 0;
                if(ptr->KeyDefaultId == 0)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strlen(ptr->Key1) == 5)
                    memcpy(pKey->KeyMaterial, ptr->Key1, 5);
                else if(strlen(ptr->Key1) == 10)
                    AtoH(ptr->Key1, pKey->KeyMaterial, 5);
                else if(strlen(ptr->Key1) == 13)
                    memcpy(pKey->KeyMaterial, ptr->Key1, 13);
                else if(strlen(ptr->Key1) == 26)
                    AtoH(ptr->Key1, pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
            //----------------------------------------------------------//
            //Key 2
            //----------------------------------------------------------//
            nKeyLen = strlen(ptr->Key2);
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 1;
                for(int i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 1;
                if(ptr->KeyDefaultId == 1)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strlen(ptr->Key2) == 5)
                    memcpy(pKey->KeyMaterial, ptr->Key2, 5);
                else if(strlen(ptr->Key2) == 10)
                    AtoH(ptr->Key2, pKey->KeyMaterial, 5);
                else if(strlen(ptr->Key2) == 13)
                    memcpy(pKey->KeyMaterial, ptr->Key2, 13);
                else if(strlen(ptr->Key2) == 26)
                    AtoH(ptr->Key2, pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
            //----------------------------------------------------------//
            //Key 3
            //----------------------------------------------------------//
            nKeyLen = strlen(ptr->Key3);
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 2;
                for(int i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 2;
                if(ptr->KeyDefaultId == 2)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strlen(ptr->Key3) == 5)
                    memcpy(pKey->KeyMaterial, ptr->Key3, 5);
                else if(strlen(ptr->Key3) == 10)
                    AtoH(ptr->Key3, pKey->KeyMaterial, 5);
                else if(strlen(ptr->Key3) == 13)
                    memcpy(pKey->KeyMaterial, ptr->Key3, 13);
                else if(strlen(ptr->Key3) == 26)
                    AtoH(ptr->Key3, pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
            //----------------------------------------------------------//
            //Key 4
            //----------------------------------------------------------//
            nKeyLen = strlen(ptr->Key4);
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 3;
                for(int i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 3;
                if(ptr->KeyDefaultId == 3)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strlen(ptr->Key4) == 5)
                    memcpy(pKey->KeyMaterial, ptr->Key4, 5);
                else if(strlen(ptr->Key4) == 10)
                    AtoH(ptr->Key4, pKey->KeyMaterial, 5);
                else if(strlen(ptr->Key4) == 13)
                    memcpy(pKey->KeyMaterial, ptr->Key3, 13);
                else if(strlen(ptr->Key4) == 26)
                    AtoH(ptr->Key4, pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
        }
        else if (ptr->Authentication == Ndis802_11AuthModeWPA2PSK ||ptr->Authentication == Ndis802_11AuthModeWPAPSK || ptr->Authentication == Ndis802_11AuthModeWPANone)
        {
            writekeystring("Default", "WpaPsk", ptr->WpaPsk, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

            nKeyLen = 32;
            lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
            // Allocate Resouce
            pKey = (PNDIS_802_11_KEY)malloc(lBufLen); // Don't use GMEM_ZEROINIT to get random key
            pKey->Length = lBufLen;
            pKey->KeyLength = nKeyLen;
            pKey->KeyIndex = 0x80000000;

            PasswordHash(ptr->WpaPsk, ptr->SSID, ptr->SsidLen, keyMaterial);
            memcpy(pKey->KeyMaterial, keyMaterial, 32);

	     DebugPrint("RT_OID_802_11_ADD_WPA\n");
		 
            OidSetInformation(RT_OID_802_11_ADD_WPA, m_nSocketId, m_strDeviceName, pKey, pKey->Length);


				
            free(pKey);
        }

        if (ptr->NetworkType == Ndis802_11IBSS)
        {
            OidQueryInformation(OID_802_11_CONFIGURATION, m_nSocketId, m_strDeviceName, &Configuration, sizeof(Configuration));
            for(i = 0; i < G_nChanFreqCount; i++)
            {
                if(ptr->Channel == ChannelFreqTable[i].lChannel)
                {
                    lFreq = ChannelFreqTable[i].lFreq;
                    break;
                }
            }

            if(lFreq != Configuration.DSConfig)
            {
                bSetSSID = TRUE;
                Configuration.DSConfig = lFreq;

                OidSetInformation(OID_802_11_CONFIGURATION, m_nSocketId, m_strDeviceName, &Configuration, sizeof(Configuration));
            }
            //Write to Registry
            //Channel
            sprintf(strtmp, "%d", ptr->Channel);
            writekeystring("Default", "Channel", strtmp, RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            //Power Save Mode
            writekeystring("Default", "PSMode", "", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
        }
        else
        { //Infra
            OidQueryInformation(OID_802_11_POWER_MODE, m_nSocketId, m_strDeviceName, &enumPSMode, sizeof(enumPSMode));
            if (ptr->PSmode != enumPSMode)
                OidSetInformation(OID_802_11_POWER_MODE, m_nSocketId, m_strDeviceName, &ptr->PSmode, sizeof(ptr->PSmode));

            writekeystring("Default", "Channel", "0", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);

            //Power Save Mode
            switch (ptr->PSmode)
            {
            case Ndis802_11PowerModeMAX_PSP:
                writekeystring("Default", "PSMode", "MAX_PSP", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
                break;
            case Ndis802_11PowerModeFast_PSP:
                writekeystring("Default", "PSMode", "Fast_PSP", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
                break;
            case Ndis802_11PowerModeCAM:
            default:
                writekeystring("Default", "PSMode", "CAM", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            }
        }

        OidQueryInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SSID, sizeof(SSID));
        memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);
        memcpy(strSSID, SSID.Ssid, SSID.SsidLength);

        if (bSetSSID || (strcmp((const char *)ptr->SSID, strSSID) != 0))
        {
            memset(&SSID, 0x00, sizeof(NDIS_802_11_SSID));
            SSID.SsidLength = ptr->SsidLen;
            memcpy(SSID.Ssid, (const void *)ptr->SSID, ptr->SsidLen);

            OidSetInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SSID, sizeof(SSID));
        }
    }

    DebugPrint("<func>RaPropSheet::ProfilePage_WriteConfigToRegistryAndSetOid()<==\n"); 
    
}

void RaPropSheet::ProfilePage_OnAddProfile()
{

    DebugPrint("<func>RaPropSheet::ProfilePage_OnAddProfile()==>\n"); 

    AddProfileDlg                   *pAddProfileDlg;

    killTimer(timerId_UpdateProfileStatus);
    timerId_UpdateProfileStatus = -1;

    pAddProfileDlg = new AddProfileDlg(m_nSocketId, m_strDeviceName, this, "AddProfile", PROFILE_ADD, ProfilePage_ListView, &m_pProfileSetting, NULL, TRUE);
    pAddProfileDlg->exec();

    if (pAddProfileDlg->IsOk())
    {
        ProfilePage_WriteProfileToFile();

        if (ProfilePage_ListView->childCount() == 0 )
        {
            ProfilePage_PushButton_Delete->setEnabled(FALSE);
            ProfilePage_PushButton_Edit->setEnabled(FALSE);
            ProfilePage_PushButton_Activate->setEnabled(FALSE);
        }
        else
        {
            ProfilePage_PushButton_Delete->setEnabled(TRUE);
            ProfilePage_PushButton_Edit->setEnabled(TRUE);
            ProfilePage_PushButton_Activate->setEnabled(TRUE);
        }
    }
    delete pAddProfileDlg;
    timerId_UpdateProfileStatus = startTimer(2000);
    
    DebugPrint("<func>RaPropSheet::ProfilePage_OnAddProfile()<==\n"); 
    
}

void RaPropSheet::ProfilePage_OnDeleteProfile()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnDeleteProfile()==>\n"); 

    
    QListViewItem                   *Item;
    QString                         qstr;
    PRT_PROFILE_SETTING             ptr;
    PRT_PROFILE_SETTING             previous;
    int                             answer = 0;

    killTimer(timerId_UpdateProfileStatus);
    timerId_UpdateProfileStatus = -1;

    Item = ProfilePage_ListView->currentItem();
    if (Item == NULL)
    {
        timerId_UpdateProfileStatus = startTimer(2000);
        return ;  //No one selected!
    }

    qstr=Item->text(0);
    if (qstrcmp(qstr.data(), m_strActiveProfileID) == 0)
    {
        answer = QMessageBox::warning(this, "Warning", "The profile which you want to delete is in active!",
            "&Yes", "&No", QString::null, 1, 1 );
        if ( answer == 0 ) 
        { //Yes
            memset(m_strActiveProfileID, 0x00, 32+1);
            writekeystring("Default", "ProfileID", "", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
            writekeystring("Default", "SSID", "", RT2500_SYSTEM_PATH, RT2500_SYSTEM_DATA);
        }
        else
        {
            timerId_UpdateProfileStatus = startTimer(2000);
            return;  //do nothing.
        }
    }

    ptr = m_pProfileSetting;
    previous = ptr;
    while (ptr!=NULL)
    {
        if (qstr.compare((const char *)ptr->Profile) == 0)
        {
            if (ptr == m_pProfileSetting)
            {
                m_pProfileSetting = m_pProfileSetting->Next;
                free (ptr);
            }
            else
            {
                previous->Next = ptr->Next;
                free(ptr);
            }
            ProfilePage_ListView->takeItem(Item);
            break;
        }
        else
            previous = ptr;
        ptr = ptr->Next;
    }

    ProfilePage_WriteProfileToFile();

    if (G_bUserAdmin)
    {
        if (ProfilePage_ListView->childCount() == 0 )
        {
            ProfilePage_PushButton_Delete->setEnabled(FALSE);
            ProfilePage_PushButton_Edit->setEnabled(FALSE);
            ProfilePage_PushButton_Activate->setEnabled(FALSE);
        }
        else
        {
            ProfilePage_PushButton_Delete->setEnabled(TRUE);
            ProfilePage_PushButton_Edit->setEnabled(TRUE);
            ProfilePage_PushButton_Activate->setEnabled(TRUE);
        }
    }
    timerId_UpdateProfileStatus = startTimer(2000);
    
    DebugPrint("<func>RaPropSheet::ProfilePage_OnDeleteProfile()<==\n"); 
    
}

void RaPropSheet::ProfilePage_OnEditProfile()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnEditProfile()==>\n"); 

    
    AddProfileDlg                   *pAddProfileDlg;
    QListViewItem                   *Item;
    QString                         qstr;
    bool                            bChangeProfileName = FALSE;

    if (!G_bUserAdmin)
    {
        QMessageBox::information(this, "Information", "You do not have supper user's privilege!");
        return;
    }

    Item = ProfilePage_ListView->currentItem();
    if (Item == NULL)
    {
        QMessageBox::warning(this, "Warning", "Please select profile first.!");
        return;
    }

    killTimer(timerId_UpdateProfileStatus);
    timerId_UpdateProfileStatus = -1;

    qstr=Item->text(0);
    if (strcmp(qstr.data(), m_strActiveProfileID) == 0)
        bChangeProfileName = TRUE;

    pAddProfileDlg = new AddProfileDlg(m_nSocketId, m_strDeviceName, this, "AddProfile", PROFILE_EDIT, ProfilePage_ListView, &m_pProfileSetting, NULL, TRUE);
    pAddProfileDlg->exec();
    
    if (pAddProfileDlg->IsOk())
    {
        ProfilePage_WriteProfileToFile();

        if (ProfilePage_ListView->childCount() == 0 )
        {
            ProfilePage_PushButton_Delete->setEnabled(FALSE);
            ProfilePage_PushButton_Edit->setEnabled(FALSE);
            ProfilePage_PushButton_Activate->setEnabled(FALSE);
        }
        else
        {
            ProfilePage_PushButton_Delete->setEnabled(TRUE);
            ProfilePage_PushButton_Edit->setEnabled(TRUE);
            ProfilePage_PushButton_Activate->setEnabled(TRUE);
        }

        if (bChangeProfileName)
        {
            ProfilePage_WriteConfigToRegistryAndSetOid();
            killTimer(timerId_UpdateProfileStatus);
            timerId_UpdateProfileStatus = -1;
            timerId_UpdateProfileStatus = startTimer(2000);
            m_bUpdateSiteSurvPage = TRUE;
            m_bUpdateLinkSatusPage = TRUE;
        }
    }

    delete pAddProfileDlg;
    timerId_UpdateProfileStatus = startTimer(2000);

    DebugPrint("<func>RaPropSheet::ProfilePage_OnEditProfile()<==\n"); 
    
}

void RaPropSheet::ProfilePage_OnActiveProfile()
{
    DebugPrint("<func>RaPropSheet::ProfilePage_OnActiveProfile()==>\n"); 

    QListViewItem                   *Item;

    Item = ProfilePage_ListView->currentItem();
    if (Item == NULL)
    {
        QMessageBox::warning(this, "Warning", "Please select profile first.!");
        return;
    }

    ProfilePage_WriteConfigToRegistryAndSetOid();

    killTimer(timerId_UpdateProfileStatus);
    timerId_UpdateProfileStatus = -1;
    timerId_UpdateProfileStatus = startTimer(2000);
    m_bUpdateSiteSurvPage = TRUE;
    m_bUpdateLinkSatusPage = TRUE;
    
    DebugPrint("<func>RaPropSheet::ProfilePage_OnActiveProfile()<==\n");     
}

/*
BOOL RaPropSheet::ProfilePage_AddProfile(const QString &strSSID, NDIS_802_11_ENCRYPTION_STATUS enumEncryStatus, NDIS_802_11_AUTHENTICATION_MODE enumAuthMode, int nNetworkType, int nChannel)
{
	BOOL bRet = TRUE;
	CString	str;

	// Fix MFC bug, if try to EndDialog outside the stack will be break so we keep the pointer address
	CString strProfile;
	BOOL bCreate = GetNextProfileName(strProfile);
	str.LoadString(IDS_TAB_ADDPROFILE);
	m_pSheetProfile = new CProfileSheet(str);
	//m_pSheetProfile = new CProfileSheet(_T("Add Profile"));
	m_pSheetProfile->SetProfileName(strProfile, strSSID, enumEncryStatus, enumAuthMode, TRUE, nNetworkType, nChannel);
	if(m_pSheetProfile->DoModal() == IDOK)
	{
		CString strSSID, strChannel, strAuthen, strEncry, strInfraMode, str8021X;
		int nNetworkType, nAuthenType, nEncryType;

		strProfile = m_pSheetProfile->m_SysConfigPage.m_strProfile;
		
		strSSID = m_pSheetProfile->m_SysConfigPage.m_strSSID;

		strChannel = m_pSheetProfile->m_SysConfigPage.m_strChannel;

		if(m_pSheetProfile->m_AuthSecuPage.m_bLeap)
			str.LoadString(IDSAryAuthenType[8]);
		else
		{
			nAuthenType = m_pSheetProfile->m_AuthSecuPage.m_enumAuthType;
			str.LoadString(IDSAryAuthenType[nAuthenType]);
		}

		if(nAuthenType == 0 || nAuthenType == 1)// open share
		{
			if(m_pSheetProfile->m_AuthSecuPage.m_b8021X)
				str8021X.LoadString(IDS_USE8021X);
		}
		strAuthen.Format(_T("%s %s"), str, str8021X);
		//strAuthen.Format(_T("%s %s"), strAryAuthenType[nAuthenType], str8021X);

		nEncryType = m_pSheetProfile->m_AuthSecuPage.m_nEncryType;
		str.LoadString(IDSAryEncryption[nEncryType]);
		strEncry.Format(_T("%s"), str);
		//strEncry.Format(_T("%s"), strAryEncryption[nEncryType]);

		nNetworkType = m_pSheetProfile->m_SysConfigPage.m_nNetworkType;
		str.LoadString(IDSAryNetworkType[nNetworkType]);
		strInfraMode.Format(_T("%s"), str);
		//strInfraMode.Format(_T("%s"), strAryNetworkType[nNetworkType]);

		AddItem(strProfile, strSSID, strChannel, strAuthen, strEncry, strInfraMode);
		
		bRet = TRUE;
		m_ProfList.SetItemState(m_ProfList.GetItemCount() - 1, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);

		CWnd* pWnd = GetDlgItem(IDC_DEL_PROF);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_EDIT_PROF);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_ACTIVE_PROF);
		pWnd->EnableWindow(TRUE);	
	}
	else
		bRet = FALSE;

	delete m_pSheetProfile;
	m_pSheetProfile = NULL;
	
	return bRet;
}
*/
