#include "RaPropSheet.h"
#include "addprofiledlg.h"
#include "authsecudlg.h"
#include "hiddenssiddlg.h"
#include "rt_tool.h"
#include "configapi.h"
#include "DebugPrint.h"
#include "Oid.h"
#include "ids.h"
#include "StructDef.h"


#include <qvariant.h>
#include <qapplication.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qheader.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qprogressbar.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qmime.h>
#include <qdragobject.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qmessagebox.h>
#include <unistd.h>
#include <errno.h>


PAIR_CHANNEL_FREQ_ENTRY ChannelFreqTable[] = 
{
    // channel Frequency
    {1,     2412000},
    {2,     2417000},
    {3,     2422000},
    {4,     2427000},
    {5,     2432000},
    {6,     2437000},
    {7,     2442000},
    {8,     2447000},
    {9,     2452000},
    {10,    2457000},
    {11,    2462000},
    {12,    2467000},
    {13,    2472000},
    {14,    2484000},
    {34,    5170000},
    {36,    5180000},
    {38,    5190000},
    {40,    5200000},
    {42,    5210000},
    {44,    5220000},
    {46,    5230000},
    {48,    5240000},
    {52,    5260000},
    {56,    5280000},
    {60,    5300000},
    {64,    5320000},
    {100,   5500000},
    {104,   5520000},
    {108,   5540000},
    {112,   5560000},
    {116,   5580000},
    {120,   5600000},
    {124,   5620000},
    {128,   5640000},
    {132,   5660000},
    {136,   5680000},
    {140,   5700000},
    {149,   5745000},
    {153,   5765000},
    {157,   5785000},
    {161,   5805000},
};

int G_nChanFreqCount = sizeof (ChannelFreqTable) / sizeof(PAIR_CHANNEL_FREQ_ENTRY);

const char *strAryNetworkType[]=
{
    "Ad Hoc",
    "Infrastructure", 
    "Automatic"
};

const char *strAryEncryption[]=
{
    "WEP",
    "Not Use",
    "",
    "",
    "TKIP",
    "",
    "AES",
    ""
};

const char *strAryAuthenType[]=
{
    "OPEN",
    "SHARED"
    "",
    "WPA",
    "WPA-PSK",
    "WPA-NONE"
};


extern UINT             G_nCountryRegion;
bool                    G_bRadio = TRUE;
extern bool             G_bUserAdmin;
extern bool             G_bSupportAMode;

RT_802_11_PHY_MODE 	G_enumWirelessMode = PHY_11BG_MIXED; // Default use BG_Mixed

int			G_nRetryConnect = 0;
BOOL		G_bSetFromSiteSurvey = FALSE;
PPROFILE_DATA G_pSiteSurveyProfData = NULL;

//----------------------------------
// HideDlg
BOOL	G_bBssidListScan = FALSE;
BOOL	G_bMoniter = FALSE;

NDIS_802_11_AUTHENTICATION_MODE		G_enumAuthenMode = Ndis802_11AuthModeOpen;
NDIS_802_11_ENCRYPTION_STATUS		G_enumEncryStatus = Ndis802_11EncryptionDisabled;

NDIS_802_11_ENCRYPTION_STATUS G_encryCapa = Ndis802_11Encryption1Enabled;
BOOL		G_bWpaCapable = TRUE;

PNDIS_802_11_BSSID_LIST_EX G_pBssidList = NULL;

USHORT		G_sNdisVer;

// for 802.1x Setting
TCHAR			chID[128];
TCHAR			chPassword[128];
TCHAR			chTunnelID[128];
TCHAR			chTunnelPassword[128];
TCHAR			chServerName[128];


//----------------------------------
// DebugPrint
extern char DebugPrntBuf[DEBUG_PRINT_BUF_MAX_LEN];







static QPixmap uic_load_pixmap_RaPropSheet( const QString &name )
{
    const QMimeSource *m = QMimeSourceFactory::defaultFactory()->data( name );
    if ( !m )
        return QPixmap();
    QPixmap pix;
    QImageDrag::decode( m, pix );
    return pix;
}



#include "ProfilePage.cpp"
#include "LinkStatusPage.cpp"
#include "SiteSurvPage.cpp"
#include "StatisticPage.cpp"
#include "AdvancePage.cpp"
#include "AboutPage.cpp"



/* 
 *  Constructs a RaPropSheet which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 */
RaPropSheet::RaPropSheet(  int socket_id, const char *device_name, QWidget* parent,  const char* name)
    : QWidget( parent, name)
{
    //-------------------------------------------------------------
    
    DebugPrint("<func>RaPropSheet::RaPropSheet()==>\n");
    
    //-------------------------------------------------------------

    m_nSocketId = socket_id;
    m_strDeviceName = (char *)malloc(strlen(device_name)+1);
    if(m_strDeviceName)
        strcpy(m_strDeviceName, device_name);
    
    //-------------------------------------------------------------
	
    if ( !name )
        setName( "RaPropSheet" );
    resize( 600, 480 ); 
    setMinimumSize( 600, 480 ); 
    setMaximumSize( 600, 480 ); 
    setCaption("Configuration Utility - RT2570");
    setIcon( uic_load_pixmap_RaPropSheet( "RaConfig2500.xpm" ) );
    setPaletteBackgroundColor( QColor( 222, 222,  222 ) );
    qApp->setStyle("Windows");

    TabWidgetRaConfig = new QTabWidget( this, "TabWidgetRaConfig" );
    TabWidgetRaConfig->setGeometry( QRect( 10, 10, 580, 460 ) );
    setPaletteBackgroundColor( QColor( 222, 222,  222 ) );
    TabWidgetRaConfig->setPaletteBackgroundColor( QColor( 222, 222,  222 ) );    

    //-------------------------------------------------------------    
        
    ProfilePage_AddPage(TabWidgetRaConfig);
    LinkStatusPage_AddPage(TabWidgetRaConfig);
    SiteSurvPage_AddPage(TabWidgetRaConfig);
    StatisticsPage_AddPage(TabWidgetRaConfig);
    AdvancePage_AddPage(TabWidgetRaConfig);
    AboutPage_AddPage(TabWidgetRaConfig);
     
    //-------------------------------------------------------------
        
    TabWidgetRaConfig->showPage(SiteSurvPage_tab);  //Site survey.
    
    //-------------------------------------------------------------
    
    ProfilePage_OnInitDialog();
    LinkStatusPage_OnInitDialog();
    SiteSurvPage_OnInitDialog();
    StatisticsPage_OnInitDialog();
    AdvancePage_OnInitDialog();
    AboutPage_OnInitDialog();   
        
    //-------------------------------------------------------------    
    
    connect( TabWidgetRaConfig, SIGNAL( currentChanged(QWidget*) ), this, SLOT( OnPageChanged() ) );



        
    //-------------------------------------------------------------
    
    timerId_Alive = startTimer(2000); //check device driver per 2 seconds.
    timerId_ActiveScan = -1;
    timerId_ConnectStatus = -1;
    timerId_LinkStatusPage_LinkStatus = -1;
    timerId_Statistic = -1;
    timerId_UpdateProfileStatus = -1;

    //-------------------------------------------------------------
    
    HideDlg_OnInitDialog();
        
    //-------------------------------------------------------------    
    

    m_pProfileSetting = NULL;


    m_WirelessMode = PHY_11BG_MIXED;
    m_bTXBurst = FALSE;
    m_nBGProtection = 0;
    m_bShortSlot = FALSE;
    m_bTurboRate = FALSE;
    m_bAdhocOfdm = 0;
    m_nTXRate = 0;
    m_nSigQua=0;
    m_bUpdateProfilePage    = TRUE;
    m_bUpdateLinkSatusPage = TRUE;

    memset(&m_BssidSet, 0x00, sizeof(m_BssidSet));
    memset(&m_SsidSet, 0x00, sizeof(m_SsidSet));

    //-------------------------------------------------------------
    
    ProfilePage_ReadProfileFromFile();

    //-------------------------------------------------------------

        
    if (!G_bUserAdmin)
    {
        ProfilePage_PushButton_Add->setEnabled(FALSE);
        ProfilePage_PushButton_Delete->setEnabled(FALSE);
        ProfilePage_PushButton_Edit->setEnabled(FALSE);
        ProfilePage_PushButton_Activate->setEnabled(FALSE);

        AdvancePage_ComboBox_InfraWirelessMode->setEnabled( FALSE );
        AdvancePage_ComboBox_TxRate->setEnabled( FALSE );
        AdvancePage_CheckBox_UseShortSlotTime->setEnabled( FALSE );
        AdvancePage_CheckBox_UseTurboRate->setEnabled( FALSE );
        AdvancePage_ComboBox_BgProtection->setEnabled( FALSE );
        AdvancePage_ComboBox_TxRate->setEnabled( FALSE );
        AdvancePage_PushButton_RadioStatus->setEnabled( FALSE );
        AdvancePage_PushButton_Apply->setEnabled( FALSE );
    }
    //-------------------------------------------------------------    

	if(G_bWpaCapable)

		G_encryCapa = Ndis802_11Encryption3Enabled;

	else

		G_encryCapa = Ndis802_11Encryption1Enabled;

    
    //-------------------------------------------------------------    
    
    ULONG RadioStatus;

    OidQueryInformation(RT_OID_802_11_RADIO, m_nSocketId, m_strDeviceName, &RadioStatus, sizeof(RadioStatus));
    if (RadioStatus)
        G_bRadio = TRUE;
    else
        G_bRadio = FALSE;
	
    //-------------------------------------------------------------
	
    DebugPrint("<func>RaPropSheet::RaPropSheet()<==\n");
    
}

/*  
 *  Destroys the object and frees any allocated resources
 */
RaPropSheet::~RaPropSheet()
{
    // no need to delete child widgets, Qt does it all for us
}

void RaPropSheet::OnPageChanged()
{

//    killTimer(timerId_ConnectStatus);
//    timerId_ConnectStatus = -1;
//    killTimer(timerId_Statistic);
//    timerId_Statistic = -1;
//    killTimer(timerId_UpdateProfileStatus);
//    timerId_UpdateProfileStatus = -1;

    //-------------------------------------------------
    // Kill Active
    
    //Profile Page
    if(TabWidgetRaConfig->currentPageIndex() != 0)
        ProfilePage_OnKillActive();
        
    //Link Status page
    if(TabWidgetRaConfig->currentPageIndex() != 1)
        LinkStatusPage_OnKillActive();
	
    //Site Survey page
    if(TabWidgetRaConfig->currentPageIndex() != 2)
        SiteSurvPage_OnKillActive();
	
    //Statistics page
    if(TabWidgetRaConfig->currentPageIndex() != 3)
        StatisticsPage_OnKillActive();
	
    //Advance page
    if(TabWidgetRaConfig->currentPageIndex() != 4)
        AdvancePage_OnKillActive();
	
    //About page
    if(TabWidgetRaConfig->currentPageIndex() != 5)
        AboutPage_OnKillActive();
	
    //-------------------------------------------------
    // Set Active

    switch(TabWidgetRaConfig->currentPageIndex())
    {
        case 0: //Profile Page
            ProfilePage_OnSetActive();
            break;
        case 1: //Link Status page
            LinkStatusPage_OnSetActive();
            break;
        case 2: //Site Survey page
            SiteSurvPage_OnSetActive();
            break;
        case 3: //Statistics page
            StatisticsPage_OnSetActive();
            break;
        case 4: //Advance page
            AdvancePage_OnSetActive();
            break;
        case 5: //About page
            AboutPage_OnSetActive();
            break;
    }
}

void RaPropSheet::timerEvent(QTimerEvent* e)
{
    DebugPrntFormat(DebugPrntBuf, "RaPropSheet::timerEvent e->timerId() = %d\n", e->timerId());
    DebugPrint(DebugPrntBuf);

    if(e->timerId() == timerId_ActiveScan)
    {
    	DebugPrint("<flow>e->timerId() == timerId_ActiveScan\n"); 
	  
        killTimer(timerId_ActiveScan); 
	timerId_ActiveScan = -1;
	   
        HideDlg_ActionExec();
	return;
    }

    if(e->timerId() == timerId_Alive)
    {
    	DebugPrint("<flow>e->timerId() == timerId_Alive\n"); 
	
	if(m_nTimerCount_HideDlg != 0 && ((m_nTimerCount_HideDlg % 30) == 0)) // 60 seconds retry rescan
	{
		HideDlg_RescanBssidList();
		m_nTimerCount_HideDlg = 0;
	}	
	else
	{
		m_nTimerCount_HideDlg++;
	}
	
	return;
    }
        
    //Profile Page
    ProfilePage_OnTimer(e->timerId());
    
    //Link Status page
    LinkStatusPage_OnTimer(e->timerId());
    
    //Site Survey page
    SiteSurvPage_OnTimer(e->timerId());
    
    //Statistics page
    StatisticsPage_OnTimer(e->timerId());
    
    //Advance page
    AdvancePage_OnTimer(e->timerId());
    
    //About page
    AboutPage_OnTimer(e->timerId());
    
}

BOOL RaPropSheet::HideDlg_OnInitDialog()
{
    DebugPrint("<func>RaPropSheet::HideDlg_OnInitDialog()==>\n");

	// Allocate global bssid_list memory
	G_pBssidList = (PNDIS_802_11_BSSID_LIST_EX) malloc(65536); //64K
	
	HideDlg_RescanBssidList();
	
    DebugPrint("<func>RaPropSheet::HideDlg_OnInitDialog()<==\n");

	return TRUE;
}

void RaPropSheet::HideDlg_RescanBssidList()
{
    DebugPrint("<func>RaPropSheet::HideDlg_RescanBssidList()==>\n");
    
	ACTION_DATA actionData;
	actionData.enumActionType = BssidListScan;
	actionData.pActionBuffer = NULL;
	if(HideDlg_InsertAction(actionData))
		HideDlg_ActionExec();
		
    DebugPrint("<func>RaPropSheet::HideDlg_RescanBssidList()<==\n");	
}

BOOL RaPropSheet::HideDlg_InsertAction(ACTION_DATA actionData)
{
    DebugPrint("<func>RaPropSheet::HideDlg_InsertAction()==>\n");
    
	if(aryActionData.count() > 0)
	{
		BOOL bFind = FALSE;
		ACTION_DATA* pSelActionData;
		int nSize = aryActionData.count();
		
		for(int i = nSize - 1; i >= 0 ; i--)
		{
			pSelActionData = aryActionData.take(i);
			if(pSelActionData->enumActionType == BssidListScan&& 
				pSelActionData->enumActionType == actionData.enumActionType)
			{
				aryActionData.remove(i);
				i--;
			}
			else if(pSelActionData->enumActionType == Profile&& 
				pSelActionData->enumActionType == actionData.enumActionType)
			{
				if(bFind)
				{
					PPROFILE_DATA pSelProfileData = (PPROFILE_DATA)pSelActionData->pActionBuffer;
					
					if(pSelProfileData->enumAuthenMode == Ndis802_11AuthModeWPANone)
						GlobalFreePtr(pSelProfileData->pWPAKey);				
					else if(pSelProfileData->enumAuthenMode == Ndis802_11AuthModeShared || pSelProfileData->enumEncryStatus == Ndis802_11Encryption1Enabled)
					{
						if(pSelProfileData->lWEPKey1Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey1);				
						if(pSelProfileData->lWEPKey2Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey2);				
						if(pSelProfileData->lWEPKey3Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey3);				
						if(pSelProfileData->lWEPKey4Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey4);				
					}
					GlobalFreePtr(pSelProfileData);
					aryActionData.remove(i);
					i--;
				}
				else
				{					
					PPROFILE_DATA pSelProfileData = (PPROFILE_DATA)pSelActionData->pActionBuffer;
					
					if(pSelProfileData->enumAuthenMode == Ndis802_11AuthModeWPANone)
						GlobalFreePtr(pSelProfileData->pWPAKey);				
					else if(pSelProfileData->enumAuthenMode == Ndis802_11AuthModeShared || pSelProfileData->enumEncryStatus == Ndis802_11Encryption1Enabled)
					{
						if(pSelProfileData->lWEPKey1Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey1);				
						if(pSelProfileData->lWEPKey2Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey2);				
						if(pSelProfileData->lWEPKey3Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey3);				
						if(pSelProfileData->lWEPKey4Len != 0)
							GlobalFreePtr(pSelProfileData->pWEPKey4);				
					}
					GlobalFreePtr(pSelProfileData);
					pSelActionData->pActionBuffer = actionData.pActionBuffer;			
					aryActionData.replace(i, pSelActionData);

					bFind = TRUE;
				}
			}
		}
		if(!bFind)
		{
			ACTION_DATA* pItemActionData = (ACTION_DATA*) new ACTION_DATA;
			*pItemActionData = actionData;
			aryActionData.append(pItemActionData);
		}
			
	}
	else
	{
		ACTION_DATA* pItemActionData = (ACTION_DATA*) new ACTION_DATA;
		*pItemActionData = actionData;
		aryActionData.append(pItemActionData);
	}
		
	//------------------------------------------
	
	if(aryActionData.count() == 1)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
	
    DebugPrint("<func>RaPropSheet::HideDlg_InsertAction()<==\n");	
}

void RaPropSheet::HideDlg_ActionExec()
{

    DebugPrint("<func>RaPropSheet::HideDlg_ActionExec()==>\n");
    
	int i;
	
	ULONG lReturn = 0; 
	UCHAR buf[4];
	if(G_bBssidListScan == TRUE)
	{ 
		DebugPrint("<flow>G_bBssidListScan == TRUE\n");
		ULONG lBufLen = 65536; // 64k = 64 * 1024
		G_bBssidListScan = FALSE;
		OidQueryInformation(OID_802_11_BSSID_LIST, m_nSocketId, m_strDeviceName, G_pBssidList, lBufLen);
		
		
		DebugPrntFormat(DebugPrntBuf, "<flow>G_pBssidList->NumberOfItems = %d\n", G_pBssidList->NumberOfItems);
		DebugPrint(DebugPrntBuf);
    		
		ACTION_DATA* pItemActionData = aryActionData.take(0);	
		delete pItemActionData; 
		pItemActionData = NULL;
		i = 0;
		aryActionData.remove(i);
		
	}

	while(aryActionData.count() > 0)
	{
		DebugPrint("<flow>while(aryActionData.count() > 0)\n");	
		ACTION_DATA* pActionData;
		pActionData = aryActionData.take(0);
		if(pActionData->enumActionType == BssidListScan)
		{ 
			DebugPrint("OID_802_11_BSSID_LIST_SCAN\n");			
			DebugPrint("<flow>pActionData->enumActionType == BssidListScan\n");	
			OidSetInformation(OID_802_11_BSSID_LIST_SCAN, m_nSocketId, m_strDeviceName, buf, 0);
			G_bBssidListScan = TRUE;
			timerId_ActiveScan = startTimer(2100); // Driver use 2 seconds for active scan 
			break;
		}
		else if(pActionData->enumActionType == Profile)
		{	
			DebugPrint("<flow>pActionData->enumActionType == Profile\n");					
			// BUGBUG	StopAuthenticate();
			G_bMoniter = FALSE;
			// BUGBUG	AcContextConfigResumption(g_adapter, AcResumptionDisabled);
			PPROFILE_DATA pProfileData = (PPROFILE_DATA)pActionData->pActionBuffer;

			if(!pProfileData)
			{	
				delete 	pActionData; 
				pActionData = NULL;
				i = 0;
				aryActionData.remove(i);
				
				continue;
			}

			// KillTimer(3);
			if(pProfileData->bDisassociate)
				OidSetInformation(OID_802_11_DISASSOCIATE, m_nSocketId, m_strDeviceName, buf, 0);

			// Infrastrucure Mode
			OidSetInformation(OID_802_11_INFRASTRUCTURE_MODE, m_nSocketId, m_strDeviceName, &pProfileData->enumNetworkType, 4);

			if(pProfileData->enumNetworkType == Ndis802_11Infrastructure)
				pProfileData->enumPreamType = Rt802_11PreambleAuto;

			OidSetInformation(RT_OID_802_11_SET_PREAMBLE, m_nSocketId, m_strDeviceName, &pProfileData->enumPreamType, 4);
			OidSetInformation(OID_802_11_RTS_THRESHOLD, m_nSocketId, m_strDeviceName, &pProfileData->lRtsThre, 4);
			OidSetInformation(OID_802_11_FRAGMENTATION_THRESHOLD, m_nSocketId, m_strDeviceName, &pProfileData->lFragThre, 4);
			OidSetInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &pProfileData->enumAuthenMode, 4);
			OidSetInformation(OID_802_11_ENCRYPTION_STATUS, m_nSocketId, m_strDeviceName, &pProfileData->enumEncryStatus, 4);

			G_enumAuthenMode = pProfileData->enumAuthenMode;
			G_enumEncryStatus = pProfileData->enumEncryStatus;
			ULONG lTxPowerPercent = 0xffffffff; // Default AUTO
			if(pProfileData->lTxPower == 0) // AUTO
				lTxPowerPercent = 0xffffffff;
			else if(pProfileData->lTxPower == 1) // 100%
				lTxPowerPercent = 100;
			else if(pProfileData->lTxPower == 2) // 75%
				lTxPowerPercent = 75;
			else if(pProfileData->lTxPower == 3) // 50%
				lTxPowerPercent = 50;
			else if(pProfileData->lTxPower == 4) // 25%
				lTxPowerPercent = 25;
			else if(pProfileData->lTxPower == 5) // 10%
				lTxPowerPercent = 10;
			else if(pProfileData->lTxPower == 6) // Lowest 6%
				lTxPowerPercent = 6;
			OidSetInformation(RT_OID_802_11_SET_TX_POWER_LEVEL_1, m_nSocketId, m_strDeviceName, &lTxPowerPercent, 4);
			
/*
			// BUGBUG	TestContextConfigValues (g_adapter);
			
			if(G_bWpaCapable && (pProfileData->enumAuthenMode == Ndis802_11AuthModeWPA || 
				pProfileData->enumAuthenMode == Ndis802_11AuthModeWPA2 || 
				((pProfileData->enumAuthenMode == Ndis802_11AuthModeOpen || 
				pProfileData->enumAuthenMode == Ndis802_11AuthModeShared) && pProfileData->b8021X)))
			{
				G_bMoniter = TRUE;
				// Reset value
				// BUGBUG	g_ai.ai_leap = 0;
				// BUGBUG	g_ai.ai_md5 = 0;
				// BUGBUG	g_ai.ai_peap = 0;
				// BUGBUG	g_ai.ai_tls = 0;
				// BUGBUG	g_ai.ai_ttls = 0;
				if(pProfileData->enumAuthenProtocol == Peap)
					;// BUGBUG	g_ai.ai_peap = 1;
				else if(pProfileData->enumAuthenProtocol == Md5)
					;// BUGBUG	g_ai.ai_md5 = 1;
//				else if(pProfileData->enumAuthenProtocol == Leap)
//					g_ai.ai_leap = 1;
				else if(pProfileData->enumAuthenProtocol == Tls)
					;// BUGBUG	g_ai.ai_tls = 1;
				else if(pProfileData->enumAuthenProtocol == Ttls)
					;// BUGBUG	g_ai.ai_ttls = 1;
				else
					;// BUGBUG	ASSERT(FALSE);

				strcpy(chID, pProfileData->chID);
				strcpy(chTunnelID, pProfileData->chTunnelID);
				strcpy(chPassword, pProfileData->chPassword);
				strcpy(chTunnelPassword, pProfileData->chTunnelPassword);
				strcpy(chServerName, pProfileData->chServerName);
				// BUGBUG	g_ai.ai_tunnel = pProfileData->enumTunnel;
				// BUGBUG	g_ai.ai_identity = chID;
				if(pProfileData->enumAuthenProtocol == Md5) // || pProfileData->enumAuthenProtocol == Leap)
				{
					// BUGBUG	g_ai.ai_user = chID;
					// BUGBUG	g_ai.ai_password = chPassword;
				}
				else
				{
					// BUGBUG	g_ai.ai_user = chTunnelID;
					// BUGBUG	g_ai.ai_password = chTunnelPassword;
					if(pProfileData->enumAuthenProtocol == Peap && pProfileData->enumTunnel == AcTunneledGTC && pProfileData->nPasswordMode == 0)
						;// BUGBUG	PeapOneTimePassword();
					
					if(pProfileData->bClientCert)
					{
						g_ai.user_cert.blobLength = pProfileData->user_cert.blobLength;
						memcpy(g_ai.user_cert.blobData, pProfileData->user_cert.blobData, pProfileData->user_cert.blobLength);
					}
					if(pProfileData->bServerCert)
					{
						g_ai.CA_cert.blobLength = pProfileData->CA_cert.blobLength;
						memcpy(g_ai.CA_cert.blobData, pProfileData->CA_cert.blobData, pProfileData->CA_cert.blobLength);
					}
				}
				g_ai.ai_server = chServerName;

				// TLS/TTLS/Peap
				if(pProfileData->enumAuthenProtocol == Peap || pProfileData->enumAuthenProtocol == Tls || pProfileData->enumAuthenProtocol == Ttls)
				{
					AcResumptionEnum enumResumptionEnum = AcResumptionDisabled;
					if(pProfileData->nSessionResumption == 0)
						enumResumptionEnum = AcResumptionDisabled;
					else if(pProfileData->nSessionResumption == 1)
						enumResumptionEnum = AcResumptionReauthenticate;
					else if(pProfileData->nSessionResumption == 2)
						enumResumptionEnum = AcResumptionRoaming;
					else if(pProfileData->nSessionResumption == 3)
						enumResumptionEnum = AcResumptionSameSsid;
					else if(pProfileData->nSessionResumption == 4)
						enumResumptionEnum = AcResumptionAlways;

					AcContext p = AcContextConfigResumption(g_adapter, enumResumptionEnum);
					TestDumpContext ( p, _T("TestAdapterConfigResumption") );
					TestContextRelease ( p);
				}

				if(pProfileData->enumAuthenMode == Ndis802_11AuthModeWPA || pProfileData->enumAuthenMode == Ndis802_11AuthModeWPA2)
					StartAuthenticate(TRUE);
				else
					StartAuthenticate(FALSE);
			}
*/
			OidSetInformation(RT_OID_802_11_LEAP_AUTH_INFO, m_nSocketId, m_strDeviceName, &pProfileData->infoLeapAuth, sizeof(LEAP_AUTH_INFO));
			
			if(pProfileData->enumAuthenMode == Ndis802_11AuthModeWPA2PSK)
			{
				;
/*			
				G_bMoniter = TRUE;
				//OidSetInformation(RT_OID_802_11_ADD_WPA, pProfileData->pWPAKey, pProfileData->lWPAKeyLen, &lReturn);
				char Password[65];
				g_ai.ai_leap = 0;
				g_ai.ai_md5 = 0;
				g_ai.ai_peap = 0;
				g_ai.ai_tls = 0;
				g_ai.ai_ttls = 0;
				g_ai.user_cert.blobLength = 0;
				g_ai.CA_cert.blobLength = 0;
				g_ai.ai_tunnel = AcTunneledChap;

				ZeroMemory(Password, 65);
				if(pProfileData->nPskKeyLen == 64)
				{
					AtoH(pProfileData->chPskKey, (unsigned char *)Password, 32);
					StartWpaPsk(Password, pProfileData->SSID, TRUE);
				}
				else
				{
					memcpy(Password, pProfileData->chPskKey, pProfileData->nPskKeyLen);
					StartWpaPsk(Password, pProfileData->SSID);
				}
*/				
			}
			else if(pProfileData->enumAuthenMode == Ndis802_11AuthModeWPANone || pProfileData->enumAuthenMode == Ndis802_11AuthModeWPAPSK)
			{
				DebugPrint("RT_OID_802_11_ADD_KEY\n");;
				OidSetInformation(RT_OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pProfileData->pWPAKey, pProfileData->lWPAKeyLen);
				GlobalFreePtr(pProfileData->pWPAKey);				
			}
			else if(pProfileData->enumAuthenMode == Ndis802_11AuthModeShared || pProfileData->enumEncryStatus == Ndis802_11Encryption1Enabled)
			{
				NDIS_802_11_REMOVE_KEY removeKey;
				if(pProfileData->lWEPKey1Len != 0)
				{
					OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pProfileData->pWEPKey1, pProfileData->lWEPKey1Len);
					GlobalFreePtr(pProfileData->pWEPKey1);				
				}
				else
				{
					removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
					removeKey.KeyIndex = 0;
					for(int i = 0; i < 6; i++)
						removeKey.BSSID[i] = 0xff;
					OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
				}

				if(pProfileData->lWEPKey2Len != 0)
				{
					OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pProfileData->pWEPKey2, pProfileData->lWEPKey2Len);
					GlobalFreePtr(pProfileData->pWEPKey2);				
				}
				else
				{
					removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
					removeKey.KeyIndex = 1;
					for(int i = 0; i < 6; i++)
						removeKey.BSSID[i] = 0xff;
					OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
				}
			
				if(pProfileData->lWEPKey3Len != 0)
				{
					OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pProfileData->pWEPKey3, pProfileData->lWEPKey3Len);
					GlobalFreePtr(pProfileData->pWEPKey3);				
				}
				else
				{
					removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
					removeKey.KeyIndex = 2;
					for(int i = 0; i < 6; i++)
						removeKey.BSSID[i] = 0xff;
					OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
				}
			
				if(pProfileData->lWEPKey4Len != 0)
				{
					OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pProfileData->pWEPKey4, pProfileData->lWEPKey4Len);
					GlobalFreePtr(pProfileData->pWEPKey4);				
				}
				else
				{
					removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
					removeKey.KeyIndex = 3;
					for(int i = 0; i < 6; i++)
						removeKey.BSSID[i] = 0xff;
					OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
				}
			}

			if(pProfileData->enumNetworkType == Ndis802_11IBSS)
			{
				DebugPrint("Ndis802_11IBSS OID_802_11_CONFIGURATION\n");
				NDIS_802_11_CONFIGURATION Configuration;
				OidQueryInformation(OID_802_11_CONFIGURATION, m_nSocketId, m_strDeviceName, &Configuration, sizeof(NDIS_802_11_CONFIGURATION));
				Configuration.DSConfig = pProfileData->lFreq;
				OidSetInformation(OID_802_11_CONFIGURATION, m_nSocketId, m_strDeviceName, &Configuration, sizeof(NDIS_802_11_CONFIGURATION));
			}
			else
			{
				OidSetInformation(OID_802_11_POWER_MODE, m_nSocketId, m_strDeviceName, &pProfileData->enumPSMode, 4);
				if(G_sNdisVer >= NDIS_VERSION_51)
				{
					;//OidSetInformation(RT_OID_802_11_SET_AC_CAM, m_nSocketId, m_strDeviceName, &pProfileData->bACCam, 4);
				}
			}

			// Set Advance 
			if(pProfileData->bSetAdvance)
			{
				// Wireless Mode
				OidSetInformation(RT_OID_802_11_SET_PHY_MODE, m_nSocketId, m_strDeviceName, &G_enumWirelessMode, 4);
				OidSetInformation(RT_OID_802_11_SET_STA_CONFIG, m_nSocketId, m_strDeviceName, &pProfileData->configSta, sizeof(RT_802_11_STA_CONFIG));
				OidSetInformation(OID_802_11_DESIRED_RATES, m_nSocketId, m_strDeviceName, pProfileData->aryRates, sizeof(NDIS_802_11_RATES));
//				OidSetInformation(RT_OID_802_11_CCX20_INFO, m_nSocketId, m_strDeviceName, &pProfileData->infoCCX20, sizeof(CCX2_CONTROL));
			}
			if(pProfileData->bBssid)
				OidSetInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, pProfileData->BSSID, sizeof(NDIS_802_11_MAC_ADDRESS));
			else
				OidSetInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &pProfileData->SSID, sizeof(NDIS_802_11_SSID));

//			G_bWepError = FALSE;
			
			// when Infrastrature & Open & Wep, we can use packet receive to detect wep error
/*			if((pProfileData->enumAuthenMode == Ndis802_11AuthModeOpen || pProfileData->enumAuthenMode == Ndis802_11AuthModeShared) && pProfileData->enumEncryStatus == Ndis802_11Encryption1Enabled && pProfileData->enumNetworkType == Ndis802_11Infrastructure)
			{
				m_bWepErrorDetect = TRUE;

				NDIS_802_11_STATISTICS Statistics;
				ULONG lBufLen = sizeof(NDIS_802_11_STATISTICS);
				ZeroMemory(&Statistics, lBufLen);
				OidQueryInformation(OID_802_11_STATISTICS, &Statistics, lBufLen, &lReturn);
				mllTrnOk = Statistics.TransmittedFragmentCount.QuadPart;
				OidQueryInformation(OID_GEN_RCV_OK, &m_lRcvOk, 4, &lReturn);
				SetTimer(3, 10000, NULL);
			}
			else
				m_bWepErrorDetect = FALSE;
*/
			GlobalFreePtr(pProfileData);				
		}
		else if(pActionData->enumActionType == SSID)
		{
			DebugPrint("<flow>pActionData->enumActionType == SSID\n");		
//			G_bWepError = FALSE;
			PNDIS_802_11_SSID pSsid = (PNDIS_802_11_SSID)pActionData->pActionBuffer;
			OidSetInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, pSsid, sizeof(NDIS_802_11_SSID));
/*			if(m_bWepErrorDetect)
			{
				NDIS_802_11_STATISTICS Statistics;
				ULONG lBufLen = sizeof(NDIS_802_11_STATISTICS);
				ZeroMemory(&Statistics, lBufLen);
				OidQueryInformation(OID_802_11_STATISTICS, &Statistics, lBufLen, &lReturn);
				mllTrnOk = Statistics.TransmittedFragmentCount.QuadPart;
				OidQueryInformation(OID_GEN_RCV_OK, &m_lRcvOk, 4, &lReturn);
			}
*/		}
		else if(pActionData->enumActionType == BSSID)
		{
			DebugPrint("<flow>pActionData->enumActionType == BSSID\n");		
//			G_bWepError = FALSE;
//			NDIS_802_11_MAC_ADDRESS BssidSet;
//			memcpy(BssidSet, pActionData->pActionBuffer, sizeof(NDIS_802_11_MAC_ADDRESS));
//			OidSetInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, BssidSet, sizeof(NDIS_802_11_MAC_ADDRESS));

			OidSetInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, pActionData->pActionBuffer, sizeof(NDIS_802_11_MAC_ADDRESS));

/*			if(m_bWepErrorDetect)
			{
				NDIS_802_11_STATISTICS Statistics;
				ULONG lBufLen = sizeof(NDIS_802_11_STATISTICS);
				ZeroMemory(&Statistics, lBufLen);
				OidQueryInformation(OID_802_11_STATISTICS, &Statistics, lBufLen, &lReturn);
				mllTrnOk = Statistics.TransmittedFragmentCount.QuadPart;
				OidQueryInformation(OID_GEN_RCV_OK, &m_lRcvOk, 4, &lReturn);
			}
*/		}

		i = 0;
		aryActionData.remove(i);
	}
	

    DebugPrint("<func>RaPropSheet::HideDlg_ActionExec()<==\n");		
}

BOOL RaPropSheet::HideDlg_CopyProfData(PPROFILE_DATA& pDstProfData, PPROFILE_DATA pSrcProfData)
{
    DebugPrint("<func>RaPropSheet::HideDlg_CopyProfData()==>\n");

	if(pDstProfData)
	{
		DebugPrint("Delete pDstProfData\n");
	
		if(pDstProfData->enumAuthenMode == Ndis802_11AuthModeWPANone)
			GlobalFreePtr(pDstProfData->pWPAKey);		
		else if(pDstProfData->enumAuthenMode == Ndis802_11AuthModeShared ||
			pDstProfData->enumEncryStatus == Ndis802_11Encryption1Enabled)
		{
			if(pDstProfData->lWEPKey1Len != 0)
				GlobalFreePtr(pDstProfData->pWEPKey1);				

			if(pDstProfData->lWEPKey2Len != 0)
				GlobalFreePtr(pDstProfData->pWEPKey2);

			if(pDstProfData->lWEPKey3Len != 0)
				GlobalFreePtr(pDstProfData->pWEPKey3);

			if(pDstProfData->lWEPKey4Len != 0)
				GlobalFreePtr(pDstProfData->pWEPKey4);
		}
		GlobalFreePtr(pDstProfData);
		pDstProfData = NULL;
	}		

	DebugPrint("Begin New pDstProfData and copy pSrcProfData\n");	
	pDstProfData = (PPROFILE_DATA)GlobalAllocPtr(sizeof(PROFILE_DATA));
	memcpy(pDstProfData, pSrcProfData, sizeof(PROFILE_DATA));

	DebugPrint("End New pDstProfData and copy pSrcProfData\n");	

	if(pSrcProfData->enumAuthenMode == Ndis802_11AuthModeWPANone)
	{
		DebugPrint("Ndis802_11AuthModeWPANone\n");	
	
		ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + pSrcProfData->pWPAKey->KeyLength - 1);

		pDstProfData->pWPAKey = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen);
		memcpy(pDstProfData->pWPAKey, pSrcProfData->pWPAKey, lBufLen);
	}
	else if(pSrcProfData->enumAuthenMode == Ndis802_11AuthModeShared || 
		pSrcProfData->enumEncryStatus == Ndis802_11Encryption1Enabled)
	{
		DebugPrint("Ndis802_11AuthModeShared || Ndis802_11Encryption1Enabled\n");	
		
		if(pSrcProfData->lWEPKey1Len != 0)
		{
			DebugPrint("pSrcProfData->lWEPKey1Len != 0, new and copy to pDes\n");	
			DebugPrntFormat(DebugPrntBuf, "pSrcProfData->pWEPKey1->KeyLength = %d\n", pSrcProfData->pWEPKey1->KeyLength);		DebugPrint(DebugPrntBuf);			
		
			ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + pSrcProfData->pWEPKey1->KeyLength - 1);
	
			pDstProfData->pWEPKey1 = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen);
			memcpy(pDstProfData->pWEPKey1, pSrcProfData->pWEPKey1, lBufLen);
		}

		if(pSrcProfData->lWEPKey2Len != 0)
		{
			DebugPrint("pSrcProfData->lWEPKey2Len != 0, new and copy to pDes\n");	
			DebugPrntFormat(DebugPrntBuf, "pSrcProfData->pWEPKey2->KeyLength = %d\n", pSrcProfData->pWEPKey2->KeyLength);		DebugPrint(DebugPrntBuf);			
			
			ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + pSrcProfData->pWEPKey2->KeyLength - 1);
	
			pDstProfData->pWEPKey2 = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen);
			memcpy(pDstProfData->pWEPKey2, pSrcProfData->pWEPKey2, lBufLen);
		}

		if(pSrcProfData->lWEPKey3Len != 0)
		{
			DebugPrint("pSrcProfData->lWEPKey3Len != 0, new and copy to pDes\n");	
			DebugPrntFormat(DebugPrntBuf, "pSrcProfData->pWEPKey3->KeyLength = %d\n", pSrcProfData->pWEPKey3->KeyLength);		DebugPrint(DebugPrntBuf);			
			
			ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + pSrcProfData->pWEPKey3->KeyLength - 1);
	
			pDstProfData->pWEPKey3 = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen);
			memcpy(pDstProfData->pWEPKey3, pSrcProfData->pWEPKey3, lBufLen);
		}

		if(pSrcProfData->lWEPKey4Len != 0)
		{
			DebugPrint("pSrcProfData->lWEPKey4Len != 0, new and copy to pDes\n");	
			DebugPrntFormat(DebugPrntBuf, "pSrcProfData->pWEPKey4->KeyLength = %d\n", pSrcProfData->pWEPKey4->KeyLength);		DebugPrint(DebugPrntBuf);			
			
			
			ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + pSrcProfData->pWEPKey4->KeyLength - 1);
	
			pDstProfData->pWEPKey4 = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen);
			memcpy(pDstProfData->pWEPKey4, pSrcProfData->pWEPKey4, lBufLen);
		}
	}

    DebugPrint("<func>RaPropSheet::HideDlg_CopyProfData()<==\n");
	
	return TRUE;
}
