#ifndef RACONFIGUI_H
#define RACONFIGUI_H

#include <qvariant.h>
#include <qwidget.h>
#include "rt_tool.h"
#include "StructDef.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QCheckBox;
class QComboBox;
class QLabel;
class QLineEdit;
class QListView;
class QListViewItem;
class QProgressBar;
class QPushButton;
class QTabWidget;
class QWidget;
class QGroupBox;

class RaPropSheet : public QWidget
{ 
    Q_OBJECT

public:
    RaPropSheet(  int socket_id, const char *device_name, QWidget* parent = 0, const char* name = 0);
    ~RaPropSheet();

public:    
    QTabWidget*             TabWidgetRaConfig;

    QString		    m_strTemp;

    bool                    m_bTXBurst;
    int		         m_bAdhocOfdm;
    bool                    m_bShortSlot;
    bool                    m_bTurboRate;
    bool                    m_bUpdateSiteSurvPage;
    bool                    m_bUpdateProfilePage;
    bool                    m_bUpdateLinkSatusPage;

    int                     m_nSocketId;    

    int                     m_nBGProtection;
    int                     m_nTXRate;
    int                     m_nWirelessMode;
    
    char                    *m_strDeviceName;
 

    
    int                     timerId_Alive;
    int			    timerId_ActiveScan;
    int                     timerId_ConnectStatus;
    int                     timerId_LinkStatusPage_LinkStatus;
    int                     timerId_Statistic;
    int                     timerId_UpdateProfileStatus;

    char                    m_strActiveProfileID[32+1];


    PRT_PROFILE_SETTING             m_pProfileSetting;
    RT_802_11_PHY_MODE              m_WirelessMode;

public:
#include <qptrlist.h>
    QPtrList<ACTION_DATA> aryActionData;
    
    int  m_nTimerCount_HideDlg;        
    BOOL HideDlg_OnInitDialog(); 
    void HideDlg_RescanBssidList();
    BOOL HideDlg_InsertAction(ACTION_DATA actionData);
    void HideDlg_ActionExec();
    BOOL HideDlg_CopyProfData(PPROFILE_DATA& pDstProfData, PPROFILE_DATA pSrcProfData);

public:    
    #include "ProfilePage.h"
    #include "LinkStatusPage.h"
    #include "SiteSurvPage.h"
    #include "StatisticPage.h"
    #include "AdvancePage.h"
    #include "AboutPage.h"

public slots: //--- RaPropSheet ---
    virtual void Do_NotThing() { };
    virtual void OnPageChanged();
    virtual void timerEvent(QTimerEvent* e);
    
public slots: //--- ProfilePage ---
    virtual void ProfilePage_OnAddProfile();
    virtual void ProfilePage_OnDeleteProfile();
    virtual void ProfilePage_OnEditProfile();
    virtual void ProfilePage_OnActiveProfile();    

public slots: //--- SiteSurvPage ---      
    virtual void SiteSurvPage_OnRescan();
    virtual void SiteSurvPage_OnConnect();
    virtual void SiteSurvPage_OnAddToProfile();  
    virtual void SiteSurvPage_OnSelectChange();    

public slots: //--- AdvancePage ---
    virtual void AdvancePage_OnRadio();
    virtual void AdvancePage_OnApply();
    virtual void AdvancePage_OnSelchangeInfraWirelessMode(int index);    
    virtual void AdvancePage_OnSelchangeAdhocWirelessMode(int index);    
    virtual void AdvancePage_OnSelchangeCountryRegion(int index);    	
	
public slots: //--- StatisticPage ---
    virtual void StatisticsPage_OnResetCounters();    
	
};

#endif // RACONFIGUI_H

