
void RaPropSheet::SiteSurvPage_AddPage(QTabWidget* TabWidgetRaConfig)
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_AddPage()==>\n");

//===============================================================================
//Site Survey Page
//===============================================================================
    SiteSurvPage_tab = new QWidget( TabWidgetRaConfig, "SiteSurvPage_tab" );

    SiteSurvPage_ButtonGroup = new QButtonGroup( SiteSurvPage_tab, "SiteSurvPage_ButtonGroup" );
    SiteSurvPage_ButtonGroup->setGeometry( QRect( 10, 10, 550, 410 ) ); 
    SiteSurvPage_ButtonGroup->setTitle("");

    SiteSurvPage_ListView = new QListView( SiteSurvPage_ButtonGroup, "SiteSurvPage_ListView" );
    SiteSurvPage_ListView->addColumn("SSID");
    SiteSurvPage_ListView->addColumn("BSSID");
    SiteSurvPage_ListView->addColumn("Signal");
    SiteSurvPage_ListView->addColumn("Channel");
    SiteSurvPage_ListView->addColumn("Encryption");
    SiteSurvPage_ListView->addColumn("Authentication");
    SiteSurvPage_ListView->addColumn("Network Type");
    SiteSurvPage_ListView->setSelectionMode( QListView::Single );
    SiteSurvPage_ListView->setAllColumnsShowFocus( TRUE ); 
    SiteSurvPage_ListView->setGeometry( QRect( 8, 20, 530, 350 ) ); 

    SiteSurvPage_LineEdit_Status = new QLineEdit( SiteSurvPage_ButtonGroup, "SiteSurvPage_LineEdit_Status" );
    SiteSurvPage_LineEdit_Status->setEnabled( FALSE );
    SiteSurvPage_LineEdit_Status->setGeometry( QRect( 8, 375, 220, 30 ) ); 

    SiteSurvPage_PushButton_Rescan = new QPushButton( SiteSurvPage_ButtonGroup, "SiteSurvPage_PushButton_Rescan" );
    SiteSurvPage_PushButton_Rescan->setGeometry( QRect( 232, 375, 100, 30 ) ); 
    SiteSurvPage_PushButton_Rescan->setText("&RESCAN");

    SiteSurvPage_PushButton_Connect = new QPushButton( SiteSurvPage_ButtonGroup, "SiteSurvPage_PushButton_Connect" );
    SiteSurvPage_PushButton_Connect->setGeometry( QRect( 336, 375, 100, 30 ) ); 
    SiteSurvPage_PushButton_Connect->setText("&CONNECT");
    SiteSurvPage_PushButton_Connect->setEnabled( FALSE );

    SiteSurvPage_PushButton_AddProfile = new QPushButton( SiteSurvPage_ButtonGroup, "SiteSurvPage_PushButton_AddProfile" );
    SiteSurvPage_PushButton_AddProfile->setGeometry( QRect( 440, 375, 100, 30 ) ); 
    SiteSurvPage_PushButton_AddProfile->setText("&ADD PROFILE");
    SiteSurvPage_PushButton_AddProfile->setEnabled( FALSE );

    TabWidgetRaConfig->insertTab( SiteSurvPage_tab,"Site Survey");
    
    connect( SiteSurvPage_PushButton_Rescan, SIGNAL( clicked() ), this, SLOT( SiteSurvPage_OnRescan() ) );
    connect( SiteSurvPage_PushButton_Connect, SIGNAL( clicked() ), this, SLOT( SiteSurvPage_OnConnect() ) );
    connect( SiteSurvPage_PushButton_AddProfile, SIGNAL( clicked() ), this, SLOT( SiteSurvPage_OnAddToProfile() ) );
    connect( SiteSurvPage_ListView, SIGNAL( doubleClicked(QListViewItem*) ), this, SLOT( SiteSurvPage_OnConnect() ) );
    connect( SiteSurvPage_ListView, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( SiteSurvPage_OnSelectChange() ) );    
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_AddPage()<==\n");
    
}

bool RaPropSheet::SiteSurvPage_OnInitDialog()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnInitDialog()==>\n");

	m_bSetSsid = FALSE;
	m_bSetBssid = FALSE;
	m_bRescan = FALSE;
	m_nTimerCount_SiteSurvPage = 0;
	m_bUpdateSiteSurvPage = TRUE;

		
/*
	// auto retry root ssid in registry
	CRaPropSheet* pRaPropSheet = (CRaPropSheet*)GetParent();
	if(!(pRaPropSheet && pRaPropSheet->m_ProfilePage && !pRaPropSheet->m_ProfilePage.m_strProfile.IsEmpty()))
	{
		HKEY hKeyRoot;
		CHAR buf[128];
		DWORD dwSize;                         // size of subkey buffer
		DWORD dwType;                         // value type
		TCHAR Data[128];
		CString strSSID;
		
		if (ERROR_SUCCESS !=                            // Open the services key
		RegOpenKeyEx(
		HKEY_LOCAL_MACHINE,                     // handle of open key
		(LPCTSTR)G_strRegDevClassNic,           // address of name of subkey to open
		0,                                      // must be 0
		KEY_READ,                               // access mode
		&hKeyRoot))        // address of handle of open key
		{
			sprintf(buf, _T("RegOpenKeyEx '%hs' failed\n"), G_strRegDevClassNic);
			TRACE(buf);
		}
		else
		{
			dwSize = sizeof(Data);              
			ZeroMemory(Data, dwSize);
			if (ERROR_SUCCESS !=    // Read NetCfgInstanceId value
			RegQueryValueEx(
			hKeyRoot,                // handle of key to query
			REGSTR_PROFILE_SSID,        // address of name of value to query
			0,                          // reserved
			&dwType,                    // address of buffer for value type
			(UCHAR*)Data,               // address of data buffer
			&dwSize))                   // address of data buffer size
			{
			sprintf(buf, _T("RegQueryValueEx 'REGSTR_PROFILE_SSID' failed\n"));
			TRACE(buf);
		}
		else
		{
			strSSID = Data;
			m_bSetSsid = TRUE;
			m_bSetBssid = FALSE;
			m_SsidSet.SsidLength = strSSID.GetLength();
			memcpy(m_SsidSet.Ssid, LPCTSTR(strSSID), m_SsidSet.SsidLength);
			}
			RegCloseKey(hKeyRoot);
		}
	}
*/	
	// trigger m_SiteList refresh
	m_bRescan = TRUE;
	SiteSurvPage_ButtonShowHide();

	
	m_strTemp.sprintf(IDS_SITESUR_RESCAN);
	SiteSurvPage_PushButton_Rescan->setText(m_strTemp);
	
	m_strTemp.sprintf(IDS_SITESUR_CONNECT);
	SiteSurvPage_PushButton_Connect->setText(m_strTemp);
	
	m_strTemp.sprintf(IDS_SITESUR_ADDPRO);
	SiteSurvPage_PushButton_AddProfile->setText(m_strTemp);
			
	m_pBssidList = (PNDIS_802_11_BSSID_LIST_EX) malloc(65536);  //64k
     
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnInitDialog()<==\n");
	
    return TRUE;
}

void RaPropSheet::SiteSurvPage_OnSetActive()
{   
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnSetActive()==>\n");

    // Start timerId_ConnectStatus timer
    if(timerId_ConnectStatus == -1)
    {
        timerId_ConnectStatus = startTimer(2000);
    }    
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnSetActive()<==\n");    
}

void RaPropSheet::SiteSurvPage_OnKillActive()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnKillActive()==>\n");

    // Kill timerId_ConnectStatus timer
    if(timerId_ConnectStatus != -1)
    {
        killTimer(timerId_ConnectStatus);
        timerId_ConnectStatus = -1;
    }

    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnKillActive()<==\n");
}

void RaPropSheet::SiteSurvPage_OnTimer(int nIDEvent)
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnTimer()==>\n");
    
    if(nIDEvent == timerId_ConnectStatus)
    {
        SiteSurvPage_ProbeConnectStatus();
        SiteSurvPage_ButtonShowHide();
    }
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnTimer()<==\n");    
}

void RaPropSheet::SiteSurvPage_ProbeConnectStatus()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_ProbeConnectStatus()==>\n");
    
	QString str;
	if(m_bRescan)
	{
	        DebugPrint("<xxx>m_bRescan\n");
	
		if(!G_bBssidListScan)
		{
	        	DebugPrint("<xxx>! G_bBssidListScan\n");
			SiteSurvPage_RescanTimeFunc();
			m_bRescan = FALSE;
		}
		else
		{
	        	DebugPrint("<xxx>G_bBssidListScan, then return\n");		
			return;
		}
	}
	
	DebugPrint("<xxx>! m_bRescan\n");
	
	
//	if(G_nZeroConfig == 2)
//	{
//		m_bSetSsid = FALSE;
//		m_bSetBssid = FALSE;
//	}
	

	ULONG lReturn = 0;
	int nActiveItem = -1;
	
	NDIS_MEDIA_STATE ConnectStatus;
	ZeroMemory(&ConnectStatus, 4);
	OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, m_nSocketId, m_strDeviceName, &ConnectStatus, 4);
	
	if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
	{
		DebugPrint("<flow>ConnectStatus == NdisMediaStateConnected && G_bRadio\n");
	
		m_nTimerCount_SiteSurvPage = -1;
		// Prepare to rescan
		m_bRescan = TRUE;
		NDIS_802_11_MAC_ADDRESS BssidQuery;
		ZeroMemory(BssidQuery, 6);
		OidQueryInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, BssidQuery, 6);
		
		DebugPrint("<flow> Query OID_802_11_BSSID Completed\n");
					
		NDIS_802_11_SSID SsidQuery;
		ZeroMemory(&SsidQuery, 36);
		OidQueryInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SsidQuery, 36);
		
		DebugPrint("<flow> Query OID_802_11_SSID Completed\n");
				
		// if Site Survey connect success then don't auto reconnect
		if(m_bSetSsid)
		{
			DebugPrint("<flow> m_bSetSsid\n");
		
			// not Hidden SSID
			if(SsidQuery.SsidLength != 0 && m_SsidSet.SsidLength != 0 && memcmp(&SsidQuery, &m_SsidSet, 36) != 0)
			{
				ACTION_DATA actionData;
				actionData.enumActionType = SSID;
				actionData.pActionBuffer = &m_SsidSet;
				
				if(HideDlg_InsertAction(actionData))
					HideDlg_ActionExec();
			}
		}
		// if Site Survey connect success then don't auto reconnect
		else if(m_bSetBssid)
		{
			DebugPrint("<flow> m_bSetBssid\n");
					
			if(memcmp(BssidQuery, m_BssidSet, 6) != 0)
			{
				ACTION_DATA actionData;
				actionData.enumActionType = BSSID;
				actionData.pActionBuffer = &m_BssidSet;
				
				if(HideDlg_InsertAction(actionData))
					HideDlg_ActionExec();
			}
		}
		
		QString strConnectStatus;
		QString str, strWepError; 
		QString strSSID;
	
		str.sprintf(IDS_CONNECTED);
		
		*((char*)SsidQuery.Ssid + SsidQuery.SsidLength) = 0;
		strSSID.sprintf("%s", SsidQuery.Ssid);
	
		{
			strWepError.sprintf("");
	
			strConnectStatus.sprintf("%s <--> %s", str.data(), strSSID.data());
		}
		
		DebugPrint("<flow> Fill strConnectStatus Complete\n");
		
				
    		QListViewItem*           ListItem;	
		//strConnectStatus.Format(_T("Connected <--> %s"), strSSID);
		int nCount = SiteSurvPage_ListView->childCount();
    		ListItem = SiteSurvPage_ListView->firstChild();
    		
		for(int i = 0; i < nCount; i++)
		{
			DebugPrint("<flow> SiteSurvPage_ListView->takeItem\n");
			
			NDIS_802_11_MAC_ADDRESS Bssid;
			QString strBssid = ListItem->text(1); //m_SiteList.GetItemText(i, 1);
			
			DebugPrint("<flow> - Removed Begin\n");
						
			// Filter '-'
			strBssid.remove('-');
			
			//int nFind = strBssid.find('-');
			//while(nFind != -1)
			//{
			//	strBssid.remove(nFind);
			//	nFind = strBssid.find('-');
			//}
		
			DebugPrint("<flow> - Removed Completed\n");
			
			AtoH((char*)strBssid.data(), Bssid, 6);
			
			DebugPrint("<flow> AtoH Completed\n");
						
			// if found, don't Rescan
			if(memcmp(BssidQuery, Bssid, 6) == 0)
			{
				DebugPrint("<flow> found Bssid, don't Rescan\n");
				
				nActiveItem = i;
				m_bRescan = FALSE;
				break;
			}
			
			ListItem = ListItem->itemBelow();
		}
		
		if(m_bRescan)
		{
			static UCHAR Count_FiveTimeRealRescan = 0;

			if(Count_FiveTimeRealRescan >= 5)
			{
				HideDlg_RescanBssidList(); // Can't find matched SSID or BSSID 5 times, then rescan. (10 seconds)
				Count_FiveTimeRealRescan = 0;
			}
			else
			{
				Count_FiveTimeRealRescan++;				
			}
		}
		
		DebugPrint("<flow> SiteSurvPage_LineEdit_Status->setText(strConnectStatus)\n");
		
		SiteSurvPage_LineEdit_Status->setText(strConnectStatus);
	}
	else
	{
		DebugPrint("<flow>! ConnectStatus == NdisMediaStateConnected && G_bRadio\n");
	
		if(G_bRadio)
		{   
			DebugPrint("<flow> G_bRadio\n");
			
			SiteSurvPage_LineEdit_Status->setText(IDS_DISCONNECTED);
					
			//pWnd->SetWindowText(_T("Disconnected"));
			if(m_nTimerCount_SiteSurvPage == -1) // each time disconnect then rescan
			{
				m_bRescan = TRUE;
				HideDlg_RescanBssidList();
			}
			else if(m_nTimerCount_SiteSurvPage != 0)
			{
				if((m_nTimerCount_SiteSurvPage % 30) == 0) // each 60 seconds rescan
				{
					m_bRescan = TRUE;
					HideDlg_RescanBssidList();
				}
				else if((m_nTimerCount_SiteSurvPage % 5) == 0) // each 10 seconds try autoconnect
				{
					// if Site Survey connect failed then try reconnect
					if(m_bSetBssid)
					{
						ACTION_DATA actionData;
						actionData.enumActionType = BSSID;
						actionData.pActionBuffer = &m_BssidSet;
						
						if(HideDlg_InsertAction(actionData))
							HideDlg_ActionExec();
							
						if(m_nTimerCount_SiteSurvPage >= 5)
						{
							m_bSetBssid = FALSE;
							m_bSetSsid = TRUE;
						}
					}
			}
		}
		m_nTimerCount_SiteSurvPage++;
		}
		else
		{
			DebugPrint("<flow>! G_bRadio\n");		
			SiteSurvPage_LineEdit_Status->setText(IDS_RADIOOFF);
		}
	}
	
	SiteSurvPage_UpdateConnectStatus(nActiveItem, ConnectStatus);


/*
    NDIS_MEDIA_STATE            ConnectStatus = NdisMediaStateDisconnected;
    NDIS_802_11_SSID            SsidQuery;
    NDIS_802_11_MAC_ADDRESS     BssidQuery;
    char                        strSSID[NDIS_802_11_LENGTH_SSID + 1];
    char                        msg[255];

    if (m_bRescan)
    {

        SiteSurvPage_RescanTimeFunc();
	
        m_bRescan = FALSE;
	
    }

	
    if (OidQueryInformation(OID_GEN_MEDIA_CONNECT_STATUS, m_nSocketId, m_strDeviceName, &ConnectStatus, sizeof(ConnectStatus)) >= 0)
    {
        if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
        {
            m_nTimerCount_SiteSurvPage = 0;
            m_bRescan = TRUE;        

            memset(&SsidQuery, 0x00, sizeof(SsidQuery));
            OidQueryInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &SsidQuery, sizeof(SsidQuery));        

            if (SsidQuery.SsidLength == 0)
            {
                memset(&BssidQuery, 0x00, sizeof(BssidQuery));
                OidQueryInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, &BssidQuery, sizeof(BssidQuery));
                sprintf(msg, "Connected <--> [%02X:%02X:%02X:%02X:%02X:%02X]", 
                                            BssidQuery[0], BssidQuery[1], BssidQuery[2], 
                                            BssidQuery[3], BssidQuery[4], BssidQuery[5]);
            }
            else
            {
                memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);
                memcpy(strSSID, SsidQuery.Ssid, SsidQuery.SsidLength);
                sprintf(msg, "Connected <--> %s", strSSID);
            }

            SiteSurvPage_LineEdit_Status->setText(msg);
        }
        else
        {
            if (G_bRadio)
            {
                if (m_nTimerCount_SiteSurvPage == 1)
                    m_bRescan = TRUE;
                if ((m_nTimerCount_SiteSurvPage % 30) == 0)
                    OidSetInformation(OID_802_11_BSSID_LIST_SCAN, m_nSocketId, m_strDeviceName, 0, 0);
                else
                {
                    SiteSurvPage_LineEdit_Status->setText("Disconnected");
                    // if Site Survey connect failed then try reconnect
                    if (m_bSetSsid)
                        OidSetInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &m_SsidSet, sizeof(m_SsidSet));        
                    else if (m_bSetBssid)
                    {
                        OidSetInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, &m_BssidSet, sizeof(m_BssidSet));        
                        if(m_nTimerCount_SiteSurvPage >= 5)
                        {
                            m_bSetBssid = FALSE;
                            m_bSetSsid = TRUE;
                        }
                    }
                }
                m_nTimerCount_SiteSurvPage++;
            }
            else
                SiteSurvPage_LineEdit_Status->setText("Radio Status <--> OFF");
        }
    }
    else
        SiteSurvPage_LineEdit_Status->setText("Disconnected");


    SiteSurvPage_UpdateConnectStatus(ConnectStatus);
    
*/    

    DebugPrint("<func>RaPropSheet::SiteSurvPage_ProbeConnectStatus()<==\n");

}

void RaPropSheet::SiteSurvPage_OnRescan()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnRescan()==>\n");


    SiteSurvPage_PushButton_Rescan->setEnabled( FALSE );
    SiteSurvPage_PushButton_Connect->setEnabled( FALSE );
    SiteSurvPage_PushButton_AddProfile->setEnabled( FALSE );	
    SiteSurvPage_LineEdit_Status->setText(IDS_RESCANNING);    
    
    HideDlg_RescanBssidList();
    m_bRescan = TRUE;
	    
#if 0    
    killTimer(timerId_ConnectStatus);
    timerId_ConnectStatus = -1;

    SiteSurvPage_LineEdit_Status->setText("Rescanning");

    SiteSurvPage_PushButton_Rescan->setEnabled(FALSE);
    SiteSurvPage_PushButton_Connect->setEnabled(FALSE);
    SiteSurvPage_PushButton_AddProfile->setEnabled(FALSE);

    OidSetInformation(OID_802_11_BSSID_LIST_SCAN, m_nSocketId, m_strDeviceName, 0, 0);    
    timerId_ConnectStatus = startTimer(2000);
    m_bRescan = TRUE;
#endif
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnRescan()<==\n");    
}

void RaPropSheet::SiteSurvPage_RescanTimeFunc()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_RescanTimeFunc()==>\n");
   
    	ULONG lBufLen = 65536; // 64k = 64 * 1024
	
    	SiteSurvPage_ListView->clear();
	
	QString	str;
	if(!G_pBssidList)
	{
		// Clean Memory
		ZeroMemory(m_pBssidList, lBufLen);
		DebugPrint("<flow>ZeroMemory(m_pBssidList, lBufLen)\n");
		
	}
	else
	{
		memcpy(m_pBssidList, G_pBssidList, lBufLen);	
		DebugPrint("<flow>memcpy(m_pBssidList, G_pBssidList, lBufLen)\n");		
	}

	PNDIS_WLAN_BSSID_EX pBssid = m_pBssidList->Bssid;    
	
	// Set item content
	for(ULONG i = 0; i < m_pBssidList->NumberOfItems; i++)
	{
		DebugPrint("<flow>Set item content\n");		
	
		QString strSSID = (char*)pBssid->Ssid.Ssid;
		strSSID = strSSID.left(pBssid->Ssid.SsidLength);

		QString strBssid;
		strBssid.sprintf("%02X-%02X-%02X-%02X-%02X-%02X", pBssid->MacAddress[0], pBssid->MacAddress[1], pBssid->MacAddress[2],
			pBssid->MacAddress[3], pBssid->MacAddress[4], pBssid->MacAddress[5]);

		UINT nSigQua = ConvertRssiToSignalQuality(pBssid->Rssi);
		QString strRSSI;
		strRSSI.sprintf("%d%%", nSigQua);
		
		int nChannel = -1;

		for(int j = 0; j < G_nChanFreqCount; j++)
		{
			if(pBssid->Configuration.DSConfig == ChannelFreqTable[j].lFreq)
			{
				nChannel = ChannelFreqTable[j].lChannel;
				break;
			}
		}

		if(nChannel == -1)
			continue;//ASSERT(FALSE);

		QString strChannel;
		strChannel.sprintf("%u", nChannel);

		
    		QListViewItem           *ListItem;	
			
		// Insert the item, select every other item.  
		DebugPrint("<flow>new QListViewItem(SiteSurvPage_ListView)\n");	      
		
		ListItem=new QListViewItem(SiteSurvPage_ListView);
		//if(i>=7)
		// Set subitem 0
		ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("uncheck16.xpm"));
		ListItem->setText(0, strSSID);
		// Set subitem 1
		ListItem->setText(1, strBssid);
		// Set subitem 2
		ListItem->setText(2, strRSSI);
		// Set subitem 3
		ListItem->setText(3, strChannel);
		// Set subitem 4
		if (pBssid->Privacy)
		ListItem->setText(4, strAryEncryption[0]);
		else
		ListItem->setText(4, strAryEncryption[1]);
		// Set subitem 5
		ListItem->setText(5, "Unknown");
		// Set subitem 6        
		ListItem->setText(6, strAryNetworkType[pBssid->InfrastructureMode]);
		

		// work with NDIS_WLAN_BSSID_EX
		BOOL bTKIP = FALSE;
		BOOL bAESWRAP = FALSE;
		BOOL bAESCCMP = FALSE;
		BOOL bWPA = FALSE;
		BOOL bWPAPSK = FALSE;
		BOOL bWPANONE = FALSE;
		BOOL bWPA2 = FALSE;
		BOOL bWPA2PSK = FALSE;
		BOOL bWPA2NONE = FALSE;
		if(pBssid->Length > sizeof(NDIS_WLAN_BSSID) && pBssid->IELength > sizeof(NDIS_802_11_FIXED_IEs))
		{
			ULONG lIELoc = 0;
			PNDIS_802_11_FIXED_IEs pFixIE = (PNDIS_802_11_FIXED_IEs)pBssid->IEs;
			PNDIS_802_11_VARIABLE_IEs pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pFixIE + sizeof(NDIS_802_11_FIXED_IEs));
			lIELoc += sizeof(NDIS_802_11_FIXED_IEs);
			while(pBssid->IELength > (lIELoc + sizeof(NDIS_802_11_VARIABLE_IEs)))
			{
				if(pVarIE->ElementID == 221 && pVarIE->Length >= 16)
				{
					ULONG* pOUI = (ULONG*)((char*)pVarIE + 2);
					if(*pOUI != WPA_OUI_TYPE)
						break;
					ULONG* plGroupKey; 
					WORD* pdPairKeyCount;
					ULONG* plPairwiseKey; 
					ULONG* plAuthenKey; 
					WORD* pdAuthenKeyCount;
					plGroupKey = (ULONG*)((char*)pVarIE + 8);
					
					ULONG lGroupKey = *plGroupKey & 0x00ffffff;
					if(lGroupKey == WPA_OUI)
					{
						lGroupKey = (*plGroupKey & 0xff000000) >> 0x18;
						if(lGroupKey == 2)
							bTKIP = TRUE;
							//m_SiteList.SetItemText(i, 4, _T("TKIP"));
						else if(lGroupKey == 3)
							bAESWRAP = TRUE;
							//m_SiteList.SetItemText(i, 4, _T("AES-WRAP"));
						else if(lGroupKey == 4)
							bAESCCMP = TRUE;
							//m_SiteList.SetItemText(i, 4, _T("AES-CCMP"));
					}
					else
						break;

					pdPairKeyCount = (WORD*)((char*)plGroupKey + 4);
					plPairwiseKey = (ULONG*)((char*)pdPairKeyCount + 2);

					QString strPairewise;
					for(USHORT k = 0; k < *pdPairKeyCount; k++)
					{
						ULONG lPairKey = *plPairwiseKey & 0x00ffffff;
						if(lPairKey == WPA_OUI)
						{
							lPairKey = (*plPairwiseKey & 0xff000000) >> 0x18;
							if(lPairKey == 2)
								bTKIP = TRUE;
	//							strPairewise += _T("TKIP;");
							else if(lPairKey == 3)
								bAESWRAP = TRUE;
	//							strPairewise += _T("AES-WRAP;");
							else if(lPairKey == 4)
								bAESCCMP = TRUE;
	//							strPairewise += _T("AES-CCMP;");
						}
						else
							break;

						plPairwiseKey = ++plPairwiseKey;
					}
//					m_SiteList.SetItemText(i, 5, strPairewise);

					pdAuthenKeyCount = (WORD*)((char*)pdPairKeyCount + 2 + 4 * *pdPairKeyCount);
					if(*pdAuthenKeyCount > 0)
					{
						plAuthenKey = (ULONG*)((char*)pdAuthenKeyCount + 2);

						ULONG lAuthenKey = *plAuthenKey & 0x00ffffff;
						if(lAuthenKey == WPA_OUI)
						{
							lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;
							if(lAuthenKey == 1)
								bWPA = TRUE;
//								m_SiteList.SetItemText(i, 6, _T("WPA"));
							else if(lAuthenKey == 0 || lAuthenKey == 2)
							{
								if(pBssid->InfrastructureMode)
									bWPAPSK = TRUE;
//									m_SiteList.SetItemText(i, 6, _T("WPA-PSK"));
								else
									bWPANONE = TRUE;
//									m_SiteList.SetItemText(i, 6, _T("WPA-NONE"));
							}
						}					
					}
//					break;
				}
				else if(pVarIE->ElementID == 48 && pVarIE->Length >= 12)
				{
					ULONG* pOUI = (ULONG*)((char*)pVarIE + 2);
					ULONG* plGroupKey; 
					ULONG* plPairwiseKey; 
					WORD* pdPairKeyCount;
					ULONG* plAuthenKey; 
					WORD* pdAuthenKeyCount;
					plGroupKey = (ULONG*)((char*)pVarIE + 4);
					
					ULONG lGroupKey = *plGroupKey & 0x00ffffff;
					if(lGroupKey == WPA2_OUI)
					{
						lGroupKey = (*plGroupKey & 0xff000000) >> 0x18;
						if(lGroupKey == 2)
							bTKIP = TRUE;
//							m_SiteList.SetItemText(i, 4, _T("TKIP"));
						else if(lGroupKey == 3)
							bAESWRAP = TRUE;
//							m_SiteList.SetItemText(i, 4, _T("AES-WRAP"));
						else if(lGroupKey == 4)
							bAESCCMP = TRUE;
//							m_SiteList.SetItemText(i, 4, _T("AES-CCMP"));
					}
					else
						break;
					
					pdPairKeyCount = (WORD*)((char*)plGroupKey + 4);
					plPairwiseKey = (ULONG*)((char*)pdPairKeyCount + 2);

					QString strPairewise;
					for(USHORT k = 0; k < *pdPairKeyCount; k++)
					{
						ULONG lPairKey = *plPairwiseKey & 0x00ffffff;
						if(lPairKey == WPA2_OUI)
						{
							lPairKey = (*plPairwiseKey & 0xff000000) >> 0x18;
							if(lPairKey == 2)
								bTKIP = TRUE;
//								strPairewise += _T("TKIP;");
							else if(lPairKey == 3)
								bAESWRAP = TRUE;
//								strPairewise += _T("AES-WRAP;");
							else if(lPairKey == 4)
								bAESCCMP = TRUE;
//								strPairewise += _T("AES-CCMP;");
						}
						else
							break;

						plPairwiseKey = ++plPairwiseKey;
					}
//					m_SiteList.SetItemText(i, 5, strPairewise);

					pdAuthenKeyCount = (WORD*)((char*)pdPairKeyCount + 2 + 4 * *pdPairKeyCount);
					if(*pdAuthenKeyCount > 0)
					{
						plAuthenKey = (ULONG*)((char*)pdAuthenKeyCount + 2);

						ULONG lAuthenKey = *plAuthenKey & 0x00ffffff;
						if(lAuthenKey == WPA2_OUI)
						{
							lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;
							if(lAuthenKey == 1)
								bWPA2 = TRUE;
//								m_SiteList.SetItemText(i, 6, _T("WPA2"));
							else if(lAuthenKey == 0 || lAuthenKey == 2)
							{
								if(pBssid->InfrastructureMode)
									bWPA2PSK = TRUE;
//									m_SiteList.SetItemText(i, 6, _T("WPA2-PSK"));
								else
									bWPA2NONE = TRUE;
//									m_SiteList.SetItemText(i, 6, _T("WPA2-NONE"));
							}
						}					
					}
//					break;
				}

				lIELoc += pVarIE->Length;
				lIELoc += 2;
				pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pVarIE + pVarIE->Length + 2);
				
				if(pVarIE->Length <= 0)
					break;
			}
		}

		QString strAuth, strEncry;

		if(bWPA)
			strAuth += "WPA;";
		if(bWPAPSK)
			strAuth += "WPA-PSK;";
		if(bWPANONE)
			strAuth += "WPA-NONE;";
		if(bWPA2)
			strAuth += "WPA2;";
		if(bWPA2PSK)
			strAuth += "WPA2-PSK;";
		if(bWPA2NONE)
			strAuth += "WPA2-NONE;";
		if(!strAuth.isEmpty())
		{
			strAuth = strAuth.left(strAuth.length() - 1);
			ListItem->setText(5, strAuth);
		}

		if(bTKIP)
			strEncry += "TKIP;";
		if(bAESWRAP || bAESCCMP)
			strEncry += "AES;";
//					strEncry += _T("AES-WRAP;");
//				if(bAESCCMP)
//					strEncry += _T("AES-CCMP;");
		if(!strEncry.isEmpty())
		{
			strEncry = strEncry.left(strEncry.length() - 1);
			ListItem->setText(4, strEncry);			
		}

		pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);
	}
	
//	m_SiteList.SetItemState(0, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);	
    
#if 0
    
    QListViewItem           *ListItem;
    PNDIS_WLAN_BSSID_EX     pBssid;
    char                    strSSID[NDIS_802_11_LENGTH_SSID + 1];    
    QString                 qstrBssid;
    QString                 qstrRSSI;
    QString                 qstrChannel;
    ULONG                   lBufLen = 65536; // 64K
    ULONG                   i;
    UINT                    nSigQua;
    int                     nChannel;
    int                     j;
    int kk;//baltam
    PUCHAR tempkk;

    SiteSurvPage_ListView->clear();

    if (OidQueryInformation(OID_802_11_BSSID_LIST, m_nSocketId, m_strDeviceName, m_pBssidList, lBufLen) < 0)
    { //failed
        memset(m_pBssidList, 0x00, lBufLen);
        return;
    }


    pBssid = (PNDIS_WLAN_BSSID_EX) m_pBssidList->Bssid;
   // qDebug("m_pBssidList->NumberOfItems=%d\n",m_pBssidList->NumberOfItems);
    for (i = 0; i < m_pBssidList->NumberOfItems; i++)
    {
        memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);
        memcpy(strSSID, pBssid->Ssid.Ssid, pBssid->Ssid.SsidLength);

        qstrBssid.sprintf("%02X-%02X-%02X-%02X-%02X-%02X", 
                        pBssid->MacAddress[0], pBssid->MacAddress[1], pBssid->MacAddress[2],
                        pBssid->MacAddress[3], pBssid->MacAddress[4], pBssid->MacAddress[5]);

        nSigQua = ConvertRssiToSignalQuality(pBssid->Rssi);

        qstrRSSI.sprintf("%d%%", nSigQua);

        nChannel = -1;

        for(j = 0; j < G_nChanFreqCount; j++)
        {
            if(pBssid->Configuration.DSConfig == ChannelFreqTable[j].lFreq)
            {
                nChannel = ChannelFreqTable[j].lChannel;
                break;
            }
        }

        if(nChannel == -1)
        	{
            continue;
        	}

        qstrChannel.sprintf("%u", nChannel);

        // Insert the item, select every other item.        
        ListItem=new QListViewItem(SiteSurvPage_ListView);
	//if(i>=7)
        // Set subitem 0
        ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("uncheck16.xpm"));
        ListItem->setText(0, strSSID);
        // Set subitem 1
        ListItem->setText(1, qstrBssid);
        // Set subitem 2
        ListItem->setText(2, qstrRSSI);
        // Set subitem 3
        ListItem->setText(3, qstrChannel);
        // Set subitem 4
        if (pBssid->Privacy)
            ListItem->setText(4, strAryEncryption[0]);
        else
            ListItem->setText(4, strAryEncryption[1]);
        // Set subitem 5
        ListItem->setText(5, "Unknown");
        // Set subitem 6        
        ListItem->setText(6, strAryNetworkType[pBssid->InfrastructureMode]);

	if(i>=7)
        // work with NDIS_WLAN_BSSID_EX
        if ((pBssid->Length > sizeof(NDIS_WLAN_BSSID)) && (pBssid->IELength > sizeof(NDIS_802_11_FIXED_IEs)))
        {
            ULONG lIELoc = 0;
            PNDIS_802_11_FIXED_IEs pFixIE = (PNDIS_802_11_FIXED_IEs)pBssid->IEs;
            PNDIS_802_11_VARIABLE_IEs pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pFixIE + sizeof(NDIS_802_11_FIXED_IEs));
            lIELoc += sizeof(NDIS_802_11_FIXED_IEs);
            while (pBssid->IELength > (lIELoc + sizeof(NDIS_802_11_VARIABLE_IEs)))
            {
                if ((pVarIE->ElementID == 221) && (pVarIE->Length >= 16))
                {
                    ULONG* pOUI = (ULONG*)((char*)pVarIE + 2);
                    if(*pOUI != WPA_OUI_TYPE)
                        break;
                    ULONG* plGroupKey; 
                    WORD* pdPairKeyCount;
                    ULONG* plAuthenKey; 
                    WORD* pdAuthenKeyCount;
                    plGroupKey = (ULONG*)((char*)pVarIE + 8);

                    ULONG lGroupKey = *plGroupKey & 0x00ffffff;
                    if (lGroupKey == WPA_OUI)
                    {
                        lGroupKey = (*plGroupKey & 0xff000000) >> 0x18;
                        if (lGroupKey == 2)
                            ListItem->setText(4, "TKIP");
                        else if (lGroupKey == 3)
                            ListItem->setText(4, "AES-WRAP");
                        else if (lGroupKey == 4)
                            ListItem->setText(4, "AES-CCMP");
                    }
                    else
                        break;

                    pdPairKeyCount = (WORD*)((char*)plGroupKey + 4);
                    pdAuthenKeyCount = (WORD*)((char*)pdPairKeyCount + 2 + 4 * (*pdPairKeyCount));
                    if (*pdAuthenKeyCount > 0)
                    {
                        plAuthenKey = (ULONG*)((char*)pdAuthenKeyCount + 2);

                        ULONG lAuthenKey = *plAuthenKey & 0x00ffffff;
                        if (lAuthenKey == WPA_OUI)
                        {
                            lAuthenKey = (*plAuthenKey & 0xff000000) >> 0x18;
                            if (lAuthenKey == 1)
                                ListItem->setText(5, "WPA");
                            else if (lAuthenKey == 2)
                            {
                                if (pBssid->InfrastructureMode)
                                    ListItem->setText(5, "WPA-PSK");
                                else 
                                    ListItem->setText(5, "WPA-NONE");
                            }
                        }
                    }
                    break;
                }
                lIELoc += pVarIE->Length;
                pVarIE = (PNDIS_802_11_VARIABLE_IEs)((char*)pVarIE + pVarIE->Length);
                
                if(pVarIE->Length <= 0)
                    break;
            }
	     
        }
        pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);
    }
    
#endif    
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_RescanTimeFunc()<==\n");
    
}

bool RaPropSheet::SiteSurvPage_ResetOidValue(NDIS_802_11_NETWORK_INFRASTRUCTURE enumInfrastructureMode)
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_ResetOidValue()==>\n");

    RT_802_11_PREAMBLE                      enumPreamType = Rt802_11PreambleAuto;
    NDIS_802_11_RTS_THRESHOLD               lRtsThre = MAX_RTS_THRESHOLD;
    NDIS_802_11_FRAGMENTATION_THRESHOLD     lFragThre = 0;
    NDIS_802_11_TX_POWER_LEVEL              lTransPower = MAX_TX_POWER_LEVEL;
    NDIS_802_11_POWER_MODE                  enumPSMode = Ndis802_11PowerModeCAM;

    OidSetInformation(RT_OID_802_11_PREAMBLE, m_nSocketId, m_strDeviceName, &enumPreamType, sizeof(enumPreamType));

    OidSetInformation(OID_802_11_TX_POWER_LEVEL, m_nSocketId, m_strDeviceName, &lTransPower, sizeof(lTransPower));

    OidSetInformation(OID_802_11_RTS_THRESHOLD, m_nSocketId, m_strDeviceName, &lRtsThre, sizeof(lRtsThre));

    OidSetInformation(OID_802_11_FRAGMENTATION_THRESHOLD, m_nSocketId, m_strDeviceName, &lFragThre, sizeof(lFragThre));

    if (enumInfrastructureMode == Ndis802_11Infrastructure)
    {
        OidSetInformation(OID_802_11_POWER_MODE, m_nSocketId, m_strDeviceName, &enumPSMode, sizeof(enumPSMode));
    }
    else if (enumInfrastructureMode == Ndis802_11IBSS)
    {
        ; //do nothing
    }

    DebugPrint("<func>RaPropSheet::SiteSurvPage_ResetOidValue()<==\n");
    
    return TRUE;
}

void RaPropSheet::SiteSurvPage_UpdateConnectStatus(int nActiveItem, int nImageIdx)
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_UpdateConnectStatus()==>\n");

    int                 nItem;    
    QListViewItem       *ListItem;

    nItem = SiteSurvPage_ListView->childCount();
    ListItem = SiteSurvPage_ListView->firstChild();
        
	for(int i = 0; i < nItem; i++)
	{		
		if(nImageIdx == SITE_STATUS_CONNECTED && i==nActiveItem)
		{
			ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("handshak16.xpm"));	
		}	            	
		else
		{
			ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("uncheck16.xpm"));
		}
		
		ListItem = ListItem->itemBelow();	
	}
	    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_UpdateConnectStatus()<==\n");    
}    
#if 0
void RaPropSheet::SiteSurvPage_UpdateConnectStatus(NDIS_MEDIA_STATE ConnectStatus)
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_UpdateConnectStatus()==>\n");

    
    QListViewItem       *ListItem;
    QString                     qstrBssid;
    NDIS_802_11_MAC_ADDRESS     BssidQuery;
    NDIS_802_11_MAC_ADDRESS     Bssid;
    int                 nItem;
    int                 i,j;


    memset(&BssidQuery, 0x00, sizeof(BssidQuery));
    OidQueryInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, &BssidQuery, sizeof(BssidQuery));

    nItem = SiteSurvPage_ListView->childCount();
    ListItem = SiteSurvPage_ListView->firstChild();
    for (i = 0; i < nItem; i++)
    {
        ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("uncheck16.xpm"));
        if(ConnectStatus == NdisMediaStateConnected && G_bRadio)
        {
            qstrBssid = ListItem->text(1);
            j = 0;
            while ( ( j = qstrBssid.find( '-', j ) ) != -1 )
                qstrBssid.remove( j ,1 );

            AtoH((char *)qstrBssid.data(), Bssid, 6);
            if(memcmp(BssidQuery, Bssid, 6) == 0)
            {
                ListItem->setPixmap(0, uic_load_pixmap_RaPropSheet("handshak16.xpm"));
                m_bRescan = FALSE;
            }
        }
        ListItem = ListItem->itemBelow();
    }

    if (m_bUpdateProfilePage)
    {
        m_bUpdateProfilePage = FALSE;
        ProfilePage_UpdateProfileStatus();
    }

    if (m_bUpdateLinkSatusPage)
    {
        m_bUpdateLinkSatusPage = FALSE;
//        LinkStatusPage_UpdateStatus();
    }

    DebugPrint("<func>RaPropSheet::SiteSurvPage_UpdateConnectStatus()<==\n");
    
}
#endif

void RaPropSheet::SiteSurvPage_OnConnect()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnConnect()==>\n");


	UINT nWPA = Auth_Mode_UNKNOWN;
	BOOL bHiddenSsid = FALSE;
	QString	str;
	
		
    	QListViewItem                       *selectedItem;	
	int				nTotalItemNum;
    	QListViewItem                       *listViewItem;
		
   	nTotalItemNum = SiteSurvPage_ListView->childCount();	
    	selectedItem = SiteSurvPage_ListView->selectedItem();

	// Check that Is Item selected.					
	if(selectedItem == 0)
	{
		QMessageBox::warning(this, "Warning", IDS_NOSELECTEDITEM);
		return;	
	}

	// Check that have items in m_pBssidList.
	if(m_pBssidList->NumberOfItems == 0)
	{
		return;
	}

	// Selected item's MAC-ADDRESS
	NDIS_802_11_MAC_ADDRESS CurBssid;
	QString strBssid = selectedItem->text(1);
	strBssid.remove('-');
	AtoH((char*)strBssid.data(), CurBssid, 6);
	
	DebugPrntFormat(DebugPrntBuf, "SelectedItem BSSID -> %02x-%02x-%02x-%02x-%02x-%02x\n",  CurBssid[0], CurBssid[1], CurBssid[2], CurBssid[3], CurBssid[4], CurBssid[5]);
	DebugPrint(DebugPrntBuf);

	SiteSurvPage_ButtonShowHide();
	
	if(!SiteSurvPage_PushButton_Connect->isEnabled())
	{
		return;
	}


	nWPA = SiteSurvPage_IsItemWPA();
	if(!G_bWpaCapable && (nWPA == Auth_Mode_WPA || nWPA == Auth_Mode_WPA_NONE || 
		nWPA == Auth_Mode_WPA_PSK || nWPA == Auth_Mode_WPA2 || nWPA == Auth_Mode_WPA2_PSK))
	{
		// RaConfig don't support this authentication in Linux
		QMessageBox::warning(this, "Warning", "RaConfig don't support this authentication!");
		return;
	}


	// Selected Item's mapping record in m_pBssidList
	PNDIS_WLAN_BSSID_EX pBssid = m_pBssidList->Bssid;
	
    	listViewItem = SiteSurvPage_ListView->firstChild();
    	
	for(int i = 0; i < m_pBssidList->NumberOfItems; i ++)
	{
		if(memcmp(pBssid->MacAddress, CurBssid, 6) == 0)
		{
			break;
		}
		pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);
	}

	if(pBssid->InfrastructureMode == Ndis802_11Infrastructure) 
	{
		if(pBssid->Ssid.SsidLength == 0)
		{
			HiddenSsidDlg *pHiddendlg = new HiddenSsidDlg(this, "HiddenSsid", TRUE);
			QString qstrSsid;
		
			pHiddendlg->exec();
			if (pHiddendlg->IsClickOk())
			{
				bHiddenSsid = TRUE;
				qstrSsid = pHiddendlg->GetSsidString();
				m_SsidSet.SsidLength = qstrSsid.length();
				memcpy(m_SsidSet.Ssid, qstrSsid.data(), m_SsidSet.SsidLength);
			}
			else
			{
				return;
			}
		}
	}
	
	
	ULONG lReturn = 0;
	ACTION_DATA actionData;
	actionData.enumActionType = Profile;
	PPROFILE_DATA pProfileData = (PPROFILE_DATA)GlobalAllocPtr(sizeof(PROFILE_DATA));
	actionData.pActionBuffer = pProfileData;

	memset(pProfileData, 0x00, sizeof(PROFILE_DATA));

	pProfileData->bACCam = FALSE;
	pProfileData->enumPSMode = Ndis802_11PowerModeCAM;
	pProfileData->lRtsThre = RTS_MAX;
	pProfileData->lFragThre = 0;
	pProfileData->enumPreamType = Rt802_11PreambleAuto;
	pProfileData->enumNetworkType = pBssid->InfrastructureMode;
	pProfileData->infoLeapAuth.Enabled = FALSE;
	pProfileData->lTxPower = 0;
	
		
	// Set Authentication & Encry Status
	NDIS_802_11_AUTHENTICATION_MODE enumAuthenMode = Ndis802_11AuthModeOpen;
	NDIS_802_11_ENCRYPTION_STATUS enumEncryStatus = Ndis802_11EncryptionDisabled;


	if(pBssid->Privacy || nWPA == Auth_Mode_WPA_PSK || nWPA == Auth_Mode_WPA_NONE || 
		nWPA == Auth_Mode_WPA || nWPA == Auth_Mode_WPA2 || nWPA == Auth_Mode_WPA2_PSK)
	{
	
		DebugPrntFormat(DebugPrntBuf, "pBssid->Privacy = %d, %02x-%02x-%02x-%02x-%02x-%02x ,%s\n", pBssid->Privacy, pBssid->MacAddress[0], pBssid->MacAddress[1], pBssid->MacAddress[2], pBssid->MacAddress[3], pBssid->MacAddress[4], pBssid->MacAddress[5],  &pBssid->Ssid.Ssid[0]);
		DebugPrint(DebugPrntBuf);
		
	        AuthSecuDlg *pAuthSecuDlg = new AuthSecuDlg(this, "AuthSecuDlg", TRUE);
			
		pAuthSecuDlg->m_enumInfrastructureMode = pBssid->InfrastructureMode;
		pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)0;
		pAuthSecuDlg->m_nEncryType = (NDIS_802_11_ENCRYPTION_STATUS)0;

		if(nWPA == Auth_Mode_WPA || nWPA == Auth_Mode_WPA_PSK || 
			nWPA == Auth_Mode_WPA_NONE || nWPA == Auth_Mode_WPA2 || 
			nWPA == Auth_Mode_WPA2_PSK)
		{
			pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)2;
			if(nWPA == Auth_Mode_WPA)
				pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)3;
			else if(nWPA == Auth_Mode_WPA_PSK)
				pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)4;
			else if(nWPA == Auth_Mode_WPA2)
			{
//				if(G_osVersion == Win2000 || G_osVersion == WinXP)
					pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)5;
//				else
//					pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)3;
			}
			else if(nWPA == Auth_Mode_WPA2_PSK)
			{
//				if(G_osVersion == Win2000 || G_osVersion == WinXP)
					pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)6;	
//				else
//					pAuthSecuDlg->m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)4;	
			}
			
	
			QString strEncryStatus = selectedItem->text(4);
			if(strEncryStatus.compare(IDS_ENCRY_TYPE_TKIP) != 0) // for AES
				pAuthSecuDlg->m_nEncryType = (NDIS_802_11_ENCRYPTION_STATUS)1;
		}
		else
		{
			pAuthSecuDlg->m_nEncryType = (NDIS_802_11_ENCRYPTION_STATUS)1;
		}
		
		DebugPrntFormat(DebugPrntBuf, "<Authen> nWPA=%d, m_enumInfrastructureMode=%d, m_nAuthenType=%d, m_nEncryType=%d\n", nWPA, pAuthSecuDlg->m_enumInfrastructureMode, pAuthSecuDlg->m_nAuthenType, pAuthSecuDlg->m_nEncryType);
		DebugPrint(DebugPrntBuf);

		pAuthSecuDlg->InitCombosInDialog();
        	pAuthSecuDlg->exec();

		if(nWPA == Auth_Mode_WPA || nWPA == Auth_Mode_WPA2 )
		{
			GlobalFreePtr(pProfileData);
			delete pAuthSecuDlg;
			pAuthSecuDlg = NULL;
		
			// RaConfig don't support this authentication in Linux
			QMessageBox::warning(this, "Warning", "RaConfig don't support this authentication!");
			return;
		}

#if DRIVER_IS_COMPLETED_ON_AES

		//if((nWPA == Auth_Mode_WPA2_PSK ||nWPA == Auth_Mode_WPA_PSK || nWPA == Auth_Mode_WPA_NONE) && pAuthSecuDlg->m_nEncryType==1)
		if(pAuthSecuDlg->AuthSecuDlg_IsClickOk() == FALSE)
		{
			GlobalFreePtr(pProfileData);
			delete pAuthSecuDlg;
			pAuthSecuDlg = NULL;
		
			// RaConfig don't support this authentication in Linux
			QMessageBox::warning(this, "Warning", "RaConfig don't support this encryption type!");
			return;		
		}
#endif

		if(pAuthSecuDlg->AuthSecuDlg_IsClickOk() == FALSE)
		{
			GlobalFreePtr(pProfileData);
			delete pAuthSecuDlg;
			pAuthSecuDlg = NULL;
			return;
		}
	
#if 0
		if(G_bWpaCapable && ((pProfileData->enumNetworkType == Ndis802_11Infrastructure &&
			(pAuthSecuDlg->m_nAuthenType == 3 || pAuthSecuDlg->m_nAuthenType == 5)) || // WPA
			((pAuthSecuDlg->m_nAuthenType == 0 || pAuthSecuDlg->m_nAuthenType == 1) && pAuthSecuDlg->m_b8021X)))
		{
			pProfileData->b8021X = TRUE;
			pProfileData->enumAuthenProtocol = pAuthSecuDlg->m_wpaInfo.enumAuthenProtocol;
			pProfileData->enumTunnel = pAuthSecuDlg->m_wpaInfo.enumTunnel;
			pProfileData->nSessionResumption = pAuthSecuDlg->m_wpaInfo.nSessionResumption;

			strcpy(pProfileData->chID, pAuthSecuDlg->m_wpaInfo.strID.GetBuffer(pAuthSecuDlg->m_wpaInfo.strID.GetLength()));
			strcpy(pProfileData->chPassword, pAuthSecuDlg->m_wpaInfo.strPassword.GetBuffer(pAuthSecuDlg->m_wpaInfo.strPassword.GetLength()));
			strcpy(pProfileData->chTunnelID, pAuthSecuDlg->m_wpaInfo.strTunnelID.GetBuffer(pAuthSecuDlg->m_wpaInfo.strTunnelID.GetLength()));
			strcpy(pProfileData->chTunnelPassword, pAuthSecuDlg->m_wpaInfo.strTunnelPassword.GetBuffer(pAuthSecuDlg->m_wpaInfo.strTunnelPassword.GetLength()));
			pProfileData->nPasswordMode = pAuthSecuDlg->m_wpaInfo.nPasswordMode;
			if(pProfileData->nPasswordMode == 1)
				strcpy(pProfileData->chTunnelPassword, pAuthSecuDlg->m_wpaInfo.strTunnelPassword.GetBuffer(pAuthSecuDlg->m_wpaInfo.strTunnelPassword.GetLength()));
			pProfileData->bClientCert = pAuthSecuDlg->m_wpaInfo.bClientCert;
			if(pProfileData->bClientCert)
			{
				pProfileData->user_cert.blobLength = pAuthSecuDlg->m_wpaInfo.user_cert.blobLength;
				if(pProfileData->user_cert.blobLength > 0)
					memcpy(pProfileData->user_cert.blobData, pAuthSecuDlg->m_wpaInfo.user_cert.blobData, pProfileData->user_cert.blobLength);
			}

			pProfileData->bServerCert = pAuthSecuDlg->m_wpaInfo.bServerCert;
			if(pProfileData->bServerCert)
			{
				pProfileData->bIntermidiateCert = pAuthSecuDlg->m_wpaInfo.bIntermidiateCert;
				pProfileData->nServerNameRule = pAuthSecuDlg->m_wpaInfo.nServerNameRule;
				strcpy(pProfileData->chServerName, pAuthSecuDlg->m_wpaInfo.strServerName.GetBuffer(pAuthSecuDlg->m_wpaInfo.strServerName.GetLength()));
				pProfileData->CA_cert.blobLength = pAuthSecuDlg->m_wpaInfo.CA_cert.blobLength;
				if(pProfileData->CA_cert.blobLength > 0)
					memcpy(pProfileData->CA_cert.blobData, pAuthSecuDlg->m_wpaInfo.CA_cert.blobData, pProfileData->CA_cert.blobLength);
			}

			if(pProfileData->enumNetworkType == Ndis802_11Infrastructure && pAuthSecuDlg->m_nAuthenType == 3)
			{
				enumAuthenMode = Ndis802_11AuthModeWPA;
				// Set Encryption Status
				if(pAuthSecuDlg->m_nEncryType == 0)
					enumEncryStatus = Ndis802_11Encryption2Enabled;
				else
					enumEncryStatus = Ndis802_11Encryption3Enabled;
			}
			else if(pProfileData->enumNetworkType == Ndis802_11Infrastructure && pAuthSecuDlg->m_nAuthenType == 5)
			{
				enumAuthenMode = Ndis802_11AuthModeWPA2;
				// Set Encryption Status
				if(pAuthSecuDlg->m_nEncryType == 0)
					enumEncryStatus = Ndis802_11Encryption2Enabled;
				else
					enumEncryStatus = Ndis802_11Encryption3Enabled;
			}
		}

#endif

#if 1
		if(pProfileData->enumNetworkType == Ndis802_11Infrastructure && pAuthSecuDlg->m_nAuthenType == 2) // LEAP
		{
			enumAuthenMode = Ndis802_11AuthModeOpen;
			enumEncryStatus = Ndis802_11Encryption1Enabled;	
			if(pAuthSecuDlg->m_bCCX20 && pAuthSecuDlg->m_nLeapEncryType == 1)
				enumEncryStatus = Ndis802_11Encryption2Enabled;	
			pProfileData->infoLeapAuth.CCKM = pAuthSecuDlg->m_bLeapCCKM;
			pProfileData->infoLeapAuth.Enabled = TRUE;
			pProfileData->infoLeapAuth.UserNameLen = pAuthSecuDlg->AuthSecuDlg_LineEdit_LeapId->text ().length();
			pProfileData->infoLeapAuth.PasswordLen = pAuthSecuDlg->AuthSecuDlg_LineEdit_LeapPassword->text ().length();
			
			memcpy(pProfileData->infoLeapAuth.UserName, pAuthSecuDlg->AuthSecuDlg_LineEdit_LeapId->text ().data(), pProfileData->infoLeapAuth.UserNameLen);
			memcpy(pProfileData->infoLeapAuth.Password, pAuthSecuDlg->AuthSecuDlg_LineEdit_LeapPassword->text ().data(), pProfileData->infoLeapAuth.PasswordLen);
		}
		else if((pProfileData->enumNetworkType == Ndis802_11Infrastructure && (pAuthSecuDlg->m_nAuthenType == 4 || pAuthSecuDlg->m_nAuthenType == 6)) || // WPA-Psk
			(pProfileData->enumNetworkType == Ndis802_11IBSS && pAuthSecuDlg->m_nAuthenType == 2)) // WPA-NONE
		{			
            		QString TmpStrPsk = pAuthSecuDlg->AuthSecuDlg_GetPSKString();
			int nLen = TmpStrPsk.length();
			char* pStrPsk = (char*)TmpStrPsk.data();
			

	    
			// Set Authentication Mode
			if(pBssid->InfrastructureMode == Ndis802_11Infrastructure)
			{
				if(pAuthSecuDlg->m_nAuthenType == 6)
					enumAuthenMode = Ndis802_11AuthModeWPA2PSK;
				else
					enumAuthenMode = Ndis802_11AuthModeWPAPSK;
				pProfileData->nPskKeyLen = nLen;
				memcpy(pProfileData->chPskKey, pStrPsk, nLen);
			}
			else
			{
				enumAuthenMode = Ndis802_11AuthModeWPANone;
				ULONG nKeyLen = 32;
				ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
				UCHAR keyMaterial[40];
				// Allocate Resouce
				PNDIS_802_11_KEY pKey = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen);
				pKey->Length = lBufLen;
				pKey->KeyLength = nKeyLen;
				pKey->KeyIndex = 0x80000000;
				pKey->BSSID[0] = 0xff;
				pKey->BSSID[1] = 0xff;
				pKey->BSSID[2] = 0xff;
				pKey->BSSID[3] = 0xff;
				pKey->BSSID[4] = 0xff;
				pKey->BSSID[5] = 0xff;
				if(nLen == 64)
					AtoH(pStrPsk, keyMaterial, 32);
				else
				{
					if(bHiddenSsid)
						PasswordHash(pStrPsk, m_SsidSet.Ssid, m_SsidSet.SsidLength, keyMaterial);	
					else
						PasswordHash(pStrPsk, pBssid->Ssid.Ssid, (pBssid->Ssid.SsidLength), keyMaterial);
				}
				memcpy(pKey->KeyMaterial, keyMaterial, 32);

				pProfileData->pWPAKey = pKey;
				pProfileData->lWPAKeyLen = lBufLen;
			}

			// Set Encryption Status
			if(pAuthSecuDlg->m_nEncryType == 0)
				enumEncryStatus = Ndis802_11Encryption2Enabled;
			else
				enumEncryStatus = Ndis802_11Encryption3Enabled;
		}
		else if(pAuthSecuDlg->m_nAuthenType == 1 || (pAuthSecuDlg->m_nAuthenType == 0 && pAuthSecuDlg->m_nEncryType == 1)) // Shared Key or WEP On
		{
			// Set Authentication Mode
			enumAuthenMode = (NDIS_802_11_AUTHENTICATION_MODE)pAuthSecuDlg->m_nAuthenType;

			// Set Encryption Status
			if(pAuthSecuDlg->m_nEncryType == 0)
				enumEncryStatus = Ndis802_11EncryptionDisabled;
			else
				enumEncryStatus = Ndis802_11Encryption1Enabled;

			int nKeyLen = pAuthSecuDlg->m_Key1Len;			
			    DebugPrntFormat(DebugPrntBuf, "pAuthSecuDlg->m_Key1Len = %d\n", pAuthSecuDlg->m_Key1Len);		DebugPrint(DebugPrntBuf);			
			    DebugPrntFormat(DebugPrntBuf, "nKeyLen = %d\n", nKeyLen);		DebugPrint(DebugPrntBuf);			

			if(nKeyLen != 0)
			{
				DebugPrint("nKeyLen!=0, copydata\n");
			
				ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
				PNDIS_802_11_KEY pKey = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen); // Don't use GMEM_ZEROINIT to get random key
				pKey->Length = lBufLen;
				pKey->KeyLength = nKeyLen;
				pKey->KeyIndex = 0;
				if(pAuthSecuDlg->m_nKeyIndex == 0)
					pKey->KeyIndex |= 0x80000000;
				for(int i = 0; i < 6; i++)
					pKey->BSSID[i] = 0xff;
		
				memcpy(pKey->KeyMaterial, pAuthSecuDlg->m_chKey1Material, nKeyLen);
				pProfileData->pWEPKey1 = pKey;
				pProfileData->lWEPKey1Len = lBufLen;
			}

			nKeyLen = pAuthSecuDlg->m_Key2Len;
			    DebugPrntFormat(DebugPrntBuf, "pAuthSecuDlg->m_Key2Len = %d\n", pAuthSecuDlg->m_Key2Len);		DebugPrint(DebugPrntBuf);			
			
			if(nKeyLen != 0)
			{
				ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
				PNDIS_802_11_KEY pKey = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen); // Don't use GMEM_ZEROINIT to get random key
				pKey->Length = lBufLen;
				pKey->KeyLength = nKeyLen;
				pKey->KeyIndex = 1;
				if(pAuthSecuDlg->m_nKeyIndex == 1)
					pKey->KeyIndex |= 0x80000000;
				for(int i = 0; i < 6; i++)
					pKey->BSSID[i] = 0xff;

				memcpy(pKey->KeyMaterial, pAuthSecuDlg->m_chKey2Material, nKeyLen);
				pProfileData->pWEPKey2 = pKey;
				pProfileData->lWEPKey2Len = lBufLen;
			}

			nKeyLen = pAuthSecuDlg->m_Key3Len;
			    DebugPrntFormat(DebugPrntBuf, "pAuthSecuDlg->m_Key3Len = %d\n", pAuthSecuDlg->m_Key3Len);		DebugPrint(DebugPrntBuf);			
			
			if(nKeyLen != 0)
			{
				ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
				PNDIS_802_11_KEY pKey = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen); // Don't use GMEM_ZEROINIT to get random key
				pKey->Length = lBufLen;
				pKey->KeyLength = nKeyLen;
				pKey->KeyIndex = 2;
				if(pAuthSecuDlg->m_nKeyIndex == 2)
					pKey->KeyIndex |= 0x80000000;
				for(int i = 0; i < 6; i++)
					pKey->BSSID[i] = 0xff;

				memcpy(pKey->KeyMaterial, pAuthSecuDlg->m_chKey3Material, nKeyLen);
				pProfileData->pWEPKey3 = pKey;
				pProfileData->lWEPKey3Len = lBufLen;
			}		
			
			nKeyLen = pAuthSecuDlg->m_Key4Len;
			    DebugPrntFormat(DebugPrntBuf, "pAuthSecuDlg->m_Key4Len = %d\n", pAuthSecuDlg->m_Key4Len);		DebugPrint(DebugPrntBuf);			
			
			if(nKeyLen != 0)
			{
				ULONG lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
				PNDIS_802_11_KEY pKey = (PNDIS_802_11_KEY)GlobalAllocPtr(lBufLen); // Don't use GMEM_ZEROINIT to get random key
				pKey->Length = lBufLen;
				pKey->KeyLength = nKeyLen;
				pKey->KeyIndex = 3;
				if(pAuthSecuDlg->m_nKeyIndex == 3)
					pKey->KeyIndex |= 0x80000000;
				for(int i = 0; i < 6; i++)
					pKey->BSSID[i] = 0xff;

				memcpy(pKey->KeyMaterial, pAuthSecuDlg->m_chKey4Material, nKeyLen);
				pProfileData->pWEPKey4 = pKey;
				pProfileData->lWEPKey4Len = lBufLen;
			}
		}

	    DebugPrint("<func>delete pAutehSecuDlg begin\n");
		
		delete pAuthSecuDlg;
		pAuthSecuDlg = NULL;

	    DebugPrint("<func>delete pAutehSecuDlg end\n");		

#endif
	}
	
#if 1	
	pProfileData->enumAuthenMode = enumAuthenMode;
	pProfileData->enumEncryStatus = enumEncryStatus;
	pProfileData->bDisassociate = TRUE;

	SiteSurvPage_LineEdit_Status->setText(IDS_CONNECTING);
		

	// Reset all configuration value

	if(!bHiddenSsid)
		memcpy(&m_SsidSet, &pBssid->Ssid, sizeof(NDIS_802_11_SSID)); // Prepare SSID for retry after retry 5 times BSSID
	memcpy(m_BssidSet, pBssid->MacAddress, sizeof(NDIS_802_11_MAC_ADDRESS));

	if(pBssid->InfrastructureMode == Ndis802_11IBSS || bHiddenSsid) // Ad hoc use SSID
	{
		if(bHiddenSsid)
			memcpy(&pProfileData->SSID, &m_SsidSet, sizeof(NDIS_802_11_SSID)); 
		else
			memcpy(&pProfileData->SSID, &pBssid->Ssid, sizeof(NDIS_802_11_SSID));

		pProfileData->bBssid = FALSE;

		m_bSetSsid = TRUE;
		m_bSetBssid = FALSE;
	}
	else
	{
		memcpy(pProfileData->BSSID, pBssid->MacAddress, sizeof(NDIS_802_11_MAC_ADDRESS));
		pProfileData->bBssid = TRUE;
		
		m_bSetBssid = TRUE;
		m_bSetSsid = FALSE;
	}

	G_nRetryConnect = 0;
	G_bSetFromSiteSurvey = TRUE;
	HideDlg_CopyProfData(G_pSiteSurveyProfData, pProfileData);

	if(HideDlg_InsertAction(actionData))
		HideDlg_ActionExec();

	// Stop Profile autoreconnect
//BUGBUG		pRaPropSheet->m_ProfilePage.StopProfileTimer();
		    

    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnConnect()<==\n");

#endif


//// Old Program
#if 0
    QListViewItem                           *CurSelItem;
    PNDIS_WLAN_BSSID_EX                     pBssid;
    NDIS_802_11_MAC_ADDRESS                 CurBssid;
    NDIS_802_11_AUTHENTICATION_MODE         AuthenticationMode = Ndis802_11AuthModeOpen;
    NDIS_802_11_ENCRYPTION_STATUS           EncryptType = Ndis802_11WEPDisabled;
    NDIS_802_11_AUTHENTICATION_MODE         EncryStatus;
    NDIS_802_11_REMOVE_KEY                  removeKey;
    PNDIS_802_11_KEY                        pKey = NULL;
    QString                                 qstrAuthen;
    QString                                 qstrEncrypt;
    QString                                 qstrBssid;
    QString                                 strPsk;
    QString                                 strKey;
    ULONG                                   index;
    ULONG                                   nKeyLen;
    ULONG                                   lBufLen;
    UCHAR                                   keyMaterial[40];
    int                                     i = 0;
    bool                                    bfound = FALSE;
    bool                                    bHiddenSsid = FALSE;

    if (!G_bUserAdmin)
    {
        QMessageBox::information(this, "Information", "You do not have supper user's privilege!");
        return;
    }

    CurSelItem = SiteSurvPage_ListView->selectedItem();
    if(!CurSelItem)
    {
        QMessageBox::warning(this, "Warning", "No selected Item!");
        return;
    }

    if (!m_pBssidList)
        return;

    // Not support WPA yet
    EncryStatus = SiteSurvPage_GetEncryStatus();
    if (EncryStatus == Ndis802_11AuthModeWPA)
        return;

    killTimer(timerId_ConnectStatus);
    timerId_ConnectStatus = -1;

    qstrBssid = CurSelItem->text(1);
    while ( ( i = qstrBssid.find( '-', i ) ) != -1 )
        qstrBssid.remove( i ,1 );

    AtoH((char *)qstrBssid.data(), CurBssid, 6);

    pBssid = (PNDIS_WLAN_BSSID_EX)m_pBssidList->Bssid;
    //for (i = 0; i < m_nCurSelItem; i++)
    for (index = 0; index < m_pBssidList->NumberOfItems; index++)
    {
        if(memcmp(pBssid->MacAddress, CurBssid, 6) == 0)
        {
            bfound = TRUE;
            break;
        }
        pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);
    }

    if (!bfound)
        return;

    if (pBssid->Ssid.SsidLength == 0)
    {
        HiddenSsidDlg *pHiddendlg = new HiddenSsidDlg(this, "HiddenSsid", TRUE);
        QString qstrSsid;

        pHiddendlg->exec();
        if (pHiddendlg->IsClickOk())
        {
            bHiddenSsid = TRUE;
            qstrSsid = pHiddendlg->GetSsidString();
            m_SsidSet.SsidLength = qstrSsid.length();
            memcpy(m_SsidSet.Ssid, qstrSsid.data(), m_SsidSet.SsidLength);
        }
        else
            return;
    }

    // Reset all configuration value
    SiteSurvPage_ResetOidValue(pBssid->InfrastructureMode);

    // Set Infrastructure Mode
    OidSetInformation(OID_802_11_INFRASTRUCTURE_MODE, m_nSocketId, m_strDeviceName, &pBssid->InfrastructureMode, sizeof(pBssid->InfrastructureMode));

    // Set Wep Status
    if (pBssid->Privacy)
    {
        AuthSecuDlg *pAuthSecuDlg = new AuthSecuDlg(this, "AuthSecuDlg", TRUE);

        qstrAuthen = CurSelItem->text(5);
        qstrEncrypt = CurSelItem->text(4);

        if (qstrAuthen.compare("Unknown") == 0)
        {
            if (qstrEncrypt.compare("WEP") == 0)
            {
                EncryptType = Ndis802_11WEPEnabled;
                AuthenticationMode = Ndis802_11AuthModeOpen;
            }
        }
        else if (qstrAuthen.compare("WPA-PSK") == 0)
        {
            AuthenticationMode = Ndis802_11AuthModeWPAPSK;
            if (qstrEncrypt.compare("TKIP") == 0)
                EncryptType = Ndis802_11Encryption2Enabled;
            else if (qstrEncrypt.compare("AES-WRAP") == 0)
                EncryptType = Ndis802_11Encryption3Enabled;
            else if (qstrEncrypt.compare("AES-CCMP") == 0)
                EncryptType = Ndis802_11Encryption3Enabled;
        }
        else if (qstrAuthen.compare("WPA-NONE") == 0)
        {
            AuthenticationMode = Ndis802_11AuthModeWPANone;
            if (qstrEncrypt.compare("TKIP") == 0)
                EncryptType = Ndis802_11Encryption2Enabled;
            else if (qstrEncrypt.compare("AES-WRAP") == 0)
                EncryptType = Ndis802_11Encryption3Enabled;
            else if (qstrEncrypt.compare("AES-CCMP") == 0)
                EncryptType = Ndis802_11Encryption3Enabled;
        }
        else if (qstrAuthen.compare("WPA") == 0)
        {
            AuthenticationMode = Ndis802_11AuthModeWPA;
            if (qstrEncrypt.compare("TKIP") == 0)
                EncryptType = Ndis802_11Encryption2Enabled;
            else if (qstrEncrypt.compare("AES-WRAP") == 0)
                EncryptType = Ndis802_11Encryption3Enabled;
            else if (qstrEncrypt.compare("AES-CCMP") == 0)
                EncryptType = Ndis802_11Encryption3Enabled;
        }

	NDIS_802_11_NETWORK_INFRASTRUCTURE tmp = Ndis802_11Infrastructure;	
        pAuthSecuDlg->AuthSecuDlg_SetAuthModeAndEncryType(tmp, AuthenticationMode, EncryptType);
	
        pAuthSecuDlg->exec();

        if (pAuthSecuDlg->AuthSecuDlg_IsClickOk() == FALSE)
            return; //Do nothing

        AuthenticationMode = pAuthSecuDlg->AuthSecuDlg_GetAuthticationMode();
        EncryptType = pAuthSecuDlg->AuthSecuDlg_GetEncryptType();

        if ( AuthenticationMode >= Ndis802_11AuthModeAutoSwitch)
        {
            nKeyLen = 32;
            lBufLen = (sizeof(NDIS_802_11_KEY) + nKeyLen - 1);
            // Allocate Resouce
            pKey = (PNDIS_802_11_KEY)malloc(lBufLen); // Don't use GMEM_ZEROINIT to get random key
            pKey->Length = lBufLen;
            pKey->KeyLength = nKeyLen;
            pKey->KeyIndex = 0x80000000;

            strPsk = pAuthSecuDlg->AuthSecuDlg_GetPSKString();

            if (bHiddenSsid)
                PasswordHash((char *)strPsk.data(), m_SsidSet.Ssid, m_SsidSet.SsidLength, keyMaterial);
            else
                PasswordHash((char *)strPsk.data(), pBssid->Ssid.Ssid, pBssid->Ssid.SsidLength, keyMaterial);

            memcpy(pKey->KeyMaterial, keyMaterial, 32);

            // Set Authentication Mode
            if(pBssid->InfrastructureMode == Ndis802_11Infrastructure)
                AuthenticationMode = Ndis802_11AuthModeWPAPSK;
            else
                AuthenticationMode = Ndis802_11AuthModeWPANone;

            OidSetInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &AuthenticationMode, sizeof(AuthenticationMode));

            OidSetInformation(OID_802_11_ENCRYPTION_STATUS, m_nSocketId, m_strDeviceName, &EncryptType, sizeof(EncryptType));
            // Add Key
            OidSetInformation(RT_OID_802_11_ADD_WPA, m_nSocketId, m_strDeviceName, pKey, pKey->Length);

            // Free Resouce
            free(pKey);
        }
        else if ((AuthenticationMode == Ndis802_11AuthModeShared) || (EncryptType == Ndis802_11WEPEnabled))
        {
            // Set Authentication Mode
            OidSetInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &AuthenticationMode, sizeof(AuthenticationMode));

            // Set Encryption Status
            OidSetInformation(OID_802_11_ENCRYPTION_STATUS, m_nSocketId, m_strDeviceName, &EncryptType, sizeof(EncryptType));

            //----------------------------------------------------------//
            //Key 1
            //----------------------------------------------------------//
            strKey = pAuthSecuDlg->AuthSecuDlg_GetWepKeyString(0);
            nKeyLen = strKey.length();
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 0;
                for(i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 0;
                if(pAuthSecuDlg->AuthSecuDlg_GetDefaultKeyId() == 0)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strKey.length() == 5)
                    memcpy(pKey->KeyMaterial, strKey.data(), 5);
                else if(strKey.length() == 10)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 5);
                else if(strKey.length() == 13)
                    memcpy(pKey->KeyMaterial, strKey.data(), 13);
                else if(strKey.length() == 26)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
            //----------------------------------------------------------//
            //Key 2
            //----------------------------------------------------------//
            strKey = pAuthSecuDlg->AuthSecuDlg_GetWepKeyString(1);
            nKeyLen = strKey.length();
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 1;
                for(i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 1;
                if(pAuthSecuDlg->AuthSecuDlg_GetDefaultKeyId() == 1)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strKey.length() == 5)
                    memcpy(pKey->KeyMaterial, strKey.data(), 5);
                else if(strKey.length() == 10)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 5);
                else if(strKey.length() == 13)
                    memcpy(pKey->KeyMaterial, strKey.data(), 13);
                else if(strKey.length() == 26)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
            //----------------------------------------------------------//
            //Key 3
            //----------------------------------------------------------//
            strKey = pAuthSecuDlg->AuthSecuDlg_GetWepKeyString(2);
            nKeyLen = strKey.length();
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 2;
                for(i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 2;
                if(pAuthSecuDlg->AuthSecuDlg_GetDefaultKeyId() == 2)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strKey.length() == 5)
                    memcpy(pKey->KeyMaterial, strKey.data(), 5);
                else if(strKey.length() == 10)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 5);
                else if(strKey.length() == 13)
                    memcpy(pKey->KeyMaterial, strKey.data(), 13);
                else if(strKey.length() == 26)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
            //----------------------------------------------------------//
            //Key 4
            //----------------------------------------------------------//
            strKey = pAuthSecuDlg->AuthSecuDlg_GetWepKeyString(3);
            nKeyLen = strKey.length();
            if(nKeyLen == 0)
            {
                removeKey.Length = sizeof(NDIS_802_11_REMOVE_KEY);
                removeKey.KeyIndex = 3;
                for(i = 0; i < 6; i++)
                    removeKey.BSSID[i] = 0xff;
                OidSetInformation(OID_802_11_REMOVE_KEY, m_nSocketId, m_strDeviceName, &removeKey, removeKey.Length);
            }
            else
            {
                if(nKeyLen == 10)
                    nKeyLen = 5;
                else if(nKeyLen == 26)
                    nKeyLen = 13;

                lBufLen = sizeof(NDIS_802_11_KEY) + nKeyLen - 1;
                // Allocate Resource
                pKey = (PNDIS_802_11_KEY)malloc(lBufLen);
                pKey->Length = lBufLen;
                pKey->KeyLength = nKeyLen;
                pKey->KeyIndex = 3;
                if(pAuthSecuDlg->AuthSecuDlg_GetDefaultKeyId() == 3)
                    pKey->KeyIndex |= 0x80000000;
                for(i = 0; i < 6; i++)
                    pKey->BSSID[i] = 0xff;

                if(strKey.length() == 5)
                    memcpy(pKey->KeyMaterial, strKey.data(), 5);
                else if(strKey.length() == 10)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 5);
                else if(strKey.length() == 13)
                    memcpy(pKey->KeyMaterial, strKey.data(), 13);
                else if(strKey.length() == 26)
                    AtoH((char *)strKey.data(), pKey->KeyMaterial, 13);

                OidSetInformation(OID_802_11_ADD_KEY, m_nSocketId, m_strDeviceName, pKey, pKey->Length);
                free(pKey);
            }
        }
        else
        {
            // Set Authentication Mode
            OidSetInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &AuthenticationMode, sizeof(AuthenticationMode));

            // Set Encryption Status
            OidSetInformation(OID_802_11_ENCRYPTION_STATUS, m_nSocketId, m_strDeviceName, &EncryptType, sizeof(EncryptType));
        }
    }
    else
    {
        // Set Authentication Mode
        OidSetInformation(OID_802_11_AUTHENTICATION_MODE, m_nSocketId, m_strDeviceName, &AuthenticationMode, sizeof(AuthenticationMode));

        // Set Encryption Status
        OidSetInformation(OID_802_11_ENCRYPTION_STATUS, m_nSocketId, m_strDeviceName, &EncryptType, sizeof(EncryptType));
    }

    SiteSurvPage_LineEdit_Status->setText("Connecting");


    if (!bHiddenSsid)
        memcpy(&m_SsidSet, &pBssid->Ssid, sizeof(NDIS_802_11_SSID)); // Prepare SSID for retry after retry 5 times BSSID

    if ((pBssid->InfrastructureMode == Ndis802_11IBSS) || bHiddenSsid) // Ad hoc use SSID
    {
        // Set SSID
        OidSetInformation(OID_802_11_SSID, m_nSocketId, m_strDeviceName, &m_SsidSet, sizeof(m_SsidSet));
        m_bSetSsid = TRUE;
        m_bSetBssid = FALSE;
    }
    else
    {
        memcpy(m_BssidSet, pBssid->MacAddress, sizeof(NDIS_802_11_MAC_ADDRESS));
        // Set BSSID
        OidSetInformation(OID_802_11_BSSID, m_nSocketId, m_strDeviceName, m_BssidSet, sizeof(NDIS_802_11_MAC_ADDRESS));
        m_bSetBssid = TRUE;
        m_bSetSsid = FALSE;
    }

    m_bUpdateProfilePage = TRUE;
    m_bUpdateLinkSatusPage = TRUE;
    timerId_ConnectStatus = startTimer(2000);
#endif
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnConnect()<==\n");    
}

void RaPropSheet::SiteSurvPage_ButtonShowHide()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_ButtonShowHide()==>\n");

	
	if(G_bRadio && !m_bRescan)
	        SiteSurvPage_PushButton_Rescan->setEnabled( TRUE );
	else
	        SiteSurvPage_PushButton_Rescan->setEnabled( FALSE );

	UINT nWPA = SiteSurvPage_IsItemWPA();

	if(m_bRescan || !G_bRadio || SiteSurvPage_ListView->childCount() <= 0 || 
		(!G_bWpaCapable && (nWPA == Auth_Mode_WPA || nWPA == Auth_Mode_WPA_NONE || 
		nWPA == Auth_Mode_WPA_PSK || nWPA == Auth_Mode_WPA2 || nWPA == Auth_Mode_WPA2_PSK)))
	{
		SiteSurvPage_PushButton_Connect->setEnabled(FALSE);	
		SiteSurvPage_PushButton_AddProfile->setEnabled(FALSE);	
	}
	else
	{
		SiteSurvPage_PushButton_Connect->setEnabled(TRUE);

		if(G_bUserAdmin)
			SiteSurvPage_PushButton_AddProfile->setEnabled(TRUE);
		else
			SiteSurvPage_PushButton_AddProfile->setEnabled(FALSE);
	}
	    
#if 0    
    NDIS_802_11_AUTHENTICATION_MODE    EncrypType;

    if (G_bRadio)
        SiteSurvPage_PushButton_Rescan->setEnabled( TRUE );
    else
        SiteSurvPage_PushButton_Rescan->setEnabled( FALSE );

    EncrypType = SiteSurvPage_GetEncryStatus();
    if ((!G_bRadio) || (SiteSurvPage_ListView->childCount() <= 0) || 
        (EncrypType == Ndis802_11AuthModeAutoSwitch) ||
        (EncrypType == Ndis802_11AuthModeWPA)  || 
        (EncrypType == Ndis802_11AuthModeWPANone) ||
        (EncrypType == Ndis802_11AuthModeMax))
    {
        SiteSurvPage_PushButton_Connect->setEnabled( FALSE );
        SiteSurvPage_PushButton_AddProfile->setEnabled( FALSE );
    }
    else
    {
        if(G_bUserAdmin)
        {
            SiteSurvPage_PushButton_Connect->setEnabled( TRUE );
            SiteSurvPage_PushButton_AddProfile->setEnabled( TRUE );
        }
        else
        {
            SiteSurvPage_PushButton_Connect->setEnabled( FALSE );
            SiteSurvPage_PushButton_AddProfile->setEnabled( FALSE );
        }
    }
#endif

    DebugPrint("<func>RaPropSheet::SiteSurvPage_ButtonShowHide()<==\n");
    
}

void RaPropSheet::SiteSurvPage_OnAddToProfile()
{

    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnAddToProfile()==>\n");

	int i;

	if(!G_bUserAdmin)
	{
		return; // It should not come here, the AddToProfile button is enabled when the user is Administrator.
	}


    	QListViewItem                       *selectedItem;	
	int				nTotalItemNum;
    	QListViewItem                       *listViewItem;
		
   	nTotalItemNum = SiteSurvPage_ListView->childCount();	
    	selectedItem = SiteSurvPage_ListView->selectedItem();

	// Check that Is Item selected.					
	if(selectedItem == 0)
	{
		QMessageBox::warning(this, "Warning", IDS_NOSELECTEDITEM);
		return;	
	}

	// Check that have items in m_pBssidList.
	if(m_pBssidList->NumberOfItems == 0)
	{
		return;
	}

	// Selected item's MAC-ADDRESS
	NDIS_802_11_MAC_ADDRESS CurBssid;
	QString strBssid = selectedItem->text(1);
	strBssid.remove('-');
	AtoH((char*)strBssid.data(), CurBssid, 6);
	
	DebugPrntFormat(DebugPrntBuf, "SelectedItem BSSID -> %02x-%02x-%02x-%02x-%02x-%02x\n",  CurBssid[0], CurBssid[1], CurBssid[2], CurBssid[3], CurBssid[4], CurBssid[5]);
	DebugPrint(DebugPrntBuf);

	
	// Selected Item's mapping record in m_pBssidList
	PNDIS_WLAN_BSSID_EX pBssid = m_pBssidList->Bssid;
	
    	listViewItem = SiteSurvPage_ListView->firstChild();
		
	for(int i = 0; i < m_pBssidList->NumberOfItems; i ++)
	{
		if(memcmp(pBssid->MacAddress, CurBssid, 6) == 0)
		{
			break;
		}
		pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);
	}


	// Selected item's SSID
	QString strSSID = (char*)pBssid->Ssid.Ssid;
	strSSID = strSSID.left(pBssid->Ssid.SsidLength);


	// Selected item's network type
	int nNetworkType = pBssid->InfrastructureMode;

	// Selected item's Channel
	int nChannel = -1;
	for(i = 0; i < G_nChanFreqCount; i++)
	{
		if(pBssid->Configuration.DSConfig == ChannelFreqTable[i].lFreq)
		{
			nChannel = ChannelFreqTable[i].lChannel;
			break;
		}
	}

       if(nChannel == -1)
	{
		ASSERT(FALSE);
		nChannel = ChannelFreqTable[0].lChannel;
	}



	// assign Authentication Mode & Encryption Status
	UINT nWPA = Auth_Mode_UNKNOWN;
	NDIS_802_11_AUTHENTICATION_MODE enumAuthMode = Ndis802_11AuthModeOpen;
	NDIS_802_11_ENCRYPTION_STATUS enumEncryStatus = Ndis802_11EncryptionDisabled;
	
	if(pBssid->Privacy)
		enumEncryStatus = Ndis802_11Encryption1Enabled;
	
	nWPA = SiteSurvPage_IsItemWPA();
	
	if(nWPA == Auth_Mode_WPA)
	{
		enumAuthMode = Ndis802_11AuthModeWPA;
		QString strEncryStatus = selectedItem->text(4);
		if(strEncryStatus.compare(IDS_ENCRY_TYPE_TKIP) != 0) // for AES
			enumEncryStatus = Ndis802_11Encryption3Enabled;
		else
			enumEncryStatus = Ndis802_11Encryption2Enabled;
	}
	else if(nWPA == Auth_Mode_WPA_PSK)
	{
		enumAuthMode = Ndis802_11AuthModeWPAPSK;
		QString strEncryStatus = selectedItem->text(4);
		if(strEncryStatus.compare(IDS_ENCRY_TYPE_TKIP) != 0) // for AES
			enumEncryStatus = Ndis802_11Encryption3Enabled;
		else
			enumEncryStatus = Ndis802_11Encryption2Enabled;
	}
	else if(nWPA == Auth_Mode_WPA_NONE)
	{
		enumAuthMode = Ndis802_11AuthModeWPANone;
		QString strEncryStatus = selectedItem->text(4);
		if(strEncryStatus.compare(IDS_ENCRY_TYPE_TKIP) != 0) // for AES
			enumEncryStatus = Ndis802_11Encryption3Enabled;
		else
			enumEncryStatus = Ndis802_11Encryption2Enabled;
	}
	else if(nWPA == Auth_Mode_WPA2)
	{
		//if(G_osVersion == Win2000 || G_osVersion == WinXP)
			enumAuthMode = Ndis802_11AuthModeWPA2;
		//else
		//	enumAuthMode = Ndis802_11AuthModeWPA;
		QString strEncryStatus = selectedItem->text(4);
		if(strEncryStatus.compare(IDS_ENCRY_TYPE_TKIP) != 0) // for AES
			enumEncryStatus = Ndis802_11Encryption3Enabled;
		else
			enumEncryStatus = Ndis802_11Encryption2Enabled;
	}
	else if(nWPA == Auth_Mode_WPA2_PSK)
	{
		//if(G_osVersion == Win2000 || G_osVersion == WinXP)
			enumAuthMode = Ndis802_11AuthModeWPA2PSK;
		//else
		//	enumAuthMode = Ndis802_11AuthModeWPAPSK;
		QString strEncryStatus = selectedItem->text(4);
		if(strEncryStatus.compare(IDS_ENCRY_TYPE_TKIP) != 0) // for AES
			enumEncryStatus = Ndis802_11Encryption3Enabled;
		else
			enumEncryStatus = Ndis802_11Encryption2Enabled;
	}


// This is Windows Code, 
//	if(ProfilePage_AddProfile(strSSID, enumEncryStatus, enumAuthMode, nNetworkType, nChannel) == TRUE)
//		TabWidgetRaConfig->setCurrentPage(0);

    AddProfileDlg                           *pAddProfileDlg;

    pAddProfileDlg = new AddProfileDlg(m_nSocketId, m_strDeviceName, this, "AddProfile", PROFILE_ADD, ProfilePage_ListView, &m_pProfileSetting, &CurBssid, TRUE);
//    if (bHiddenSsid)
//        pAddProfileDlg->Config_SetCurrentSSID(qstrSsid);
    pAddProfileDlg->Security_SetAuthModeAndEncryType(pBssid->InfrastructureMode, enumAuthMode, enumEncryStatus);
    pAddProfileDlg->exec();

    if (pAddProfileDlg->IsOk())
    {
        ProfilePage_WriteProfileToFile();
        
        if (ProfilePage_ListView->childCount() == 0 )
        {
            ProfilePage_PushButton_Delete->setEnabled(FALSE);
            ProfilePage_PushButton_Edit->setEnabled(FALSE);
            ProfilePage_PushButton_Activate->setEnabled(FALSE);
        }
        else
        {
            ProfilePage_PushButton_Delete->setEnabled(TRUE);
            ProfilePage_PushButton_Edit->setEnabled(TRUE);
            ProfilePage_PushButton_Activate->setEnabled(TRUE);
        }

        TabWidgetRaConfig->setCurrentPage(0);
    }
    delete pAddProfileDlg;
	
#if 0    

    AddProfileDlg                           *pAddProfileDlg;
    QListViewItem                           *selectedItem;
    PNDIS_WLAN_BSSID_EX                     pBssid;
    NDIS_802_11_MAC_ADDRESS                 CurBssid;
    NDIS_802_11_AUTHENTICATION_MODE         AuthenticationMode = Ndis802_11AuthModeOpen;
    NDIS_802_11_ENCRYPTION_STATUS           EncryptType = Ndis802_11WEPDisabled;
    QString                                 qstrSsid;
    QString                                 qstrBssid;
    QString                                 qstrAuthen;
    QString                                 qstrEncrypt;
    char                                    strSSID[NDIS_802_11_LENGTH_SSID + 1];
    ULONG                                   index;
    int                                     nChannel;
    int                                     i = 0;
    bool                                    bfound = FALSE;
    bool                                    bHiddenSsid = FALSE;

    if (!G_bUserAdmin)
        return;

    selectedItem = SiteSurvPage_ListView->selectedItem();
    if (!selectedItem)
    {
        QMessageBox::warning(this, "Warning", "No selected Item!");
        return;
    }

    if (!m_pBssidList)
        return;

    qstrBssid = selectedItem->text(1);
    while ( ( i = qstrBssid.find( '-', i ) ) != -1 )
        qstrBssid.remove( i ,1 );

    AtoH((char *)qstrBssid.data(), CurBssid, 6);

    pBssid = (PNDIS_WLAN_BSSID_EX) m_pBssidList->Bssid;
    for (index = 0; index < m_pBssidList->NumberOfItems; index++)
    {
        if (memcmp(pBssid->MacAddress, CurBssid, 6) == 0)
        {
            bfound = TRUE;
            break;
        }
        pBssid = (PNDIS_WLAN_BSSID_EX)((char *)pBssid + pBssid->Length);
    }
    
    if (!bfound)
        return;

    memset(strSSID, 0x00, NDIS_802_11_LENGTH_SSID + 1);
    memcpy(strSSID, pBssid->Ssid.Ssid, pBssid->Ssid.SsidLength);

    nChannel = -1;

    for (i = 0; i < G_nChanFreqCount; i++)
    {
        if (pBssid->Configuration.DSConfig == ChannelFreqTable[i].lFreq)
        {
            nChannel = ChannelFreqTable[i].lChannel;
            break;
        }
    }

    if(nChannel == -1)
        return;

    qstrAuthen = selectedItem->text(5);
    qstrEncrypt = selectedItem->text(4);

    if (qstrAuthen.compare("Unknown") == 0)
    {
        if (qstrEncrypt.compare("WEP") == 0)
        {
            EncryptType = Ndis802_11WEPEnabled;
            AuthenticationMode = Ndis802_11AuthModeOpen;
        }
    }
    else if (qstrAuthen.compare("WPA-PSK") == 0)
    {
        AuthenticationMode = Ndis802_11AuthModeWPAPSK;
        if (qstrEncrypt.compare("TKIP") == 0)
            EncryptType = Ndis802_11Encryption2Enabled;
        else if (qstrEncrypt.compare("AES-WRAP") == 0)
            EncryptType = Ndis802_11Encryption3Enabled;
        else if (qstrEncrypt.compare("AES-CCMP") == 0)
            EncryptType = Ndis802_11Encryption3Enabled;
    }
    else if (qstrAuthen.compare("WPA-NONE") == 0)
    {
        AuthenticationMode = Ndis802_11AuthModeWPANone;
        if (qstrEncrypt.compare("TKIP") == 0)
            EncryptType = Ndis802_11Encryption2Enabled;
        else if (qstrEncrypt.compare("AES-WRAP") == 0)
            EncryptType = Ndis802_11Encryption3Enabled;
        else if (qstrEncrypt.compare("AES-CCMP") == 0)
            EncryptType = Ndis802_11Encryption3Enabled;
    }
    else if (qstrAuthen.compare("WPA") == 0)
    {
        AuthenticationMode = Ndis802_11AuthModeWPA;
        if (qstrEncrypt.compare("TKIP") == 0)
            EncryptType = Ndis802_11Encryption2Enabled;
        else if (qstrEncrypt.compare("AES-WRAP") == 0)
            EncryptType = Ndis802_11Encryption3Enabled;
        else if (qstrEncrypt.compare("AES-CCMP") == 0)
            EncryptType = Ndis802_11Encryption3Enabled;
    }

    if (pBssid->Ssid.SsidLength == 0)
    {
        HiddenSsidDlg *pHiddendlg = new HiddenSsidDlg(this, "HiddenSsid", TRUE);

        pHiddendlg->exec();
        if (pHiddendlg->IsClickOk())
        {
            qstrSsid = pHiddendlg->GetSsidString();
            bHiddenSsid = TRUE;
        }
        else
            return;
    }

    pAddProfileDlg = new AddProfileDlg(m_nSocketId, m_strDeviceName, this, "AddProfile", PROFILE_ADD, ProfilePage_ListView, &m_pProfileSetting, &CurBssid, TRUE);
    if (bHiddenSsid)
        pAddProfileDlg->Config_SetCurrentSSID(qstrSsid);
    pAddProfileDlg->Security_SetAuthModeAndEncryType(pBssid->InfrastructureMode, AuthenticationMode, EncryptType);
    pAddProfileDlg->exec();

    if (pAddProfileDlg->IsOk())
    {
        ProfilePage_WriteProfileToFile();
        
        if (ProfilePage_ListView->childCount() == 0 )
        {
            ProfilePage_PushButton_Delete->setEnabled(FALSE);
            ProfilePage_PushButton_Edit->setEnabled(FALSE);
            ProfilePage_PushButton_Activate->setEnabled(FALSE);
        }
        else
        {
            ProfilePage_PushButton_Delete->setEnabled(TRUE);
            ProfilePage_PushButton_Edit->setEnabled(TRUE);
            ProfilePage_PushButton_Activate->setEnabled(TRUE);
        }

        TabWidgetRaConfig->setCurrentPage(0);
    }
    delete pAddProfileDlg;
	
#endif

    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnAddToProfile()<==\n");
    
}

void RaPropSheet::SiteSurvPage_OnSelectChange()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnSelectChange()==>\n");

    SiteSurvPage_ButtonShowHide();
    
    DebugPrint("<func>RaPropSheet::SiteSurvPage_OnSelectChange()<==\n");    
}

NDIS_802_11_AUTHENTICATION_MODE RaPropSheet::SiteSurvPage_GetEncryStatus()
{
    DebugPrint("<func>RaPropSheet::SiteSurvPage_GetEncryStatus()==>\n");
    
    QListViewItem                       *selectedItem;
    QString                             qstrAuthenMode;
    QString                             qstrEncrypType;
    NDIS_802_11_AUTHENTICATION_MODE     status = Ndis802_11AuthModeWPANone;

	selectedItem = SiteSurvPage_ListView->selectedItem();
	if (!selectedItem)
        return (status);

    qstrAuthenMode = selectedItem->text(5);
    qstrEncrypType = selectedItem->text(4);
    if (qstrAuthenMode.compare("Unknown") == 0)
    {
        if (qstrEncrypType.compare("WEP") == 0)
            status = Ndis802_11AuthModeOpen;
        else if (qstrEncrypType.compare("Not Use") == 0)
            status = Ndis802_11AuthModeOpen;
    }
    else if (qstrAuthenMode.compare("Shared Key") == 0)
        status = Ndis802_11AuthModeShared;
    else if (qstrAuthenMode.compare("WPA") == 0)
        status = Ndis802_11AuthModeWPA;
    else if (qstrAuthenMode.compare("WPA-PSK") == 0)
        status = Ndis802_11AuthModeWPAPSK;
    else if (qstrAuthenMode.compare("WPA-NONE") == 0)
        status = Ndis802_11AuthModeWPANone;
    else 
        status = Ndis802_11AuthModeMax;

	
    DebugPrint("<func>RaPropSheet::SiteSurvPage_GetEncryStatus()<==\n");
	
    return (status);
}

UINT RaPropSheet::SiteSurvPage_IsItemWPA()
{
    QListViewItem                       *selectedItem;
    QString                             qstrAuthenMode;
          
    selectedItem = SiteSurvPage_ListView->selectedItem();
	
    if(selectedItem == 0)
	return Auth_Mode_UNKNOWN;
	

    {
	qstrAuthenMode = selectedItem->text(5);
	
	// use find 
	if(qstrAuthenMode.find(IDS_AUTH_TYPE_WPA2_PSK) != -1)
		return Auth_Mode_WPA2_PSK;
	else if(qstrAuthenMode.find(IDS_AUTH_TYPE_WPA2_0) != -1)
		return Auth_Mode_WPA2;
	else if(qstrAuthenMode.find(IDS_AUTH_TYPE_WPA_PSK) != -1)
		return Auth_Mode_WPA_PSK;
	else if(qstrAuthenMode.find(IDS_AUTH_TYPE_WPA_NONE) != -1)
		return Auth_Mode_WPA_NONE;
	else if(qstrAuthenMode.find(IDS_AUTH_TYPE_WPA_0) != -1)
		return Auth_Mode_WPA;
	else
		return Auth_Mode_UNKNOWN;
    }
}
