/*
 ***************************************************************************
 * Ralink Tech Inc.
 * 4F, No. 2 Technology 5th Rd.
 * Science-based Industrial Park
 * Hsin-chu, Taiwan, R.O.C.
 *
 * (c) Copyright 2002, Ralink Technology, Inc.
 *
 * All rights reserved. Ralink's source code is an unpublished work and the
 * use of a copyright notice does not imply otherwise. This source code
 * contains confidential trade secret material of Ralink Tech. Any attemp
 * or participation in deciphering, decoding, reverse engineering or in any
 * way altering the source code is stricitly prohibited, unless the prior
 * written consent of Ralink Technology, Inc. is obtained.
 ***************************************************************************/

#ifndef _STRUCTDEF_H_
#define _STRUCTDEF_H_


#define NDIS_VERSION_51				0x0501
#define WPA_OUI_TYPE				0x01F25000
#define WPA_OUI						0x00F25000
#define WPA2_OUI					0x00AC0F00

#define RTS_MAX						2347
#define RTS_SLIDER_MAX				2312
#define RTS_SLIDER_MIN				0
#define RTS_SLIDER_LINE				32
#define RTS_SLIDER_PAGE				256

#define FRAG_MAX					2346
#define FRAG_SLIDER_MAX				2312
#define FRAG_SLIDER_MIN				256
#define FRAG_SLIDER_LINE			32
#define FRAG_SLIDER_PAGE			256

#define REGISTER_TYPE_MAC			0
#define REGISTER_TYPE_BBP			1
#define REGISTER_TYPE_RF			2

#define REGSTR_COUNTRYREGION_FCC	0	// FCC, CH1-11
#define REGSTR_COUNTRYREGION_IC		1	// IC (Canada), CH1-11
#define REGSTR_COUNTRYREGION_ETSI	2	// ETSI, CH1-13
#define REGSTR_COUNTRYREGION_SPAIN	3	// SPAIN, CH10-11
#define REGSTR_COUNTRYREGION_FRANCE	4	// FRANCE, CH10-13
#define REGSTR_COUNTRYREGION_MKK	5	// MKK, CH14
#define REGSTR_COUNTRYREGION_MKK1	6	// MKK1(TELEC), CH1-14
#define REGSTR_COUNTRYREGION_ISRAEL	7	// ISRAEL, CH3-9

//----------------------------------

#define Auth_Mode_UNKNOWN			0
#define Auth_Mode_WPA				1
#define Auth_Mode_WPA_PSK			2
#define Auth_Mode_WPA_NONE			3
#define Auth_Mode_WPA2				4
#define Auth_Mode_WPA2_PSK			5

//----------------------------------

#define SITE_STATUS_CONNECTED		0

//----------------------------------

#define WEP_KEY_TYPE_HEX			0
#define WEP_KEY_TYPE_ASCII			1

//----------------------------------

typedef enum _AUTHEN_PROTOCOL {
	Peap,
	Tls,
	Ttls,
//	Leap,
	Md5,
} AUTHEN_PROTOCOL, *PAUTHEN_PROTOCOL;

typedef struct _WPA_INFO {
//	AUTHEN_PROTOCOL enumAuthenProtocol;
//    AcEnumTunneled  enumTunnel;
	int				nSessionResumption;
    QString         strID;
    QString         strPassword;
    QString         strTunnelID;
    QString         strTunnelPassword;
	int				nPasswordMode;
	BOOL			bClientCert;
	BOOL			bServerCert;
	BOOL			bIntermidiateCert;
	QString			strServerName;
	int				nServerNameRule;
//    AcBlobKeyStruct CA_cert;
//    AcBlobKeyStruct user_cert;
}WPA_INFO, *PWPA_INFO;

typedef struct _PROFILE_DATA {
	BOOL								bBssid;
	NDIS_802_11_SSID					SSID;
    NDIS_802_11_MAC_ADDRESS             BSSID;
    UCHAR                               Reserved[2];
	NDIS_802_11_NETWORK_INFRASTRUCTURE	enumNetworkType;
	RT_802_11_PREAMBLE					enumPreamType;
	NDIS_802_11_RTS_THRESHOLD			lRtsThre;
	NDIS_802_11_FRAGMENTATION_THRESHOLD	lFragThre;
	NDIS_802_11_AUTHENTICATION_MODE		enumAuthenMode;
	NDIS_802_11_ENCRYPTION_STATUS		enumEncryStatus;
	ULONG								lTxPower;
	PNDIS_802_11_KEY					pWPAKey;
	ULONG								lWPAKeyLen;
	PNDIS_802_11_KEY					pWEPKey1;
	ULONG								lWEPKey1Len;
	PNDIS_802_11_KEY					pWEPKey2;
	ULONG								lWEPKey2Len;
	PNDIS_802_11_KEY					pWEPKey3;
	ULONG								lWEPKey3Len;
	PNDIS_802_11_KEY					pWEPKey4;
	ULONG								lWEPKey4Len;
	NDIS_802_11_POWER_MODE				enumPSMode;
	BOOL								bACCam;
	ULONG								lFreq;
	BOOL								bSetAdvance;
	NDIS_802_11_RATES					aryRates;
	RT_802_11_STA_CONFIG				configSta;
	BOOL								bDisassociate;
	// 802.1x Setting
/*	
	BOOL			b8021X;
	AUTHEN_PROTOCOL enumAuthenProtocol;
    AcEnumTunneled  enumTunnel;
	int				nSessionResumption;
	BOOL			bClientCert;
	BOOL			bServerCert;
	BOOL			bIntermidiateCert;
	int				nServerNameRule;
    TCHAR			chID[128];
    TCHAR			chPassword[128];
    TCHAR			chTunnelID[128];
    TCHAR			chTunnelPassword[128];
    TCHAR			chServerName[128];
*/    
	char			chPskKey[64];
	int				nPskKeyLen;
/*	
	int				nPasswordMode;
    AcBlobKeyStruct CA_cert;
    AcBlobKeyStruct user_cert;
*/    
	LEAP_AUTH_INFO  infoLeapAuth;
/*	
	CCX2_CONTROL	infoCCX20;
*/	
	
} PROFILE_DATA, *PPROFILE_DATA;

//----------------------------------

typedef enum _ACTION_TYPE {
	BssidListScan,
	Profile,
	SSID,
	BSSID
} ACTION_TYPE, *PACTION_TYPE;

typedef struct _ACTION_DATA {
	ACTION_TYPE enumActionType;
	PVOID pActionBuffer;
} ACTION_DATA, *PACTION_DATA;

//----------------------------------

typedef struct _EXTRA_INFO_DATA 
{
	ULONG	nExtraInfoDef;
	char*	nExtraInfoString;
} EXTRA_INFO_DATA, *PEXTRA_INFO_DATA;

//CertDescription

#endif // _STRUCTDEF_H_
