#include "authsecudlg.h"
#include "ids.h"
#include "DebugPrint.h"

#include <qvariant.h>
#include <qbuttongroup.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>


extern BOOL		G_bWpaCapable;
extern NDIS_802_11_ENCRYPTION_STATUS G_encryCapa;

extern char DebugPrntBuf[DEBUG_PRINT_BUF_MAX_LEN];

/* 
 *  Constructs a Security which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
AuthSecuDlg::AuthSecuDlg( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
        setName( "AuthSecuDlg" );
    resize( 580, 325 ); 
    setMinimumSize( 580, 325 );
    setMaximumSize( 580, 325 );
    setCaption("Authentication & AuthSecuDlg"); 

    
    //--------------------------------------------------------------------------
        
    AuthSecuDlg_PushButton_Enable802Dot1X = new QPushButton( this, "AuthSecuDlg_PushButton_Enable802Dot1X" );
    AuthSecuDlg_PushButton_Enable802Dot1X->setGeometry( QRect( 330, 10, 110, 30 ) );

    AuthSecuDlg_PushButton_802Dot1XSetting = new QPushButton( this, "AuthSecuDlg_PushButton_802Dot1XSetting" );
    AuthSecuDlg_PushButton_802Dot1XSetting->setGeometry( QRect( 330, 50, 110, 30 ) );

    AuthSecuDlg_Label_PSK = new QLabel( this, "AuthSecuDlg_Label_PSK" );
    AuthSecuDlg_Label_PSK->setGeometry( QRect( 20, 110, 133, 21 ) );

    AuthSecuDlg_LineEdit_PSK = new QLineEdit( this, "AuthSecuDlg_LineEdit_PSK" );
    AuthSecuDlg_LineEdit_PSK->setEnabled( FALSE );
    AuthSecuDlg_LineEdit_PSK->setGeometry( QRect( 170, 110, 270, 21 ) );

    AuthSecuDlg_PushButton_OK = new QPushButton( this, "AuthSecuDlg_PushButton_OK" );
    AuthSecuDlg_PushButton_OK->setGeometry( QRect( 120, 290, 80, 30 ) );

    AuthSecuDlg_PushButton_Cancel = new QPushButton( this, "AuthSecuDlg_PushButton_Cancel" );
    AuthSecuDlg_PushButton_Cancel->setGeometry( QRect( 240, 290, 80, 30 ) );

    AuthSecuDlg_ComboBox_AuthType = new QComboBox( FALSE, this, "AuthSecuDlg_ComboBox_AuthType" );
    AuthSecuDlg_ComboBox_AuthType->setGeometry( QRect( 170, 20, 80, 21 ) );

    AuthSecuDlg_ComboBox_EncryptType = new QComboBox( FALSE, this, "AuthSecuDlg_ComboBox_EncryptType" );
    AuthSecuDlg_ComboBox_EncryptType->setGeometry( QRect( 170, 50, 80, 20 ) );

    AuthSecuDlg_Label_EncryptType = new QLabel( this, "AuthSecuDlg_Label_EncryptType" );
    AuthSecuDlg_Label_EncryptType->setGeometry( QRect( 20, 50, 120, 21 ) );

    AuthSecuDlg_Label_LeapPassword = new QLabel( this, "AuthSecuDlg_Label_LeapPassword" );
    AuthSecuDlg_Label_LeapPassword->setGeometry( QRect( 70, 180, 120, 21 ) );

    AuthSecuDlg_Label_LeapId = new QLabel( this, "AuthSecuDlg_Label_LeapId" );
    AuthSecuDlg_Label_LeapId->setGeometry( QRect( 70, 130, 120, 21 ) );

    AuthSecuDlg_LineEdit_LeapId = new QLineEdit( this, "AuthSecuDlg_LineEdit_LeapId" );
    AuthSecuDlg_LineEdit_LeapId->setGeometry( QRect( 190, 130, 200, 21 ) );

    AuthSecuDlg_LineEdit_LeapPassword = new QLineEdit( this, "AuthSecuDlg_LineEdit_LeapPassword" );
    AuthSecuDlg_LineEdit_LeapPassword->setGeometry( QRect( 190, 180, 200, 21 ) );

    AuthSecuDlg_ButtonGroup_Key = new QButtonGroup( this, "AuthSecuDlg_ButtonGroup_Key" );
    AuthSecuDlg_ButtonGroup_Key->setGeometry( QRect( 10, 140, 431, 140 ) );

    AuthSecuDlg_RadioButton_Key2 = new QRadioButton( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_RadioButton_Key2" );
    AuthSecuDlg_RadioButton_Key2->setGeometry( QRect( 10, 50, 70, 21 ) );

    AuthSecuDlg_RadioButton_Key3 = new QRadioButton( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_RadioButton_Key3" );
    AuthSecuDlg_RadioButton_Key3->setGeometry( QRect( 10, 80, 70, 21 ) );

    AuthSecuDlg_RadioButton_Key4 = new QRadioButton( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_RadioButton_Key4" );
    AuthSecuDlg_RadioButton_Key4->setGeometry( QRect( 10, 110, 70, 21 ) );

    AuthSecuDlg_ComboBox_KeyType2 = new QComboBox( FALSE, AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_ComboBox_KeyType2" );
    AuthSecuDlg_ComboBox_KeyType2->setGeometry( QRect( 80, 50, 91, 21 ) );

    AuthSecuDlg_ComboBox_KeyType3 = new QComboBox( FALSE, AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_ComboBox_KeyType3" );
    AuthSecuDlg_ComboBox_KeyType3->setGeometry( QRect( 80, 80, 91, 21 ) );

    AuthSecuDlg_ComboBox_KeyType4 = new QComboBox( FALSE, AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_ComboBox_KeyType4" );
    AuthSecuDlg_ComboBox_KeyType4->setGeometry( QRect( 80, 110, 91, 21 ) );

    AuthSecuDlg_LineEdit_Key1Hex = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key1Hex" );
    AuthSecuDlg_LineEdit_Key1Hex->setGeometry( QRect( 180, 20, 231, 21 ) );

    AuthSecuDlg_LineEdit_Key2Hex = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key2Hex" );
    AuthSecuDlg_LineEdit_Key2Hex->setGeometry( QRect( 180, 50, 231, 21 ) );

    AuthSecuDlg_LineEdit_Key3Hex = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key3Hex" );
    AuthSecuDlg_LineEdit_Key3Hex->setGeometry( QRect( 180, 80, 231, 21 ) );

    AuthSecuDlg_LineEdit_Key4Hex = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key4Hex" );
    AuthSecuDlg_LineEdit_Key4Hex->setGeometry( QRect( 180, 110, 231, 21 ) );

    AuthSecuDlg_ComboBox_KeyType1 = new QComboBox( FALSE, AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_ComboBox_KeyType1" );
    AuthSecuDlg_ComboBox_KeyType1->setGeometry( QRect( 80, 20, 91, 21 ) );

    AuthSecuDlg_LineEdit_Key2Ascii = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key2Ascii" );
    AuthSecuDlg_LineEdit_Key2Ascii->setGeometry( QRect( 180, 50, 231, 21 ) );

    AuthSecuDlg_LineEdit_Key3Ascii = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key3Ascii" );
    AuthSecuDlg_LineEdit_Key3Ascii->setGeometry( QRect( 180, 80, 231, 21 ) );

    AuthSecuDlg_LineEdit_Key4Ascii = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key4Ascii" );
    AuthSecuDlg_LineEdit_Key4Ascii->setGeometry( QRect( 180, 110, 231, 21 ) );

    AuthSecuDlg_LineEdit_Key1Ascii = new QLineEdit( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_LineEdit_Key1Ascii" );
    AuthSecuDlg_LineEdit_Key1Ascii->setGeometry( QRect( 180, 20, 231, 21 ) );

    AuthSecuDlg_RadioButton_Key1 = new QRadioButton( AuthSecuDlg_ButtonGroup_Key, "AuthSecuDlg_RadioButton_Key1" );
    AuthSecuDlg_RadioButton_Key1->setGeometry( QRect( 10, 20, 70, 21 ) );

    AuthSecuDlg_RadioButton_LeapWep = new QRadioButton( this, "AuthSecuDlg_RadioButton_LeapWep" );
    AuthSecuDlg_RadioButton_LeapWep->setGeometry( QRect( 110, 90, 170, 21 ) );

    AuthSecuDlg_RadioButton_LeapTkip = new QRadioButton( this, "AuthSecuDlg_RadioButton_LeapTkip" );
    AuthSecuDlg_RadioButton_LeapTkip->setGeometry( QRect( 240, 90, 270, 21 ) );

    AuthSecuDlg_Label_AuthType = new QLabel( this, "AuthSecuDlg_Label_AuthType" );
    AuthSecuDlg_Label_AuthType->setGeometry( QRect( 20, 20, 140, 21 ) );
    
    //--------------------------------------------------------------------------    
    

    AuthSecuDlg_PushButton_Enable802Dot1X->setText("Enable 802.1X");
    AuthSecuDlg_PushButton_802Dot1XSetting->setText("802.1X Setting");

    AuthSecuDlg_PushButton_Enable802Dot1X->hide();
    AuthSecuDlg_PushButton_802Dot1XSetting->hide();     
    
    AuthSecuDlg_Label_AuthType->setText("Authentication Type:");

    AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_OPENSYSTEM);
    AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_SHARED);

    AuthSecuDlg_Label_EncryptType->setText("Encryptiion Type:");

    AuthSecuDlg_ComboBox_EncryptType->insertItem("None");
    AuthSecuDlg_ComboBox_EncryptType->insertItem("WEP");

    AuthSecuDlg_Label_PSK->setText("WPA Pre-Shared Key:");

    AuthSecuDlg_LineEdit_PSK->setMaxLength(64);
    AuthSecuDlg_LineEdit_PSK->setEnabled( FALSE );

    AuthSecuDlg_ButtonGroup_Key->setTitle("WEP Key");

    AuthSecuDlg_RadioButton_Key1->setText("Key#1");
    AuthSecuDlg_RadioButton_Key1->setEnabled( FALSE );
    AuthSecuDlg_RadioButton_Key1->setChecked( TRUE );
    AuthSecuDlg_ButtonGroup_Key->insert( AuthSecuDlg_RadioButton_Key1, 0 );

    AuthSecuDlg_RadioButton_Key2->setText("Key#2");
    AuthSecuDlg_RadioButton_Key2->setEnabled( FALSE );
    AuthSecuDlg_RadioButton_Key2->setChecked( FALSE );
    AuthSecuDlg_ButtonGroup_Key->insert( AuthSecuDlg_RadioButton_Key2, 1 );

    AuthSecuDlg_RadioButton_Key3->setText("Key#3");
    AuthSecuDlg_RadioButton_Key3->setEnabled( FALSE );
    AuthSecuDlg_RadioButton_Key3->setChecked( FALSE );
    AuthSecuDlg_ButtonGroup_Key->insert( AuthSecuDlg_RadioButton_Key3, 2 );

    AuthSecuDlg_RadioButton_Key4->setText("Key#4");
    AuthSecuDlg_RadioButton_Key4->setEnabled( FALSE );
    AuthSecuDlg_RadioButton_Key4->setChecked( FALSE );
    AuthSecuDlg_ButtonGroup_Key->insert( AuthSecuDlg_RadioButton_Key4, 3 );

    AuthSecuDlg_ComboBox_KeyType1->insertItem("Hexadecimal");
    AuthSecuDlg_ComboBox_KeyType1->insertItem("Ascii");
    AuthSecuDlg_ComboBox_KeyType1->setEnabled( FALSE );

    AuthSecuDlg_ComboBox_KeyType2->insertItem("Hexadecimal");
    AuthSecuDlg_ComboBox_KeyType2->insertItem("Ascii");
    AuthSecuDlg_ComboBox_KeyType2->setEnabled( FALSE );

    AuthSecuDlg_ComboBox_KeyType3->insertItem("Hexadecimal");
    AuthSecuDlg_ComboBox_KeyType3->insertItem("Ascii");
    AuthSecuDlg_ComboBox_KeyType3->setEnabled( FALSE );

    AuthSecuDlg_ComboBox_KeyType4->insertItem("Hexadecimal");
    AuthSecuDlg_ComboBox_KeyType4->insertItem("Ascii");
    AuthSecuDlg_ComboBox_KeyType4->setEnabled( FALSE );

    m_hexValidator = new QHexValidator(this);

    AuthSecuDlg_LineEdit_Key1Hex->setMaxLength(26);
    AuthSecuDlg_LineEdit_Key1Hex->setEnabled( FALSE );
    AuthSecuDlg_LineEdit_Key1Hex->setValidator(m_hexValidator);

    AuthSecuDlg_LineEdit_Key1Ascii->setMaxLength(13);
    AuthSecuDlg_LineEdit_Key1Ascii->hide();
    AuthSecuDlg_LineEdit_Key1Ascii->setEnabled( FALSE );

    AuthSecuDlg_LineEdit_Key2Hex->setMaxLength(26);
    AuthSecuDlg_LineEdit_Key2Hex->setEnabled( FALSE );
    AuthSecuDlg_LineEdit_Key2Hex->setValidator(m_hexValidator);

    AuthSecuDlg_LineEdit_Key2Ascii->setMaxLength(13);
    AuthSecuDlg_LineEdit_Key2Ascii->hide();
    AuthSecuDlg_LineEdit_Key2Ascii->setEnabled( FALSE );

    AuthSecuDlg_LineEdit_Key3Hex->setMaxLength(26);
    AuthSecuDlg_LineEdit_Key3Hex->setEnabled( FALSE );
    AuthSecuDlg_LineEdit_Key3Hex->setValidator(m_hexValidator);
 
    AuthSecuDlg_LineEdit_Key3Ascii->setMaxLength(13);
    AuthSecuDlg_LineEdit_Key3Ascii->hide();
    AuthSecuDlg_LineEdit_Key3Ascii->setEnabled( FALSE );

    AuthSecuDlg_LineEdit_Key4Hex->setMaxLength(26);
    AuthSecuDlg_LineEdit_Key4Hex->setEnabled( FALSE );
    AuthSecuDlg_LineEdit_Key4Hex->setValidator(m_hexValidator);

    AuthSecuDlg_LineEdit_Key4Ascii->setMaxLength(13);
    AuthSecuDlg_LineEdit_Key4Ascii->hide();
    AuthSecuDlg_LineEdit_Key4Ascii->setEnabled( FALSE );


    AuthSecuDlg_PushButton_OK->setText("&OK");

    AuthSecuDlg_PushButton_Cancel->setText("&CANCEL");

    
    AuthSecuDlg_Label_LeapPassword->setText("Password");

    AuthSecuDlg_Label_LeapId->setText("Id");
     
    AuthSecuDlg_RadioButton_LeapWep->setText("WEP");
    AuthSecuDlg_RadioButton_LeapWep->setChecked(TRUE);	

    AuthSecuDlg_RadioButton_LeapTkip->setText("TKIP");
    AuthSecuDlg_RadioButton_LeapTkip->setChecked(FALSE);
	
    AuthSecuDlg_RadioButton_LeapTkip->setText("AES");
    AuthSecuDlg_RadioButton_LeapTkip->setChecked(FALSE);
	
    connect( AuthSecuDlg_PushButton_OK, SIGNAL( clicked() ), this, SLOT( OnOK() ) );
    connect( AuthSecuDlg_PushButton_Cancel, SIGNAL( clicked() ), this, SLOT( OnCancel() ) );
    connect( AuthSecuDlg_ComboBox_AuthType, SIGNAL( activated(int) ), this, SLOT( AuthSecuDlg_OnSelectAuthenType(int) ) );
    connect( AuthSecuDlg_ComboBox_EncryptType, SIGNAL( activated(int) ), this, SLOT( AuthSecuDlg_OnSelectEncryptType(int) ) );
    connect( AuthSecuDlg_ComboBox_KeyType1, SIGNAL( activated(int) ), this, SLOT( AuthSecuDlg_OnSelectKey1Type(int) ) );
    connect( AuthSecuDlg_ComboBox_KeyType2, SIGNAL( activated(int) ), this, SLOT( AuthSecuDlg_OnSelectKey2Type(int) ) );
    connect( AuthSecuDlg_ComboBox_KeyType3, SIGNAL( activated(int) ), this, SLOT( AuthSecuDlg_OnSelectKey3Type(int) ) );
    connect( AuthSecuDlg_ComboBox_KeyType4, SIGNAL( activated(int) ), this, SLOT( AuthSecuDlg_OnSelectKey4Type(int) ) );

    connect( AuthSecuDlg_RadioButton_LeapWep, SIGNAL( clicked() ), this, SLOT( OnLeapWep() ) );
    connect( AuthSecuDlg_RadioButton_LeapTkip, SIGNAL( clicked() ), this, SLOT( OnLeapTkip() ) );	
	
    connect( AuthSecuDlg_PushButton_Enable802Dot1X, SIGNAL( clicked() ), this, SLOT( OnEnableDisable802Dot1X() ) );
    connect( AuthSecuDlg_PushButton_802Dot1XSetting, SIGNAL( clicked() ), this, SLOT( On802Dot1XSetting() ) );


    m_nLeapEncryType = 0;
	
    //-----------------------
    // Need Read from File.
    
    m_bCCX20	= FALSE;
    m_bLeapCCKM = FALSE;	

    //-----------------------
    m_nKey1Type = WEP_KEY_TYPE_HEX;
    m_nKey2Type = WEP_KEY_TYPE_HEX;
    m_nKey3Type = WEP_KEY_TYPE_HEX;
    m_nKey4Type = WEP_KEY_TYPE_HEX;

    //-----------------------


	
    m_isClickOk = FALSE;
    m_b8021X = TRUE;
    
}

void AuthSecuDlg::InitCombosInDialog()
{
    DebugPrint("<func>AuthSecuDlg::InitCombosInDialog()==>\n");

        AuthSecuDlg_ComboBox_AuthType->clear();
	AuthSecuDlg_ComboBox_EncryptType->clear();
	
	AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_OPENSYSTEM);
	AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_SHARED);
    
	if(m_enumInfrastructureMode == Ndis802_11Infrastructure)
	{
		AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_LEAP);
	}

	if(G_bWpaCapable)
	{
		if(G_encryCapa >= Ndis802_11Encryption2Enabled)
		{
			if(m_enumInfrastructureMode == Ndis802_11Infrastructure)
			{
				AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_WPA_0);
				AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_WPA_PSK);
			
//				if(G_osVersion == Win2000 || G_osVersion == WinXP)
				{
					AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_WPA2_0);
					AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_WPA2_PSK);	
				}
			}
			else
			{
				AuthSecuDlg_ComboBox_AuthType->insertItem(IDS_AUTH_TYPE_WPA_NONE);
			}
		}
	}
	
	switch(m_nAuthenType)
	{
	case 0: // Open
	case 1:	// Shared
		AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_NONE);
		AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_WEP);
		break;
		
	case 2:	// LEAP WPA-NONE
		if(m_enumInfrastructureMode == Ndis802_11Infrastructure)
			break;
			
	case 3: // WPA 
	case 4: // WPA-PSK 
	case 5: // WPA2 
	case 6: // WPA2-PSK 
		switch(G_encryCapa)
		{
		case Ndis802_11Encryption2Enabled:
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_TKIP);
			break;
		case Ndis802_11Encryption3Enabled:
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_TKIP);
#if DRIVER_IS_COMPLETED_ON_AES			
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_AES);	
#endif
			break;
		default:
			;//ASSERT(FALSE);
		}
		break;
	default:
		;//ASSERT(FALSE);
	}

	AuthSecuDlg_OnSelectAuthenType(m_nAuthenType);

    DebugPrint("<func>AuthSecuDlg::InitCombosInDialog()<==\n");		
}

/*  
 *  Destroys the object and frees any allocated resources
 */
AuthSecuDlg::~AuthSecuDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

int AuthSecuDlg::AuthSecuDlg_GetWepKeyType(int index)
{
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetWepKeyType()==>\n");
    
    int                                 num;

    DebugPrntFormat(DebugPrntBuf, "index = %d\n", index);		DebugPrint(DebugPrntBuf);

    switch (index)
    {
    case 1:
        num = AuthSecuDlg_ComboBox_KeyType2->currentItem();
        break;
    case 2:
        num = AuthSecuDlg_ComboBox_KeyType3->currentItem();
        break;
    case 3:
        num = AuthSecuDlg_ComboBox_KeyType4->currentItem();
        break;
    case 0:
    default:
        num = AuthSecuDlg_ComboBox_KeyType1->currentItem();
        break;
    }

    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetWepKeyType()<==\n");
        
    return num;
}

QString AuthSecuDlg::AuthSecuDlg_GetWepKeyString(int index)
{
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetWepKeyString()==>\n");

    DebugPrntFormat(DebugPrntBuf, "index = %d\n", index);		DebugPrint(DebugPrntBuf);
	
    switch (index)
    {
    case 1:
        if ( AuthSecuDlg_GetWepKeyType(index) == 0) //Hex
            return (AuthSecuDlg_LineEdit_Key2Hex->text());
        else
            return (AuthSecuDlg_LineEdit_Key2Ascii->text());
        break;
    case 2:
        if ( AuthSecuDlg_GetWepKeyType(index) == 0) //Hex
            return (AuthSecuDlg_LineEdit_Key3Hex->text());
        else
            return (AuthSecuDlg_LineEdit_Key3Ascii->text());
        break;
    case 3:
        if ( AuthSecuDlg_GetWepKeyType(index) == 0) //Hex
            return (AuthSecuDlg_LineEdit_Key4Hex->text());
        else
            return (AuthSecuDlg_LineEdit_Key4Ascii->text());
        break;
    case 0:
    default:
        if ( AuthSecuDlg_GetWepKeyType(index) == 0) //Hex
            return (AuthSecuDlg_LineEdit_Key1Hex->text());
        else
            return (AuthSecuDlg_LineEdit_Key1Ascii->text());
        break;
    }

    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetWepKeyString()<==\n");        
}

QString AuthSecuDlg::AuthSecuDlg_GetPSKString()
{
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetPSKString()==>\n");
    
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetPSKString()<==\n");    
    return (AuthSecuDlg_LineEdit_PSK->text());
}

NDIS_802_11_AUTHENTICATION_MODE AuthSecuDlg::AuthSecuDlg_GetAuthticationMode()
{
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetAuthticationMode()==>\n");
    
    QString                             qstr;
    NDIS_802_11_AUTHENTICATION_MODE     mode = Ndis802_11AuthModeOpen;

    qstr = AuthSecuDlg_ComboBox_AuthType->currentText();
    if (qstr.compare(IDS_AUTH_TYPE_OPENSYSTEM) == 0)
        mode = Ndis802_11AuthModeOpen;
    else if (qstr.compare(IDS_AUTH_TYPE_SHARED) == 0)
        mode = Ndis802_11AuthModeShared;
    else if (qstr.compare(IDS_AUTH_TYPE_WPA_PSK) == 0)
        mode = Ndis802_11AuthModeWPAPSK;

    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetAuthticationMode()<==\n");
    	
    return (mode);
}

NDIS_802_11_ENCRYPTION_STATUS AuthSecuDlg::AuthSecuDlg_GetEncryptType()
{
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetEncryptType()==>\n");
    
    QString                             qstr;
    NDIS_802_11_ENCRYPTION_STATUS       type = Ndis802_11WEPDisabled;

    qstr = AuthSecuDlg_ComboBox_EncryptType->currentText();
    if (qstr.compare(IDS_ENCRY_TYPE_NONE) == 0)
        type = Ndis802_11WEPDisabled;
    else if (qstr.compare(IDS_ENCRY_TYPE_WEP) == 0)
        type = Ndis802_11WEPEnabled;
    else if (qstr.compare(IDS_ENCRY_TYPE_TKIP) == 0)
        type = Ndis802_11Encryption2Enabled;
    else if (qstr.compare(IDS_ENCRY_TYPE_AES) == 0)
        type = Ndis802_11Encryption3Enabled;

    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_GetEncryptType()<==\n");

    return (type);
}

void AuthSecuDlg::AuthSecuDlg_SetAuthModeAndEncryType(NDIS_802_11_NETWORK_INFRASTRUCTURE enumInfrastructureMode,NDIS_802_11_AUTHENTICATION_MODE nAuthenType, NDIS_802_11_ENCRYPTION_STATUS nEncryType)
{
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_SetAuthModeAndEncryType()==>\n");

    m_enumInfrastructureMode = enumInfrastructureMode;
    m_nAuthenType = nAuthenType;
    m_nEncryType = nEncryType;

    InitCombosInDialog();
        
    DebugPrntFormat(DebugPrntBuf, "m_enumInfrastructureMode = %d , m_nAuthenType = %d, m_nEncryType = %d\n", enumInfrastructureMode, nAuthenType, m_nEncryType);
    DebugPrint(DebugPrntBuf);
	    
    DebugPrint("<func>AuthSecuDlg::AuthSecuDlg_SetAuthModeAndEncryType()<==\n");
}

int AuthSecuDlg::AuthSecuDlg_GetDefaultKeyId()
{
    int                                 keyId;

    keyId = AuthSecuDlg_ButtonGroup_Key->id(AuthSecuDlg_ButtonGroup_Key->selected());

    return (keyId);
}

void AuthSecuDlg::AuthSecuDlg_SetDefaultKeyId(int keyId)
{
    AuthSecuDlg_ButtonGroup_Key->setButton(keyId);
}

void AuthSecuDlg::AuthSecuDlg_SetKeyTypeAndKeyString(int keyIndex, int keyType, char *keyString)
{
    switch (keyIndex)
    {
    case 0:
        if (keyType == 0) //Hex
        {
            AuthSecuDlg_ComboBox_KeyType1->setCurrentItem( 0 );
            AuthSecuDlg_LineEdit_Key1Hex->setText(keyString);
            AuthSecuDlg_LineEdit_Key1Hex->show();
            AuthSecuDlg_LineEdit_Key1Ascii->hide();
        }
        else
        {
            AuthSecuDlg_ComboBox_KeyType1->setCurrentItem( 1 );
            AuthSecuDlg_LineEdit_Key1Ascii->setText(keyString);
            AuthSecuDlg_LineEdit_Key1Ascii->show();
            AuthSecuDlg_LineEdit_Key1Hex->hide();
        }
        break;
    case 1:
        if (keyType == 0) //Hex
        {
            AuthSecuDlg_ComboBox_KeyType2->setCurrentItem( 0 );
            AuthSecuDlg_LineEdit_Key2Hex->setText(keyString);
            AuthSecuDlg_LineEdit_Key2Hex->show();
            AuthSecuDlg_LineEdit_Key2Ascii->hide();
        }
        else
        {
            AuthSecuDlg_ComboBox_KeyType2->setCurrentItem( 1 );
            AuthSecuDlg_LineEdit_Key2Ascii->setText(keyString);
            AuthSecuDlg_LineEdit_Key2Ascii->show();
            AuthSecuDlg_LineEdit_Key2Hex->hide();
        }
        break;
    case 2:
        if (keyType == 0) //Hex
        {
            AuthSecuDlg_ComboBox_KeyType3->setCurrentItem( 0 );
            AuthSecuDlg_LineEdit_Key3Hex->setText(keyString);
            AuthSecuDlg_LineEdit_Key3Hex->show();
            AuthSecuDlg_LineEdit_Key3Ascii->hide();
        }
        else
        {
            AuthSecuDlg_ComboBox_KeyType3->setCurrentItem( 1 );
            AuthSecuDlg_LineEdit_Key3Ascii->setText(keyString);
            AuthSecuDlg_LineEdit_Key3Ascii->show();
            AuthSecuDlg_LineEdit_Key3Hex->hide();
        }
        break;
    case 3:
        if (keyType == 0) //Hex
        {
            AuthSecuDlg_ComboBox_KeyType4->setCurrentItem( 0 );
            AuthSecuDlg_LineEdit_Key4Hex->setText(keyString);
            AuthSecuDlg_LineEdit_Key4Hex->show();
            AuthSecuDlg_LineEdit_Key4Ascii->hide();
        }
        else
        {
            AuthSecuDlg_ComboBox_KeyType4->setCurrentItem( 1 );
            AuthSecuDlg_LineEdit_Key4Ascii->setText(keyString);
            AuthSecuDlg_LineEdit_Key4Ascii->show();
            AuthSecuDlg_LineEdit_Key4Hex->hide();
        }
        break;
    }
}

void AuthSecuDlg::OnOK()
{
    DebugPrint("<func>AuthSecuDlg::OnOK()==>\n");

    QString                             qstrEncryp;
    QString                             qstrAuthen;
    QString                             qstr;
    int                                 keyid;
    char                                msg[255];

    qstrAuthen = AuthSecuDlg_ComboBox_AuthType->currentText();
    qstrEncryp = AuthSecuDlg_ComboBox_EncryptType->currentText();
    if (qstrAuthen.compare(IDS_AUTH_TYPE_WPA_PSK) == 0)
    { //Use WPA-PSK
        qstr = AuthSecuDlg_LineEdit_PSK->text();
        if (qstr.length() < 8)
        {
            QMessageBox::warning(this, "Warning", "Invalid WPA Pre-Shared key. WPA-PSK used field should use more than 8 characters.");
            AuthSecuDlg_LineEdit_PSK->setFocus();
            return;
        }
    }
    else if (qstrEncryp.compare("WEP") == 0)
    {
        keyid = AuthSecuDlg_ButtonGroup_Key->id(AuthSecuDlg_ButtonGroup_Key->selected());
        qstr = AuthSecuDlg_GetWepKeyString(keyid);
        if (AuthSecuDlg_GetWepKeyType(keyid) == 0)
        {//Hex
            if ((qstr.length() != 10) && (qstr.length() != 26))
            {
                sprintf(msg, "Invalid WEP KEY length. Key should be 10 or 26 hex digits!");
                QMessageBox::warning(this, "Warning", msg);
                switch (keyid)
                {
                case 0:
                    AuthSecuDlg_LineEdit_Key1Hex->setFocus();
                    break;
                case 1:
                    AuthSecuDlg_LineEdit_Key2Hex->setFocus();
                    break;
                case 2:
                    AuthSecuDlg_LineEdit_Key3Hex->setFocus();
                    break;
                case 3:
                    AuthSecuDlg_LineEdit_Key4Hex->setFocus();
                    break;
                }
                return;
            }
        }
        else
        {//Ascii
            if ((qstr.length() != 5) && (qstr.length() != 13))
            {
                sprintf(msg, "Invalid WEP KEY length. Key should be 5 or 13 ascii characters!");
                QMessageBox::warning(this, "Warning", msg);
                switch (keyid)
                {
                case 0:
                    AuthSecuDlg_LineEdit_Key1Ascii->setFocus();
                    break;
                case 1:
                    AuthSecuDlg_LineEdit_Key2Ascii->setFocus();
                    break;
                case 2:
                    AuthSecuDlg_LineEdit_Key3Ascii->setFocus();
                    break;
                case 3:
                    AuthSecuDlg_LineEdit_Key4Ascii->setFocus();
                    break;
                }
                return;
            }
        }
    }


		
	if(/*(!m_b8021X || m_wpaInfo.enumAuthenProtocol == Md5) &&*/ (m_nAuthenType == 1 || (m_nAuthenType == 0 && m_nEncryType == 1))) // Share Key or WEP On
	{
	    DebugPrint("(m_nAuthenType == 1 || (m_nAuthenType == 0 && m_nEncryType == 1))\n");
	
		if(m_nKey1Type == WEP_KEY_TYPE_HEX)
		{
			m_Key1Len = AuthSecuDlg_LineEdit_Key1Hex->text ().length();
			
			    DebugPrint("WEP_KEY_TYPE_HEX\n");
			    DebugPrntFormat(DebugPrntBuf, "m_Key1Len = %d\n", m_Key1Len);		DebugPrint(DebugPrntBuf);
			
			if(m_Key1Len == 0)
				ZeroMemory(m_chKey1Material, 14);
			else
			{
				m_Key1Len /= 2;
				m_chKey1Material[m_Key1Len] = '\0';
				AtoH((char*)AuthSecuDlg_LineEdit_Key1Hex->text ().data(), m_chKey1Material, m_Key1Len);
			}
		}
		else
		{
			m_Key1Len = AuthSecuDlg_LineEdit_Key1Ascii->text ().length();

			    DebugPrint("WEP_KEY_TYPE_ASCII\n");
			    DebugPrntFormat(DebugPrntBuf, "m_Key1Len = %d\n", m_Key1Len);		DebugPrint(DebugPrntBuf);
			
			if(m_Key1Len == 0)
				ZeroMemory(m_chKey1Material, 14);
			else
			{
				m_chKey1Material[m_Key1Len] = '\0';
				memcpy(m_chKey1Material, AuthSecuDlg_LineEdit_Key1Hex->text ().data(), m_Key1Len);
			}
		}

		if(m_nKey2Type == WEP_KEY_TYPE_HEX)
		{
			m_Key2Len = AuthSecuDlg_LineEdit_Key2Hex->text ().length();
			if(m_Key2Len == 0)
				ZeroMemory(m_chKey2Material, 14);
			else
			{
				m_Key2Len /= 2;
				m_chKey2Material[m_Key2Len] = '\0';
				AtoH((char*)AuthSecuDlg_LineEdit_Key2Hex->text ().data(), m_chKey2Material, m_Key2Len);
			}
		}
		else
		{
			m_Key2Len = AuthSecuDlg_LineEdit_Key2Ascii->text ().length();
			if(m_Key2Len == 0)
				ZeroMemory(m_chKey2Material, 14);
			else
			{
				m_chKey2Material[m_Key2Len] = '\0';
				memcpy(m_chKey2Material, AuthSecuDlg_LineEdit_Key2Hex->text ().data(), m_Key2Len);
			}
		}

		if(m_nKey3Type == WEP_KEY_TYPE_HEX)
		{
			m_Key3Len = AuthSecuDlg_LineEdit_Key3Hex->text ().length();
			if(m_Key3Len == 0)
				ZeroMemory(m_chKey3Material, 14);
			else
			{
				m_Key3Len /= 2;
				m_chKey3Material[m_Key3Len] = '\0';
				AtoH((char*)AuthSecuDlg_LineEdit_Key3Hex->text ().data(), m_chKey3Material, m_Key3Len);
			}
		}
		else
		{
			m_Key3Len = AuthSecuDlg_LineEdit_Key3Ascii->text ().length();
			if(m_Key3Len == 0)
				ZeroMemory(m_chKey3Material, 14);
			else
			{
				m_chKey3Material[m_Key3Len] = '\0';
				memcpy(m_chKey3Material, AuthSecuDlg_LineEdit_Key3Hex->text ().data(), m_Key3Len);
			}
		}

		if(m_nKey4Type == WEP_KEY_TYPE_HEX)
		{
			m_Key4Len = AuthSecuDlg_LineEdit_Key4Hex->text ().length();
			if(m_Key4Len == 0)
				ZeroMemory(m_chKey4Material, 14);
			else
			{
				m_Key4Len /= 2;
				m_chKey4Material[m_Key4Len] = '\0';
				AtoH((char*)AuthSecuDlg_LineEdit_Key4Hex->text ().data(), m_chKey4Material, m_Key4Len);
			}
		}
		else
		{
			m_Key4Len = AuthSecuDlg_LineEdit_Key4Ascii->text ().length();
			if(m_Key4Len == 0)
				ZeroMemory(m_chKey4Material, 14);
			else
			{
				m_chKey4Material[m_Key4Len] = '\0';
				memcpy(m_chKey4Material, AuthSecuDlg_LineEdit_Key4Hex->text ().data(), m_Key4Len);
			}
		}
	}


    m_isClickOk = TRUE;

    close();
	
    DebugPrint("<func>AuthSecuDlg::OnOK()<==\n");
	
}

void AuthSecuDlg::OnCancel()
{
    m_isClickOk = FALSE;
    close();
}

void AuthSecuDlg::AuthSecuDlg_OnSelectAuthenType(int id)
{

	if(m_enumInfrastructureMode == Ndis802_11Infrastructure)
	{
		if( id==2 || id==3 || id==5)
		{
			QMessageBox::warning(this, "Warning", "RaConfig don't support this authentication!");
			id=0;
		}
	}
	else
	{
	}
	
	
	
	UpdateData(TRUE);

	m_nAuthenType = (NDIS_802_11_AUTHENTICATION_MODE)id;
	AuthSecuDlg_ComboBox_AuthType->setCurrentItem( m_nAuthenType );

	QString	str;
	AuthSecuDlg_ComboBox_EncryptType->clear();

	m_b8021X = FALSE;
		
	BOOL bMay8021X = FALSE;

	switch(m_nAuthenType)
	{
	case 0: // Open
	case 1:	// Shared
		AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_NONE);
		AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_WEP);

		if(m_enumInfrastructureMode == Ndis802_11Infrastructure)
			bMay8021X = TRUE;
		break;
	case 2:	// LEAP
		switch(G_encryCapa)
		{
		case Ndis802_11Encryption2Enabled:
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_TKIP);
			break;
		case Ndis802_11Encryption3Enabled:
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_TKIP);
#if DRIVER_IS_COMPLETED_ON_AES			
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_AES);
#endif
			break;
		default:
			;//ASSERT(FALSE);
		}
		break;
	case 3: // WPA or WPA-NONE
	case 4: // WPA-PSK
	case 5: // WPA2 or WPA2-None
	case 6: // WPA2-PSK
		if((m_nAuthenType == 3 || m_nAuthenType == 5) && 
			m_enumInfrastructureMode == Ndis802_11Infrastructure) // WPA
			m_b8021X = TRUE;
		else
			m_b8021X = FALSE;
		switch(G_encryCapa)
		{
		case Ndis802_11Encryption2Enabled:
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_TKIP);		
			break;
		case Ndis802_11Encryption3Enabled:
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_TKIP);
#if DRIVER_IS_COMPLETED_ON_AES			
			AuthSecuDlg_ComboBox_EncryptType->insertItem(IDS_ENCRY_TYPE_AES);		
#endif
			break;
		default:
			;//ASSERT(FALSE);
		}
		break;
	default:
		;//ASSERT(FALSE);
	}
	if(G_bWpaCapable && bMay8021X)
    		AuthSecuDlg_PushButton_Enable802Dot1X->show();
	else
    		AuthSecuDlg_PushButton_Enable802Dot1X->hide();

	if(G_bWpaCapable)
	{
		if(m_enumInfrastructureMode == Ndis802_11Infrastructure && ((m_b8021X && (m_nAuthenType == 0 || m_nAuthenType == 1)) || m_nAuthenType == 3 || m_nAuthenType == 5)) // Open Share and WPA WPA2
			AuthSecuDlg_PushButton_802Dot1XSetting->setEnabled( TRUE );
		else
			AuthSecuDlg_PushButton_802Dot1XSetting->setEnabled( FALSE );
	}
	else
	{
		AuthSecuDlg_PushButton_802Dot1XSetting->setEnabled( FALSE );	
	}

	UpdateData(FALSE);
	AuthSecuDlg_OnSelectEncryptType(m_nEncryType); 
	

}

void AuthSecuDlg::AuthSecuDlg_OnSelectEncryptType(int id)
{
	UpdateData(TRUE);

	m_nEncryType = (NDIS_802_11_ENCRYPTION_STATUS)id;
	AuthSecuDlg_ComboBox_EncryptType->setCurrentItem( m_nEncryType );
	
		
	// Open System and NON_WEP
	if(m_nAuthenType == 0 && m_nEncryType == 0) // ENCRY_TYPE_OFF
	{
		AuthSecuDlg_LineEdit_PSK->setEnabled(FALSE);
		
		DRAWWEPKEYSETTING(FALSE);
	}
	// Use WEP
	else if(m_nAuthenType == 0 || m_nAuthenType == 1)
	{
		AuthSecuDlg_LineEdit_PSK->setEnabled(FALSE);
			
//		if (m_b8021X && m_wpaInfo.enumAuthenProtocol != Md5)
//			DRAWWEPKEYSETTING(FALSE);
//		else
			DRAWWEPKEYSETTING(TRUE);
	}
	// Use WPA-PSK WPA-NONE WPA2-PSK
	else if((m_enumInfrastructureMode == Ndis802_11IBSS && m_nAuthenType == 2) || m_nAuthenType == 4 || m_nAuthenType == 6)
	{
		AuthSecuDlg_LineEdit_PSK->setEnabled(TRUE);
				
		DRAWWEPKEYSETTING(FALSE);
	} 
	// WPA WPA2
	else if(m_enumInfrastructureMode == Ndis802_11Infrastructure && (m_nAuthenType == 3 || m_nAuthenType == 5))
	{
		AuthSecuDlg_LineEdit_PSK->setEnabled(FALSE);
				
		DRAWWEPKEYSETTING(FALSE);
	}	
  
}

void AuthSecuDlg::AuthSecuDlg_OnSelectKey1Type(int id)
{
	
	m_nKey1Type = id;
	
	UpdateData(TRUE);
	
#if 0	
    if (id==0)
    {//hex
        AuthSecuDlg_LineEdit_Key1Hex->show();
        AuthSecuDlg_LineEdit_Key1Ascii->hide();
    }
    else
    {//Ascii
        AuthSecuDlg_LineEdit_Key1Hex->hide();
        AuthSecuDlg_LineEdit_Key1Ascii->show();
    }
#endif    
}

void AuthSecuDlg::AuthSecuDlg_OnSelectKey2Type(int id)
{
	m_nKey2Type = id;
	
	UpdateData(TRUE);
	
#if 0	
    if (id==0)
    {//hex
        AuthSecuDlg_LineEdit_Key2Hex->show();
        AuthSecuDlg_LineEdit_Key2Ascii->hide();
    }
    else
    {//Ascii
        AuthSecuDlg_LineEdit_Key2Hex->hide();
        AuthSecuDlg_LineEdit_Key2Ascii->show();
    }
#endif
}

void AuthSecuDlg::AuthSecuDlg_OnSelectKey3Type(int id)
{
	m_nKey3Type = id;
	
	UpdateData(TRUE);
	
#if 0	
    if (id==0)
    {//hex
        AuthSecuDlg_LineEdit_Key3Hex->show();
        AuthSecuDlg_LineEdit_Key3Ascii->hide();
    }
    else
    {//Ascii
        AuthSecuDlg_LineEdit_Key3Hex->hide();
        AuthSecuDlg_LineEdit_Key3Ascii->show();
    }
#endif
}

void AuthSecuDlg::AuthSecuDlg_OnSelectKey4Type(int id)
{
	m_nKey4Type = id;
	
	UpdateData(TRUE);
	
#if 0	
    if (id==0)
    {//hex
        AuthSecuDlg_LineEdit_Key4Hex->show();
        AuthSecuDlg_LineEdit_Key4Ascii->hide();
    }
    else
    {//Ascii
        AuthSecuDlg_LineEdit_Key4Hex->hide();
        AuthSecuDlg_LineEdit_Key4Ascii->show();
    }
#endif
}

bool AuthSecuDlg::AuthSecuDlg_IsClickOk()
{
    return (m_isClickOk);
}

VOID AuthSecuDlg::DRAWWEPKEYSETTING(BOOL enablekey)
{
	if (enablekey == FALSE)
	{		
		AuthSecuDlg_LineEdit_Key1Ascii->setEnabled(FALSE);
		AuthSecuDlg_LineEdit_Key2Ascii->setEnabled(FALSE);
		AuthSecuDlg_LineEdit_Key3Ascii->setEnabled(FALSE);
		AuthSecuDlg_LineEdit_Key4Ascii->setEnabled(FALSE);	

		AuthSecuDlg_LineEdit_Key1Hex->setEnabled(FALSE);
		AuthSecuDlg_LineEdit_Key2Hex->setEnabled(FALSE);
		AuthSecuDlg_LineEdit_Key3Hex->setEnabled(FALSE);
		AuthSecuDlg_LineEdit_Key4Hex->setEnabled(FALSE);	

		AuthSecuDlg_ComboBox_KeyType1->setEnabled(FALSE);
		AuthSecuDlg_ComboBox_KeyType2->setEnabled(FALSE);
		AuthSecuDlg_ComboBox_KeyType3->setEnabled(FALSE);
		AuthSecuDlg_ComboBox_KeyType4->setEnabled(FALSE);	

		AuthSecuDlg_RadioButton_Key1->setEnabled(FALSE);
		AuthSecuDlg_RadioButton_Key2->setEnabled(FALSE);
		AuthSecuDlg_RadioButton_Key3->setEnabled(FALSE);
		AuthSecuDlg_RadioButton_Key4->setEnabled(FALSE);
		
	}
	else
	{
		AuthSecuDlg_LineEdit_Key1Ascii->setEnabled(TRUE);
		AuthSecuDlg_LineEdit_Key2Ascii->setEnabled(TRUE);
		AuthSecuDlg_LineEdit_Key3Ascii->setEnabled(TRUE);
		AuthSecuDlg_LineEdit_Key4Ascii->setEnabled(TRUE);	

		AuthSecuDlg_LineEdit_Key1Hex->setEnabled(TRUE);
		AuthSecuDlg_LineEdit_Key2Hex->setEnabled(TRUE);
		AuthSecuDlg_LineEdit_Key3Hex->setEnabled(TRUE);
		AuthSecuDlg_LineEdit_Key4Hex->setEnabled(TRUE);	

		AuthSecuDlg_ComboBox_KeyType1->setEnabled(TRUE);
		AuthSecuDlg_ComboBox_KeyType2->setEnabled(TRUE);
		AuthSecuDlg_ComboBox_KeyType3->setEnabled(TRUE);
		AuthSecuDlg_ComboBox_KeyType4->setEnabled(TRUE);	

		AuthSecuDlg_RadioButton_Key1->setEnabled(TRUE);
		AuthSecuDlg_RadioButton_Key2->setEnabled(TRUE);
		AuthSecuDlg_RadioButton_Key3->setEnabled(TRUE);
		AuthSecuDlg_RadioButton_Key4->setEnabled(TRUE);
	}
}

BOOL AuthSecuDlg::UpdateData(BOOL bSaveAndValidate)
{
	QString	str;
	if(bSaveAndValidate)
	{
//		m_nAuthenType = m_comboAuthenType.GetCurSel();
//		m_nEncryType = m_comboEncryType.GetCurSel();

		if(m_enumInfrastructureMode == Ndis802_11Infrastructure && m_nAuthenType == 2) // LEAP
		{
			AuthSecuDlg_PushButton_Enable802Dot1X->hide();
			AuthSecuDlg_PushButton_802Dot1XSetting->hide(); 
			     
			AuthSecuDlg_Label_PSK->hide();
			AuthSecuDlg_Label_EncryptType->hide();
			AuthSecuDlg_ComboBox_EncryptType->hide();
			AuthSecuDlg_LineEdit_PSK->hide();
			AuthSecuDlg_ButtonGroup_Key->hide();
			AuthSecuDlg_RadioButton_Key1->hide();
			AuthSecuDlg_RadioButton_Key2->hide();
			AuthSecuDlg_RadioButton_Key3->hide();
			AuthSecuDlg_RadioButton_Key4->hide();
			AuthSecuDlg_ComboBox_KeyType1->hide();
			AuthSecuDlg_ComboBox_KeyType2->hide();
			AuthSecuDlg_ComboBox_KeyType3->hide();
			AuthSecuDlg_ComboBox_KeyType4->hide();
			AuthSecuDlg_LineEdit_Key1Hex->hide();
			AuthSecuDlg_LineEdit_Key1Ascii->hide();
			AuthSecuDlg_LineEdit_Key2Hex->hide();
			AuthSecuDlg_LineEdit_Key2Ascii->hide();
			AuthSecuDlg_LineEdit_Key3Hex->hide();
			AuthSecuDlg_LineEdit_Key3Ascii->hide();
			AuthSecuDlg_LineEdit_Key4Hex->hide();
			AuthSecuDlg_LineEdit_Key4Ascii->hide();

		
			AuthSecuDlg_Label_LeapId->show();
			AuthSecuDlg_Label_LeapPassword->show();       
			AuthSecuDlg_LineEdit_LeapId->show();
			AuthSecuDlg_LineEdit_LeapPassword->show();
			
			if(m_bCCX20)
			{
				AuthSecuDlg_RadioButton_LeapWep->show();
				AuthSecuDlg_RadioButton_LeapTkip->show();
			}
			else
			{
				AuthSecuDlg_RadioButton_LeapWep->hide();
				AuthSecuDlg_RadioButton_LeapTkip->hide();
			}
		}
		else
		{
//			AuthSecuDlg_PushButton_802Dot1XSetting->show();
			AuthSecuDlg_PushButton_Enable802Dot1X->hide();
			AuthSecuDlg_PushButton_802Dot1XSetting->hide(); 
				
			AuthSecuDlg_Label_PSK->show();
			AuthSecuDlg_Label_EncryptType->show();
			AuthSecuDlg_ComboBox_EncryptType->show();
			AuthSecuDlg_LineEdit_PSK->show();
			AuthSecuDlg_ButtonGroup_Key->show();
			AuthSecuDlg_RadioButton_Key1->show();
			AuthSecuDlg_RadioButton_Key2->show();
			AuthSecuDlg_RadioButton_Key3->show();
			AuthSecuDlg_RadioButton_Key4->show();
			AuthSecuDlg_ComboBox_KeyType1->show();
			AuthSecuDlg_ComboBox_KeyType2->show();
			AuthSecuDlg_ComboBox_KeyType3->show();
			AuthSecuDlg_ComboBox_KeyType4->show();
			AuthSecuDlg_LineEdit_Key1Hex->show();
			AuthSecuDlg_LineEdit_Key1Ascii->show();
			AuthSecuDlg_LineEdit_Key2Hex->show();
			AuthSecuDlg_LineEdit_Key2Ascii->show();
			AuthSecuDlg_LineEdit_Key3Hex->show();
			AuthSecuDlg_LineEdit_Key3Ascii->show();
			AuthSecuDlg_LineEdit_Key4Hex->show();
			AuthSecuDlg_LineEdit_Key4Ascii->show();

		
			AuthSecuDlg_Label_LeapId->hide();
			AuthSecuDlg_Label_LeapPassword->hide();       
			AuthSecuDlg_LineEdit_LeapId->hide();
			AuthSecuDlg_LineEdit_LeapPassword->hide();
			
			if(m_enumInfrastructureMode == Ndis802_11Infrastructure && (m_nAuthenType == 0 || m_nAuthenType == 1 ||m_nAuthenType == 3 ||m_nAuthenType == 5) && G_bWpaCapable)
				;//AuthSecuDlg_PushButton_802Dot1XSetting->show();
			else
				AuthSecuDlg_PushButton_802Dot1XSetting->hide();

			if(m_nKey1Type == WEP_KEY_TYPE_ASCII)
			{
				AuthSecuDlg_LineEdit_Key1Hex->hide();
				AuthSecuDlg_LineEdit_Key1Ascii->show();
			}
			else if(m_nKey1Type == WEP_KEY_TYPE_HEX)		
			{
				AuthSecuDlg_LineEdit_Key1Hex->show();
				AuthSecuDlg_LineEdit_Key1Ascii->hide();
			}
			else
				;//ASSERT(FALSE);

			if(m_nKey2Type == WEP_KEY_TYPE_ASCII)
			{
				AuthSecuDlg_LineEdit_Key2Hex->hide();
				AuthSecuDlg_LineEdit_Key2Ascii->show();
			}
			else if(m_nKey2Type == WEP_KEY_TYPE_HEX)		
			{
				AuthSecuDlg_LineEdit_Key2Hex->show();
				AuthSecuDlg_LineEdit_Key2Ascii->hide();
			}
			else
				;//ASSERT(FALSE);
				
			if(m_nKey3Type == WEP_KEY_TYPE_ASCII)
			{
				AuthSecuDlg_LineEdit_Key3Hex->hide();
				AuthSecuDlg_LineEdit_Key3Ascii->show();
			}
			else if(m_nKey3Type == WEP_KEY_TYPE_HEX)		
			{
				AuthSecuDlg_LineEdit_Key3Hex->show();
				AuthSecuDlg_LineEdit_Key3Ascii->hide();
			}
			else
				;//ASSERT(FALSE);
				
			if(m_nKey4Type == WEP_KEY_TYPE_ASCII)
			{
				AuthSecuDlg_LineEdit_Key4Hex->hide();
				AuthSecuDlg_LineEdit_Key4Ascii->show();
			}
			else if(m_nKey4Type == WEP_KEY_TYPE_HEX)
			{
				AuthSecuDlg_LineEdit_Key4Hex->show();
				AuthSecuDlg_LineEdit_Key4Ascii->hide();
			}
			else
				;//ASSERT(FALSE);
				
			AuthSecuDlg_Label_LeapId->hide();
			AuthSecuDlg_Label_LeapPassword->hide();       
			AuthSecuDlg_LineEdit_LeapId->hide();
			AuthSecuDlg_LineEdit_LeapPassword->hide();
			
			AuthSecuDlg_RadioButton_LeapWep->hide();
			AuthSecuDlg_RadioButton_LeapTkip->hide();
		}
	}
	else
	{

		if(m_b8021X)
		{
			AuthSecuDlg_PushButton_Enable802Dot1X->setText(IDS_DISABLE1X);
			AuthSecuDlg_PushButton_802Dot1XSetting->setEnabled(TRUE);
		}
		else
		{
			AuthSecuDlg_PushButton_Enable802Dot1X->setText(IDS_ENABLE1X);
			AuthSecuDlg_PushButton_802Dot1XSetting->setEnabled(FALSE);
		}

/*		
		int nAuthenType = m_nAuthenType;

		if(nAuthenType >= m_comboAuthenType.GetCount())
			nAuthenType = m_nAuthenType = 0;

		m_comboAuthenType.SetCurSel(nAuthenType);

		if(m_nEncryType >= m_comboEncryType.GetCount() || m_nEncryType < 0)
			m_nEncryType = 0;

		m_comboEncryType.SetCurSel(m_nEncryType);
*/
	}

	return TRUE;
}

void AuthSecuDlg::OnEnableDisable802Dot1X()
{
	UpdateData(TRUE);
	m_b8021X = !m_b8021X;
	
//	if (m_b8021X && m_wpaInfo.enumAuthenProtocol != Md5)
//		DRAWWEPKEYSETTING(FALSE);
//	else if(m_nAuthenType == 1 || m_nEncryType == 1)
//		DRAWWEPKEYSETTING(TRUE);
	
	UpdateData(FALSE);
}

void AuthSecuDlg::On802Dot1XSetting()
{

}

void AuthSecuDlg::OnLeapWep()
{
    AuthSecuDlg_RadioButton_LeapWep->setChecked(TRUE);
    AuthSecuDlg_RadioButton_LeapTkip->setChecked(FALSE);		

    m_nLeapEncryType = 0;
}


void AuthSecuDlg::OnLeapTkip()
{
    AuthSecuDlg_RadioButton_LeapTkip->setChecked(TRUE);		
    AuthSecuDlg_RadioButton_LeapWep->setChecked(FALSE);

    m_nLeapEncryType = 1;	
}

