#ifndef AUTHSECUDLG_H
#define AUTHSECUDLG_H

#include <qvariant.h>
#include <qdialog.h>
#include "rt_tool.h"
#include "StructDef.h"
#include "qhexvalidator.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QComboBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QRadioButton;
class QHexValidator;

class AuthSecuDlg : public QDialog
{ 
    Q_OBJECT

public:
    AuthSecuDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~AuthSecuDlg();

    QLabel*                     AuthSecuDlg_Label_AuthType;
    QLabel*                     AuthSecuDlg_Label_EncryptType;
    
    QPushButton* AuthSecuDlg_PushButton_Enable802Dot1X;
    QPushButton* AuthSecuDlg_PushButton_802Dot1XSetting;      
    QLabel*                     AuthSecuDlg_Label_PSK;
    QComboBox*                  AuthSecuDlg_ComboBox_AuthType;
    QComboBox*                  AuthSecuDlg_ComboBox_EncryptType;
    QLineEdit*                  AuthSecuDlg_LineEdit_PSK;
    QButtonGroup*               AuthSecuDlg_ButtonGroup_Key;
    QButtonGroup*               AuthSecuDlg_ButtonGroup_Leap;    
    QRadioButton*               AuthSecuDlg_RadioButton_Key1;
    QRadioButton*               AuthSecuDlg_RadioButton_Key2;
    QRadioButton*               AuthSecuDlg_RadioButton_Key3;
    QRadioButton*               AuthSecuDlg_RadioButton_Key4;
    QComboBox*                  AuthSecuDlg_ComboBox_KeyType1;
    QComboBox*                  AuthSecuDlg_ComboBox_KeyType2;
    QComboBox*                  AuthSecuDlg_ComboBox_KeyType3;
    QComboBox*                  AuthSecuDlg_ComboBox_KeyType4;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key1Hex;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key1Ascii;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key2Hex;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key2Ascii;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key3Hex;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key3Ascii;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key4Hex;
    QLineEdit*                  AuthSecuDlg_LineEdit_Key4Ascii;
    QPushButton*                AuthSecuDlg_PushButton_OK;
    QPushButton*                AuthSecuDlg_PushButton_Cancel;
    
    QLabel*                     AuthSecuDlg_Label_LeapId;
    QLabel*                     AuthSecuDlg_Label_LeapPassword;        
    QLineEdit*                  AuthSecuDlg_LineEdit_LeapId;
    QLineEdit*                  AuthSecuDlg_LineEdit_LeapPassword;
    QRadioButton*               AuthSecuDlg_RadioButton_LeapWep;
    QRadioButton*               AuthSecuDlg_RadioButton_LeapTkip;
    
    //---------------------------------------------------------------    

    QHexValidator*              m_hexValidator;
    bool                        m_isClickOk;

    //---------------------------------------------------------------

    NDIS_802_11_NETWORK_INFRASTRUCTURE m_enumInfrastructureMode;          
    NDIS_802_11_AUTHENTICATION_MODE m_nAuthenType;
    NDIS_802_11_ENCRYPTION_STATUS m_nEncryType;

    BOOL	m_b8021X;
        
    WPA_INFO m_wpaInfo;
    BOOL m_bCCX20;
    BOOL m_bLeapCCKM;
       
    //---------------------------
	int		m_nKeyIndex;
	//---    
	int		m_nKey1Type;
	int		m_nKey2Type;
	int		m_nKey3Type;
	int		m_nKey4Type;
	//---	
	UCHAR m_Key1Len;
	UCHAR m_Key2Len;
	UCHAR m_Key3Len;
	UCHAR m_Key4Len;
	//---	          
	UCHAR m_chKey1Material[14];
	UCHAR m_chKey2Material[14];
	UCHAR m_chKey3Material[14];
	UCHAR m_chKey4Material[14];
	//---		
	int		m_nLeapEncryType;	
    //---------------------------
    	
    //---------------------------------------------------------------
            
    bool AuthSecuDlg_IsClickOk();
    int AuthSecuDlg_GetWepKeyType(int index);
    QString AuthSecuDlg_GetWepKeyString(int index);
    QString AuthSecuDlg_GetPSKString();
    NDIS_802_11_AUTHENTICATION_MODE AuthSecuDlg_GetAuthticationMode();
    NDIS_802_11_ENCRYPTION_STATUS AuthSecuDlg_GetEncryptType();
    void AuthSecuDlg_SetAuthModeAndEncryType(NDIS_802_11_NETWORK_INFRASTRUCTURE enumInfrastructureMode, NDIS_802_11_AUTHENTICATION_MODE nAuthenType, NDIS_802_11_ENCRYPTION_STATUS nEncryType);
    int AuthSecuDlg_GetDefaultKeyId();
    void AuthSecuDlg_SetDefaultKeyId(int keyId);
    void AuthSecuDlg_SetKeyTypeAndKeyString(int keyIndex, int keyType, char *keyString);
    //---
    void InitCombosInDialog();
    VOID DRAWWEPKEYSETTING(BOOL enablekey);
    BOOL UpdateData(BOOL bSaveAndValidate);
	
public slots:
    virtual void Do_NotThing() { };
    virtual void OnOK();
    virtual void OnCancel();
    virtual void AuthSecuDlg_OnSelectAuthenType(int id);
    virtual void AuthSecuDlg_OnSelectEncryptType(int id);
    virtual void AuthSecuDlg_OnSelectKey1Type(int id);
    virtual void AuthSecuDlg_OnSelectKey2Type(int id);
    virtual void AuthSecuDlg_OnSelectKey3Type(int id);
    virtual void AuthSecuDlg_OnSelectKey4Type(int id);
    virtual void OnEnableDisable802Dot1X();
    virtual void On802Dot1XSetting();	
    virtual void OnLeapWep();	
    virtual void OnLeapTkip();		
};

#endif // AUTHSECUDLG_H
